2015-07-28  Benjamin Poulain  <bpoulain@apple.com>

        Speed up StringBuilder::appendQuotedJSONString()
        https://bugs.webkit.org/show_bug.cgi?id=147352

        Reviewed by Andreas Kling.

        * wtf/text/StringBuilder.cpp:
        (WTF::appendQuotedJSONStringInternal):
        The cases '"' and '\\' are not that uncommon, and they can easily
        be handled in the original branch testing for them.

        This is about 2.5% better on the JSON.stringify test.

2015-07-27  Alex Christensen  <achristensen@webkit.org>

        Progress towards building AppleWin with CMake
        https://bugs.webkit.org/show_bug.cgi?id=147325

        Reviewed by Martin Robinson.

        * wtf/PlatformWin.cmake:
        Link with CoreFoundation.lib.

2015-07-25  Carlos Alberto Lopez Perez  <clopez@igalia.com>

        REGRESSION (bmalloc): WebKit performance tests don't report memory stats.
        https://bugs.webkit.org/show_bug.cgi?id=141247

        Reviewed by Geoffrey Garen.

        Meanwhile a better way of getting memory stats with bmalloc is not found
        (see bug 136592), we can report as memory stats the resident set size
        information that the operating system provides to us.

        This at least should be good enough to get back the memory stats on the
        performance tests and being able to track down memory usage regressions
        at https://perf.webkit.org

        * wtf/FastMalloc.cpp:
        (WTF::fastMallocStatistics): Report maxrss data as committedVMBytes.

2015-07-24  Csaba Osztrogonác  <ossy@webkit.org>

        Remove the unused GCC workaround - std::is_trivially_destructible
        https://bugs.webkit.org/show_bug.cgi?id=147226

        Reviewed by Darin Adler.

        * wtf/StdLibExtras.h:

2015-07-23  Alex Christensen  <achristensen@webkit.org>

        Remove compile and runtime flags for promises.
        https://bugs.webkit.org/show_bug.cgi?id=147244

        Reviewed by Yusuke Suzuki.

        * wtf/FeatureDefines.h:

2015-07-22  Sukolsak Sakshuwong  <sukolsak@gmail.com>

        Add ENABLE_WEBASSEMBLY feature flag for WebAssembly
        https://bugs.webkit.org/show_bug.cgi?id=147212

        Reviewed by Filip Pizlo.

        * wtf/FeatureDefines.h:

2015-07-22  Filip Pizlo  <fpizlo@apple.com>

        Introduce release assert for using threads before threading is initialized
        https://bugs.webkit.org/show_bug.cgi?id=147200

        Reviewed by Michael Saboff.
        
        This will help bugs where you use createThread() before calling initializeThreading().

        * wtf/ThreadIdentifierDataPthreads.cpp:
        (WTF::ThreadIdentifierData::initialize):

2015-07-21  Daniel Bates  <dabates@apple.com>

        WTFCrash() in WebKit::WebProcess::networkConnection()
        https://bugs.webkit.org/show_bug.cgi?id=147112
        <rdar://problem/18477459>

        Reviewed by Gavin Barraclough.

        Add explicit boolean conversion function and remove overload of operator! to support
        checking whether an activity token is valid more directly than using the overloaded operator!.

        * wtf/RefCounter.h:
        (WTF::RefCounter::Token::operator bool): Added.
        (WTF::RefCounter::Token::operator!): Deleted.

2015-07-20  Mark Lam  <mark.lam@apple.com>

        Rollout r187020 and r187021: breaks JSC API tests on debug builds.
        https://bugs.webkit.org/show_bug.cgi?id=147110

        * wtf/WTFThreadData.cpp:
        (WTF::WTFThreadData::WTFThreadData):
        * wtf/WTFThreadData.h:
        (WTF::WTFThreadData::stack):

2015-07-20  Alex Christensen  <achristensen@webkit.org>

        Resurrect CMake build on Windows.
        https://bugs.webkit.org/show_bug.cgi?id=147083

        Reviewed by Gyuyoung Kim.

        * wtf/PlatformWin.cmake:

2015-07-20  Per Arne Vollan  <peavo@outlook.com>

        JavaScriptCore performance is very bad on Windows
        https://bugs.webkit.org/show_bug.cgi?id=146448

        Reviewed by Mark Lam.

        Updating the stack bounds is time consuming.
        Only update the stack bounds when a new fiber is running.

        * wtf/WTFThreadData.cpp:
        (WTF::WTFThreadData::WTFThreadData):
        * wtf/WTFThreadData.h:
        (WTF::WTFThreadData::stack):

2015-07-20  Julien Brianceau  <julien.brianceau@gmail.com>

        Use isnan from std namespace in Stopwatch.h.
        https://bugs.webkit.org/show_bug.cgi?id=146911

        Reviewed by Žan Doberšek.

        * wtf/Stopwatch.h:
        (WTF::Stopwatch::isActive):
        (WTF::Stopwatch::start):
        (WTF::Stopwatch::stop):
        (WTF::Stopwatch::elapsedTime):

2015-07-16  Benjamin Poulain  <bpoulain@apple.com>

        [Content extensions] Combine suffixes when generating NFAs
        https://bugs.webkit.org/show_bug.cgi?id=146961

        Reviewed by Alex Christensen.

        * wtf/Vector.h:
        (WTF::minCapacity>::Vector):
        (WTF::=):
        Copying a vector with a different inline capacity was broken due to
        the addition of MinimumCapacity.

        This feature was needed by this patch so I fixed WTF.

2015-07-15  Anders Carlsson  <andersca@apple.com>

        Make JavaScriptCore SPI headers used by WebCore SPI headers self-contained
        https://bugs.webkit.org/show_bug.cgi?id=146978

        Reviewed by Dan Bernstein.

        * wtf/ExportMacros.h:

2015-07-14  Anders Carlsson  <andersca@apple.com>

        Assertions.h should include ExportMacros.h
        https://bugs.webkit.org/show_bug.cgi?id=146948

        Reviewed by Tim Horton.

        * wtf/Assertions.h:

2015-07-11  Joseph Pecoraro  <pecoraro@apple.com>

        Unreviewed build fix, restrict APP_LINKS to just iOS.

        * wtf/Platform.h:

2015-07-09  Tim Horton  <timothy_horton@apple.com>

        Use CoreAnimation fences instead of synchronous IPC to synchronize resize
        https://bugs.webkit.org/show_bug.cgi?id=146294
        <rdar://problem/21090193>

        Reviewed by Anders Carlsson.

        * wtf/Platform.h:
        Add HAVE(COREANIMATION_FENCES)

2015-07-04  Chris Dumez  <cdumez@apple.com>

        Drop RefPtr::clear() method
        https://bugs.webkit.org/show_bug.cgi?id=146556

        Reviewed by Brady Eidson.

        Drop RefPtr::clear() method in favor of "= nullptr;" pattern.
        Also made the "= nullptr;" pattern as efficient as clear()
        by providing a operator=(nullptr_t) overload. Local micro-
        benchmarking showed that "= nullptr;" used to be ~1.7% slower
        than clear().

2015-07-03  Dan Bernstein  <mitz@apple.com>

        [Xcode] Update some build settings as recommended by Xcode 7
        https://bugs.webkit.org/show_bug.cgi?id=146597

        Reviewed by Sam Weinig.

        * Configurations/Base.xcconfig: Enabled CLANG_WARN_UNREACHABLE_CODE and
        GCC_NO_COMMON_BLOCKS. Removed GCC_MODEL_TUNING.

        * WTF.xcodeproj/project.pbxproj: Updated LastUpgradeCheck.

2015-07-01  Alex Christensen  <achristensen@webkit.org>

        Re-enable WebGL on WinCairo
        https://bugs.webkit.org/show_bug.cgi?id=146537

        Reviewed by Csaba Osztrogonác.

        * wtf/FeatureDefines.h:
        Enable WebGL on WinCairo again.

2015-07-01  Alex Christensen  <achristensen@webkit.org>

        Ignore Visual Studio warning in SegmentedVector
        https://bugs.webkit.org/show_bug.cgi?id=146514

        Reviewed by Andreas Kling.

        * wtf/SegmentedVector.h:
        (WTF::SegmentedVector::deleteAllSegments):
        Use pragmas to ignore the 0 element array warning.

2015-07-01  Dean Jackson  <dino@apple.com>

        Disable the experimental WebGL2 implementation
        https://bugs.webkit.org/show_bug.cgi?id=146526
        <rdar://problem/21641235>

        Reviewed by Myles Maxfield.

        Add (and disable) an ENABLE_WEBGL2 flag.

        * wtf/FeatureDefines.h:

2015-06-30  Alex Christensen  <achristensen@webkit.org>

        [Win] Unreviewed build fix after r186169.

        * wtf/FeatureDefines.h:
        Temporarily disable WebGL on WinCairo. It was already temporarily disabled on AppleWin.

2015-06-30  Andy VanWagoner  <thetalecrafter@gmail.com>

        Implement ECMAScript Internationalization API
        https://bugs.webkit.org/show_bug.cgi?id=90906

        Reviewed by Benjamin Poulain.

        * wtf/FeatureDefines.h: add ENABLE_INTL flag

2015-06-30  Keith Miller  <keith_miller@apple.com>

        Errors in read() are not handled in WTF::cryptographicallyRandomValuesFromOS.
        https://bugs.webkit.org/show_bug.cgi?id=146473

        Reviewed by Filip Pizlo.

        We were not checking if errors occurred in WTF::cryptographicallyRandomValuesFromOS.
        We now buffer the data until enough bits of entropy exist to fill the buffer
        rather than crash. Additionally, added two crash functions so we can distinguish
        between the two reasons why we crashed in traces.

        * wtf/OSRandomSource.cpp:
        (WTF::crashUnableToOpenFD):
        (WTF::crashUnableToReadFromFD):
        (WTF::cryptographicallyRandomValuesFromOS):

2015-06-29  Dean Jackson  <dino@apple.com>

        Temporarily disable PICTURE_SIZES
        https://bugs.webkit.org/show_bug.cgi?id=146435
        <rdar://problem/21087013>

        Reviewed by Tim Horton.

        Temporarily disable PICTURE_SIZES because it causes problems with out
        of date <picture> polyfills.

        * wtf/FeatureDefines.h:

2015-06-26  Antti Koivisto  <antti@apple.com>

        Network process hangs fetching disk cache entries
        https://bugs.webkit.org/show_bug.cgi?id=146348
        <rdar://problem/21528072>

        Reviewed by Anders Carlsson.

        RunLoop::dispatch may deadlock if invoked with std::function that captures an object that calls RunLoop::dispatch in destructor.

        * wtf/RunLoop.cpp:
        (WTF::RunLoop::performWork):

            Don't reuse std::function variable in loop. We may end up destroying previously held std::function in assignment
            while holding the runloop mutex. With this change std::function is always destroyed with mutex unlocked.

2015-06-24  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r185906.
        https://bugs.webkit.org/show_bug.cgi?id=146276

        MSVC doesn't yet provide a const-qualified std::array<T,
        N>::size(), failing to compile the static_assert (Requested by
        zdobersek on #webkit).

        Reverted changeset:

        "Improve the source code generated by make_names.pl"
        https://bugs.webkit.org/show_bug.cgi?id=146208
        http://trac.webkit.org/changeset/185906

2015-06-24  Zan Dobersek  <zdobersek@igalia.com>

        Improve the source code generated by make_names.pl
        https://bugs.webkit.org/show_bug.cgi?id=146208

        Reviewed by Darin Adler.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::assertHashIsCorrect): Make this method const-qualified.

2015-06-22  Darin Adler  <darin@apple.com>

        Make Array.join work directly on substrings without reifying them
        https://bugs.webkit.org/show_bug.cgi?id=146191

        Reviewed by Andreas Kling.

        * wtf/Vector.h: Added an overload of uncheckedAppend like the one we added
        a while back, a non-template function that forwards through to the function
        template. This lets us call uncheckedAppend on an argument list and have it
        properly convert it to the Vector's element type.

        * wtf/text/StringView.h:
        (WTF::StringView::getCharactersWithUpconvert): Changed to not use memcpy;
        saw some indication the hand-written loop was faster when profiling. Also
        use m_length directly when we know we are dealing with an 8-bit string,
        since the masking that the index function does is not needed in that case.
        (WTF::StringView::UpconvertedCharacters::UpconvertedCharacters): Ditto.
        (WTF::StringView::toString): Ditto.
        (WTF::StringView::toFloat): Ditto.
        (WTF::StringView::toInt): Ditto.
        (WTF::StringView::toStringWithoutCopying): Ditto.
        (WTF::StringView::find): Ditto.

2015-06-22  YunQiang Su  <wzssyqa@gmail.com>

        [WTF] Platform.h: use _ABI64 instead of _MIPS_SIM_ABI64 to determine MIPS N64
        https://bugs.webkit.org/show_bug.cgi?id=145113

        Reviewed by Csaba Osztrogonác.

        * wtf/Platform.h:

2015-06-22  Anders Carlsson  <andersca@apple.com>

        Fix build.

        * wtf/threads/BinarySemaphore.cpp:

2015-06-22  Anders Carlsson  <andersca@apple.com>

        Get rid of the Windows specific BinarySemaphore implementation
        https://bugs.webkit.org/show_bug.cgi?id=146216

        Reviewed by Andreas Kling.

        The fact that the Windows implementation uses a HEVENT internally was only useful
        to the Windows port of WebKit2; we can get rid of it now.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * wtf/threads/BinarySemaphore.h:
        (WTF::BinarySemaphore::event): Deleted.
        * wtf/threads/win/BinarySemaphoreWin.cpp: Removed.
        (WTF::BinarySemaphore::BinarySemaphore): Deleted.
        (WTF::BinarySemaphore::~BinarySemaphore): Deleted.
        (WTF::BinarySemaphore::signal): Deleted.
        (WTF::BinarySemaphore::wait): Deleted.

2015-06-21  Gavin Barraclough  <barraclough@apple.com>

        Page load performance regression due to bugs.webkit.org/show_bug.cgi?id=145542
        https://bugs.webkit.org/show_bug.cgi?id=146198

        Unreviewed rollout.

        * wtf/glib/GUniquePtr.h:

2015-06-20  Michael Catanzaro  <mcatanzaro@igalia.com>

        [EFL][GTK] Define GLIB_VERSION_MIN_REQUIRED and require glib 2.36 for GTK
        https://bugs.webkit.org/show_bug.cgi?id=146181

        Reviewed by Martin Robinson.

        Define GLIB_VERSION_MIN_REQUIRED to avoid deprecation warnings.

        * wtf/Platform.h:

2015-06-19  Michael Catanzaro  <mcatanzaro@igalia.com>

        [SOUP] Define SOUP_VERSION_MIN_REQUIRED
        https://bugs.webkit.org/show_bug.cgi?id=146165

        Reviewed by Martin Robinson.

        Define SOUP_VERSION_MIN_REQUIRED to avoid deprecation warnings.

        * wtf/Platform.h:

2015-06-19  Mark Lam  <mark.lam@apple.com>

        Gardening: build fixes for GTK and EFL for CheckedArithmetic change.

        Not reviewed.

        * wtf/CheckedArithmetic.h:
        (WTF::Checked::operator<):
        (WTF::Checked::operator<=):
        (WTF::Checked::operator>):
        (WTF::Checked::operator>=):

2015-06-19  Mark Lam  <mark.lam@apple.com>

        CheckedArithmetic's operator bool() and operator==() is broken.
        https://bugs.webkit.org/show_bug.cgi?id=146129

        Reviewed by Geoffrey Garen and Oliver Hunt.

        The existing operator UnspecifiedBoolType*() in CheckedArithmetic is erroneously
        allowing the Checked value to be implicitly casted into pointer types.  This is
        because it is doing a reinterpret_cast<UnspecifiedBoolType*>(1) whereas the idiom
        relies on the address of a member e.g. &Checked::m_value.  As a result,
        ImageBufferData::putData() was getting an implicit cast of a Checked value to
        (void*)1 and doing incorrect pointer comparisons on it.

        Also, 2 of CheckedArithmetic's operator==() will crash if used on an overflowed
        value, while a 3rd one does not.  The 3rd one should be consistent and also crash
        if used on an overflowed Checked value.

        In this fix, we replace operator UnspecifiedBoolType*() with an explicit operator
        bool().  We also add the missing operators <, <=, >, and >=.  That takes care of
        the comparisons in ImageBufferData::putData().

        * wtf/CheckedArithmetic.h:
        (WTF::CrashOnOverflow::overflowed):
        (WTF::CrashOnOverflow::crash):
        (WTF::RecordOverflow::crash):

        (WTF::Checked::operator!):
        (WTF::Checked::operator bool):
        (WTF::Checked::unsafeGet):
        - Don't call CRASH() directly.  Delegate to the handler.

        (WTF::Checked::operator==):
        - Should call the handler's crash() to be consistent with the other 2 versions of
          operator== which will crash in unsafeGet() if used on an overflowed Checked
          value.

        (WTF::Checked::operator<):
        (WTF::Checked::operator<=):
        (WTF::Checked::operator>):
        (WTF::Checked::operator>=):
        - Add missing operators.

        (WTF::Checked::operator UnspecifiedBoolType*): Deleted.

2015-06-19  Csaba Osztrogonác  <ossy@webkit.org>

        [WK2] Fix unused-private-field warning in WebProcess/Plugins/PluginView.<h|cpp>
        https://bugs.webkit.org/show_bug.cgi?id=145252

        Reviewed by Tim Horton.

        * wtf/FeatureDefines.h: Moved the definition of ENABLE_PRIMARY_SNAPSHOTTED_PLUGIN_HEURISTIC
        here from Source/WebKit2/WebProcess/WebPage/WebPage.h

2015-06-17  Andreas Kling  <akling@apple.com>

        SegmentedVector should waste less memory.
        <https://webkit.org/b/146069>

        Reviewed by Anders Carlsson.

        We were wasting sizeof(Vector) on every segment in SegmentVector.
        The segments were using inline capacity, and would never go beyond it,
        so all the size/capacity/out-of-line-buffer metadata was useless.

        Change the internal representation to Vector<T[SegmentSize]> instead.
        This saves 16 bytes per segment, so lower SegmentSize -> bigger savings!

        * wtf/SegmentedVector.h:
        (WTF::SegmentedVectorIterator::operator*):
        (WTF::SegmentedVectorIterator::operator->):
        (WTF::SegmentedVectorIterator::operator++):
        (WTF::SegmentedVectorIterator::operator==):
        (WTF::SegmentedVectorIterator::operator!=):
        (WTF::SegmentedVectorIterator::SegmentedVectorIterator):
        (WTF::SegmentedVector::at):
        (WTF::SegmentedVector::append):
        (WTF::SegmentedVector::removeLast):
        (WTF::SegmentedVector::grow):
        (WTF::SegmentedVector::begin):
        (WTF::SegmentedVector::end):
        (WTF::SegmentedVector::deleteAllSegments):
        (WTF::SegmentedVector::ensureSegmentsFor):
        (WTF::SegmentedVector::ensureSegment):
        (WTF::SegmentedVector::allocateSegment):
        (WTF::SegmentedVectorIterator::operator=): Deleted.
        (WTF::SegmentedVector::SegmentedVector): Deleted.

2015-06-16  Andreas Kling  <akling@apple.com>

        Remove unused template parameter InlineCapacity from SegmentedVector.
        <https://webkit.org/b/146044>

        Reviewed by Anders Carlsson.

        * wtf/SegmentedVector.h:
        (WTF::SegmentedVectorIterator::operator=):
        (WTF::SegmentedVectorIterator::SegmentedVectorIterator):
        (WTF::SegmentedVector::at):

2015-06-16  Mark Lam  <mark.lam@apple.com>

        Use NakedPtr<Exception>& to return exception results.
        https://bugs.webkit.org/show_bug.cgi?id=145870

        Reviewed by Anders Carlsson and Filip Pizlo.

        Introducing the NakedPtr class.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/NakedPtr.h: Added.
        (WTF::NakedPtr::NakedPtr):
        (WTF::NakedPtr::get):
        (WTF::NakedPtr::clear):
        (WTF::NakedPtr::operator*):
        (WTF::NakedPtr::operator->):
        (WTF::NakedPtr::operator T*):
        (WTF::NakedPtr::operator!):
        (WTF::NakedPtr::operator bool):
        (WTF::=):
        (WTF::NakedPtr<T>::swap):
        (WTF::swap):

2015-06-12  Zan Dobersek  <zdobersek@igalia.com>

        [GLib] Move files under Source/WTF/wtf/gobject to Source/WTF/wtf/glib
        https://bugs.webkit.org/show_bug.cgi?id=145799

        Reviewed by Carlos Garcia Campos.

        Move the GLib-specific files to the Source/WTF/wtf/glib/ directory.
        'gobject' wasn't the most appropriate name for the directory since
        GObject is a submodule of GLib, but a lot of the code there didn't
        have much to do with GObject specifically.

        Build rules for the moved files are also updated.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * wtf/Platform.h:
        * wtf/PlatformEfl.cmake:
        * wtf/PlatformGTK.cmake:
        * wtf/RunLoop.h:
        * wtf/WorkQueue.h:
        * wtf/glib/GLibUtilities.cpp: Renamed from Source/WTF/wtf/gobject/GlibUtilities.cpp.
        (getCurrentExecutablePath):
        * wtf/glib/GLibUtilities.h: Renamed from Source/WTF/wtf/gobject/GlibUtilities.h.
        * wtf/glib/GMainLoopSource.cpp: Renamed from Source/WTF/wtf/gobject/GMainLoopSource.cpp.
        (WTF::GMainLoopSource::create):
        (WTF::GMainLoopSource::GMainLoopSource):
        (WTF::GMainLoopSource::~GMainLoopSource):
        (WTF::GMainLoopSource::isScheduled):
        (WTF::GMainLoopSource::isActive):
        (WTF::GMainLoopSource::cancel):
        (WTF::GMainLoopSource::scheduleIdleSource):
        (WTF::GMainLoopSource::schedule):
        (WTF::GMainLoopSource::scheduleTimeoutSource):
        (WTF::GMainLoopSource::scheduleAfterDelay):
        (WTF::createMicrosecondsTimeoutSource):
        (WTF::GMainLoopSource::scheduleAndDeleteOnDestroy):
        (WTF::GMainLoopSource::scheduleAfterDelayAndDeleteOnDestroy):
        (WTF::GMainLoopSource::prepareVoidCallback):
        (WTF::GMainLoopSource::finishVoidCallback):
        (WTF::GMainLoopSource::voidCallback):
        (WTF::GMainLoopSource::prepareBoolCallback):
        (WTF::GMainLoopSource::finishBoolCallback):
        (WTF::GMainLoopSource::boolCallback):
        (WTF::GMainLoopSource::socketCallback):
        (WTF::GMainLoopSource::voidSourceCallback):
        (WTF::GMainLoopSource::boolSourceCallback):
        (WTF::GMainLoopSource::socketSourceCallback):
        (WTF::GMainLoopSource::Context::destroySource):
        * wtf/glib/GMainLoopSource.h: Renamed from Source/WTF/wtf/gobject/GMainLoopSource.h.
        (WTF::GMainLoopSource::Context::operator=):
        * wtf/glib/GMutexLocker.h: Renamed from Source/WTF/wtf/gobject/GMutexLocker.h.
        (WTF::MutexWrapper<GMutex>::lock):
        (WTF::MutexWrapper<GMutex>::unlock):
        (WTF::MutexWrapper<GRecMutex>::lock):
        (WTF::MutexWrapper<GRecMutex>::unlock):
        (WTF::GMutexLocker::GMutexLocker):
        (WTF::GMutexLocker::~GMutexLocker):
        (WTF::GMutexLocker::lock):
        (WTF::GMutexLocker::unlock):
        * wtf/glib/GRefPtr.cpp: Renamed from Source/WTF/wtf/gobject/GRefPtr.cpp.
        (WTF::refGPtr):
        (WTF::derefGPtr):
        * wtf/glib/GRefPtr.h: Renamed from Source/WTF/wtf/gobject/GRefPtr.h.
        (WTF::GRefPtr::GRefPtr):
        (WTF::GRefPtr::~GRefPtr):
        (WTF::GRefPtr::clear):
        (WTF::GRefPtr::outPtr):
        (WTF::GRefPtr::isHashTableDeletedValue):
        (WTF::GRefPtr::get):
        (WTF::GRefPtr::operator*):
        (WTF::GRefPtr::operator->):
        (WTF::GRefPtr::operator!):
        (WTF::GRefPtr::operator UnspecifiedBoolType):
        (WTF::GRefPtr::hashTableDeletedValue):
        (WTF::=):
        (WTF::GRefPtr<T>::swap):
        (WTF::swap):
        (WTF::operator==):
        (WTF::operator!=):
        (WTF::static_pointer_cast):
        (WTF::const_pointer_cast):
        (WTF::adoptGRef):
        (WTF::refGPtr):
        (WTF::derefGPtr):
        * wtf/glib/GThreadSafeMainLoopSource.cpp: Renamed from Source/WTF/wtf/gobject/GThreadSafeMainLoopSource.cpp.
        (WTF::GThreadSafeMainLoopSource::GThreadSafeMainLoopSource):
        (WTF::GThreadSafeMainLoopSource::~GThreadSafeMainLoopSource):
        (WTF::GThreadSafeMainLoopSource::cancel):
        (WTF::GThreadSafeMainLoopSource::schedule):
        (WTF::GThreadSafeMainLoopSource::scheduleAfterDelay):
        (WTF::GThreadSafeMainLoopSource::prepareVoidCallback):
        (WTF::GThreadSafeMainLoopSource::finishVoidCallback):
        (WTF::GThreadSafeMainLoopSource::voidCallback):
        (WTF::GThreadSafeMainLoopSource::prepareBoolCallback):
        (WTF::GThreadSafeMainLoopSource::finishBoolCallback):
        (WTF::GThreadSafeMainLoopSource::boolCallback):
        * wtf/glib/GThreadSafeMainLoopSource.h: Renamed from Source/WTF/wtf/gobject/GThreadSafeMainLoopSource.h.
        * wtf/glib/GTypedefs.h: Renamed from Source/WTF/wtf/gobject/GTypedefs.h.
        * wtf/glib/GUniquePtr.h: Renamed from Source/WTF/wtf/gobject/GUniquePtr.h.
        (WTF::GPtrDeleter::operator()):
        (WTF::GUniqueOutPtr::GUniqueOutPtr):
        (WTF::GUniqueOutPtr::~GUniqueOutPtr):
        (WTF::GUniqueOutPtr::outPtr):
        (WTF::GUniqueOutPtr::release):
        (WTF::GUniqueOutPtr::operator*):
        (WTF::GUniqueOutPtr::operator->):
        (WTF::GUniqueOutPtr::get):
        (WTF::GUniqueOutPtr::operator!):
        (WTF::GUniqueOutPtr::operator UnspecifiedBoolType):
        (WTF::GUniqueOutPtr::reset):
        * wtf/glib/MainThreadGLib.cpp:
        * wtf/gobject/GMainLoopSource.cpp:
        (WTF::GMainLoopSource::create): Deleted.
        (WTF::GMainLoopSource::GMainLoopSource): Deleted.
        (WTF::GMainLoopSource::~GMainLoopSource): Deleted.
        (WTF::GMainLoopSource::isScheduled): Deleted.
        (WTF::GMainLoopSource::isActive): Deleted.
        (WTF::GMainLoopSource::cancel): Deleted.
        (WTF::GMainLoopSource::scheduleIdleSource): Deleted.
        (WTF::GMainLoopSource::schedule): Deleted.
        (WTF::GMainLoopSource::scheduleTimeoutSource): Deleted.
        (WTF::GMainLoopSource::scheduleAfterDelay): Deleted.
        (WTF::createMicrosecondsTimeoutSource): Deleted.
        (WTF::GMainLoopSource::scheduleAndDeleteOnDestroy): Deleted.
        (WTF::GMainLoopSource::scheduleAfterDelayAndDeleteOnDestroy): Deleted.
        (WTF::GMainLoopSource::prepareVoidCallback): Deleted.
        (WTF::GMainLoopSource::finishVoidCallback): Deleted.
        (WTF::GMainLoopSource::voidCallback): Deleted.
        (WTF::GMainLoopSource::prepareBoolCallback): Deleted.
        (WTF::GMainLoopSource::finishBoolCallback): Deleted.
        (WTF::GMainLoopSource::boolCallback): Deleted.
        (WTF::GMainLoopSource::socketCallback): Deleted.
        (WTF::GMainLoopSource::voidSourceCallback): Deleted.
        (WTF::GMainLoopSource::boolSourceCallback): Deleted.
        (WTF::GMainLoopSource::socketSourceCallback): Deleted.
        (WTF::GMainLoopSource::Context::destroySource): Deleted.
        * wtf/gobject/GMainLoopSource.h:
        (WTF::GMainLoopSource::Context::operator=): Deleted.
        * wtf/gobject/GMutexLocker.h:
        (WTF::MutexWrapper<GMutex>::lock): Deleted.
        (WTF::MutexWrapper<GMutex>::unlock): Deleted.
        (WTF::MutexWrapper<GRecMutex>::lock): Deleted.
        (WTF::MutexWrapper<GRecMutex>::unlock): Deleted.
        (WTF::GMutexLocker::GMutexLocker): Deleted.
        (WTF::GMutexLocker::~GMutexLocker): Deleted.
        (WTF::GMutexLocker::lock): Deleted.
        (WTF::GMutexLocker::unlock): Deleted.
        * wtf/gobject/GRefPtr.cpp:
        (WTF::refGPtr): Deleted.
        (WTF::derefGPtr): Deleted.
        * wtf/gobject/GRefPtr.h:
        (WTF::GRefPtr::GRefPtr): Deleted.
        (WTF::GRefPtr::~GRefPtr): Deleted.
        (WTF::GRefPtr::clear): Deleted.
        (WTF::GRefPtr::outPtr): Deleted.
        (WTF::GRefPtr::isHashTableDeletedValue): Deleted.
        (WTF::GRefPtr::get): Deleted.
        (WTF::GRefPtr::operator*): Deleted.
        (WTF::GRefPtr::operator->): Deleted.
        (WTF::GRefPtr::operator!): Deleted.
        (WTF::GRefPtr::operator UnspecifiedBoolType): Deleted.
        (WTF::GRefPtr::hashTableDeletedValue): Deleted.
        (WTF::=): Deleted.
        (WTF::GRefPtr<T>::swap): Deleted.
        (WTF::swap): Deleted.
        (WTF::operator==): Deleted.
        (WTF::operator!=): Deleted.
        (WTF::static_pointer_cast): Deleted.
        (WTF::const_pointer_cast): Deleted.
        (WTF::adoptGRef): Deleted.
        (WTF::refGPtr): Deleted.
        (WTF::derefGPtr): Deleted.
        * wtf/gobject/GThreadSafeMainLoopSource.cpp:
        (WTF::GThreadSafeMainLoopSource::GThreadSafeMainLoopSource): Deleted.
        (WTF::GThreadSafeMainLoopSource::~GThreadSafeMainLoopSource): Deleted.
        (WTF::GThreadSafeMainLoopSource::cancel): Deleted.
        (WTF::GThreadSafeMainLoopSource::schedule): Deleted.
        (WTF::GThreadSafeMainLoopSource::scheduleAfterDelay): Deleted.
        (WTF::GThreadSafeMainLoopSource::prepareVoidCallback): Deleted.
        (WTF::GThreadSafeMainLoopSource::finishVoidCallback): Deleted.
        (WTF::GThreadSafeMainLoopSource::voidCallback): Deleted.
        (WTF::GThreadSafeMainLoopSource::prepareBoolCallback): Deleted.
        (WTF::GThreadSafeMainLoopSource::finishBoolCallback): Deleted.
        (WTF::GThreadSafeMainLoopSource::boolCallback): Deleted.
        * wtf/gobject/GUniquePtr.h:
        (WTF::GPtrDeleter::operator()): Deleted.
        (WTF::GUniqueOutPtr::GUniqueOutPtr): Deleted.
        (WTF::GUniqueOutPtr::~GUniqueOutPtr): Deleted.
        (WTF::GUniqueOutPtr::outPtr): Deleted.
        (WTF::GUniqueOutPtr::release): Deleted.
        (WTF::GUniqueOutPtr::operator*): Deleted.
        (WTF::GUniqueOutPtr::operator->): Deleted.
        (WTF::GUniqueOutPtr::get): Deleted.
        (WTF::GUniqueOutPtr::operator!): Deleted.
        (WTF::GUniqueOutPtr::operator UnspecifiedBoolType): Deleted.
        (WTF::GUniqueOutPtr::reset): Deleted.
        * wtf/gobject/GlibUtilities.cpp:
        (getCurrentExecutablePath): Deleted.

2015-06-10  Basile Clement  <basile_clement@apple.com>

        Unreviewed, fix an typo in unused template code.

        * wtf/TinyPtrSet.h:
        (WTF::TinyPtrSet::iterator::operator*): s/at(index)/at(m_index)/

2015-06-09  Csaba Osztrogonác  <ossy@webkit.org>

        [cmake] Fix the style issues in cmake project files
        https://bugs.webkit.org/show_bug.cgi?id=145755

        Reviewed by Darin Adler.

        * wtf/CMakeLists.txt:

2015-06-08  Alexey Proskuryakov  <ap@apple.com>

        Build fix.

        * wtf/TinyPtrSet.h: (WTF::TinyPtrSet::isEmpty): s/poointer/pointer/

2015-06-07  Filip Pizlo  <fpizlo@apple.com>

        The tiny set magic in StructureSet should be available in WTF
        https://bugs.webkit.org/show_bug.cgi?id=145722

        Reviewed by Geoffrey Garen.
        
        As the management of structure sets evolved in JSC, the StructureSet data structure grew
        increasingly smart. It's got some smart stuff for managing small sets of pointers. I
        wanted to take the generic logic out of JSC and put it into a reusable templatized class
        in WTF.
        
        * WTF.vcxproj/WTF.vcxproj:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/TinyPtrSet.h: Added.
        (WTF::TinyPtrSet::TinyPtrSet):
        (WTF::TinyPtrSet::operator=):
        (WTF::TinyPtrSet::~TinyPtrSet):
        (WTF::TinyPtrSet::clear):
        (WTF::TinyPtrSet::onlyEntry):
        (WTF::TinyPtrSet::isEmpty):
        (WTF::TinyPtrSet::add):
        (WTF::TinyPtrSet::remove):
        (WTF::TinyPtrSet::contains):
        (WTF::TinyPtrSet::merge):
        (WTF::TinyPtrSet::forEach):
        (WTF::TinyPtrSet::genericFilter):
        (WTF::TinyPtrSet::filter):
        (WTF::TinyPtrSet::exclude):
        (WTF::TinyPtrSet::isSubsetOf):
        (WTF::TinyPtrSet::isSupersetOf):
        (WTF::TinyPtrSet::overlaps):
        (WTF::TinyPtrSet::size):
        (WTF::TinyPtrSet::at):
        (WTF::TinyPtrSet::operator[]):
        (WTF::TinyPtrSet::last):
        (WTF::TinyPtrSet::iterator::iterator):
        (WTF::TinyPtrSet::iterator::operator*):
        (WTF::TinyPtrSet::iterator::operator++):
        (WTF::TinyPtrSet::iterator::operator==):
        (WTF::TinyPtrSet::iterator::operator!=):
        (WTF::TinyPtrSet::begin):
        (WTF::TinyPtrSet::end):
        (WTF::TinyPtrSet::operator==):
        (WTF::TinyPtrSet::addOutOfLine):
        (WTF::TinyPtrSet::containsOutOfLine):
        (WTF::TinyPtrSet::copyFrom):
        (WTF::TinyPtrSet::copyFromOutOfLine):
        (WTF::TinyPtrSet::OutOfLineList::create):
        (WTF::TinyPtrSet::OutOfLineList::destroy):
        (WTF::TinyPtrSet::OutOfLineList::list):
        (WTF::TinyPtrSet::OutOfLineList::OutOfLineList):
        (WTF::TinyPtrSet::deleteListIfNecessary):
        (WTF::TinyPtrSet::isThin):
        (WTF::TinyPtrSet::pointer):
        (WTF::TinyPtrSet::singleEntry):
        (WTF::TinyPtrSet::list):
        (WTF::TinyPtrSet::set):
        (WTF::TinyPtrSet::setEmpty):
        (WTF::TinyPtrSet::getReservedFlag):
        (WTF::TinyPtrSet::setReservedFlag):

2015-06-05  Chris Dumez  <cdumez@apple.com>

        [WK2][iOS] Limit the number of vnodes used by the WebContent processes
        https://bugs.webkit.org/show_bug.cgi?id=145672
        <rdar://problem/21126637>

        Reviewed by Antti Koivisto.

        * wtf/RefCounter.h:
        (WTF::RefCounter::value):

        Expose the actual refcount instead of a boolean value.

2015-06-05  Alex Christensen  <achristensen@webkit.org>

        [Web Timing] Use new SPI to enable data collection.
        https://bugs.webkit.org/show_bug.cgi?id=145650
        rdar://problem/21203358

        Reviewed by Chris Dumez.

        * wtf/Platform.h:
        Added HAVE_TIMINGDATAOPTIONS for platform and version dependent feature.

2015-06-05  Xabier Rodriguez Calvar  <calvaris@igalia.com> and Youenn Fablet <youenn.fablet@crf.canon.fr>

        [Streams API] ReadableStream should store callbacks as a Deque
        https://bugs.webkit.org/show_bug.cgi?id=145641

        Reviewed by Darin Adler.

        * wtf/Deque.h:
        (WTF::Deque::append): Adding not templated append method, forwarding to templated append method.

2015-06-02  Xabier Rodriguez Calvar  <calvaris@igalia.com> and Youenn Fablet <youenn.fablet@crf.canon.fr>

        [Streams API] Delegate ReadableStreamReader reference counting to ReadableStream
        https://bugs.webkit.org/show_bug.cgi?id=144907

        Reviewed by Darin Adler.

        * wtf/Vector.h:
        (WTF::Vector::append): Adding not templated append method, forwarding to ValueType templated append method.

2015-06-02  Yusuke Suzuki  <utatane.tea@gmail.com>

        Heap-use-after-free read of size 4 in JavaScriptCore: WTF::StringImpl::isSymbol() (StringImpl.h:496)
        https://bugs.webkit.org/show_bug.cgi?id=145532

        Reviewed by Geoffrey Garen.

        Return `RefPtr<AtomicStringImpl>` instead of `AtomicStringImpl*`.

        * wtf/text/AtomicStringImpl.cpp:
        (WTF::AtomicStringImpl::lookUpSlowCase):
        (WTF::AtomicStringImpl::lookUpInternal):
        * wtf/text/AtomicStringImpl.h:
        (WTF::AtomicStringImpl::lookUp):

2015-06-01  Anders Carlsson  <andersca@apple.com>

        Use xpc_connection_set_oneshot_instance where possible
        https://bugs.webkit.org/show_bug.cgi?id=145535
        rdar://problem/21109994

        Reviewed by Sam Weinig.

        Add SPI declaration.

        * wtf/spi/darwin/XPCSPI.h:

2015-05-29  Anders Carlsson  <andersca@apple.com>

        Missing #import of Platform.h in several WTF headers
        https://bugs.webkit.org/show_bug.cgi?id=145475
        rdar://problem/21161818

        Reviewed by Darin Adler.

        Add Platform.h #includes.

        * wtf/Assertions.h:
        * wtf/RetainPtr.h:

2015-05-29  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r184949.
        https://bugs.webkit.org/show_bug.cgi?id=145458

        Ends up generating worse code for HashTable move constructors
        (Requested by zdobersek on #webkit).

        Reverted changeset:

        "Clean up HashTable constructors"
        https://bugs.webkit.org/show_bug.cgi?id=145369
        http://trac.webkit.org/changeset/184949

2015-05-28  Gyuyoung Kim  <gyuyoung.kim@webkit.org>

        Purge PassRefPtr in StringConcatenate.h
        https://bugs.webkit.org/show_bug.cgi?id=145376

        Reviewed by Darin Adler.

        Replace PassRefPtr with RefPtr. Additionally use nullptr instead of 0.

        * wtf/text/StringConcatenate.h:
        (WTF::tryMakeString):
        (WTF::makeString):

2015-05-28  Zan Dobersek  <zdobersek@igalia.com>

        Clean up HashTable constructors
        https://bugs.webkit.org/show_bug.cgi?id=145369

        Reviewed by Andreas Kling.

        Use nullptr to initialize pointer member variables in the HashTable
        default constructor. Copy and move constructors can use constructor
        delegation instead of replicating all member initializations. Move
        constructor should simply call HashTable::swap() instead of replicating
        all the swap operations.

        * wtf/HashTable.h:
        (WTF::KeyTraits>::HashTable):

2015-05-27  Alexey Proskuryakov  <ap@apple.com>

        [Mac] Fix clang static analyzer build
        https://bugs.webkit.org/show_bug.cgi?id=145426
        rdar://problem/20947408

        Reviewed by Dan Bernstein.

        * wtf/spi/darwin/XPCSPI.h: Correct declarations of xpc_retain and xpc_release.

2015-05-27  Dean Jackson  <dino@apple.com>

        img.currentSrc problem in strict mode with old picturefill
        https://bugs.webkit.org/show_bug.cgi?id=144095
        <rdar://problem/21087013>

        Reviewed by Simon Fraser.

        Add a PICTURE_SIZES flag.

        * wtf/FeatureDefines.h:

2015-05-26  Andreas Kling  <akling@apple.com>

        StringView should have find(StringView, start).
        <https://webkit.org/b/145351>

        Reviewed by Darin Adler.

        Move the class agnostic guts of StringImpl's find() implementation from StringImpl
        to StringCommon.h and templatize the code into a findCommon() helper.

        StringImpl::find() and StringView::find() now both call findCommon().

        * wtf/text/StringCommon.h:
        (WTF::findInner):
        (WTF::find):
        (WTF::findCommon):
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::find):
        (WTF::findInner): Deleted.
        * wtf/text/StringImpl.h:
        (WTF::find): Deleted.
        * wtf/text/StringView.cpp:
        (WTF::StringView::find):
        * wtf/text/StringView.h:


2015-05-26  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/21104551> Update build settings

        Reviewed by Anders Carlsson.

        * Configurations/DebugRelease.xcconfig:

2015-05-23  Dan Bernstein  <mitz@apple.com>

        Remove unused definitions of WEBKIT_VERSION_MIN_REQUIRED
        https://bugs.webkit.org/show_bug.cgi?id=145345

        Reviewed by Sam Weinig.

        * Configurations/Base.xcconfig: Also changed to use $(inherited).

2015-05-23  Yusuke Suzuki  <utatane.tea@gmail.com>

        Introduce UniquedStringImpl and SymbolImpl to separate symbolic strings from AtomicStringImpl
        https://bugs.webkit.org/show_bug.cgi?id=144848

        Reviewed by Darin Adler.

        he current AtomicStringImpl accidentally means the symbol OR atomic StringImpl.
        t's not correct to its name and it's error prone.

        In this patch, we'll introduce/changes classes into WTF.

        1. UniquedStringImpl
        It's derived class from StringImpl. And it represents symbol || atomic StringImpl.

        2. SymbolImpl
        It's derived class from UniquedStringImpl. Only symbol strings can become this.
        It ensures the given StringImpl is symbol in compile time.

        3. AtomicStringImpl
        It's derived class from UniquedStringImpl. Only atomic (non-normal && non-symbol) strings can become this.
        It ensures the given StringImpl is atomic in compile time.

        And, in this time, I just accept UniqueStringImpl in AtomicString. As the result,
        1. Now AtomicStringImpl issue is fixed. Its SymbolImpl is separated and UniquedStringImpl is introduced.
        2. But AtomicString still have both symbol and atomic strings.
        This should be solved in the separated patch.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/PrintStream.cpp:
        * wtf/PrintStream.h:
        (WTF::printInternal):
        * wtf/text/AtomicString.h:
        (WTF::AtomicString::AtomicString):
        * wtf/text/AtomicStringImpl.h:
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl):
        (WTF::StringImpl::createSymbol):
        (WTF::StringImpl::createSymbolEmpty):
        * wtf/text/StringImpl.h:
        * wtf/text/SymbolImpl.h: Copied from Source/JavaScriptCore/runtime/PrivateName.h.
        * wtf/text/SymbolRegistry.cpp:
        (WTF::SymbolRegistry::symbolForKey):
        (WTF::SymbolRegistry::keyForSymbol):
        (WTF::SymbolRegistry::remove):
        * wtf/text/SymbolRegistry.h:
        * wtf/text/UniquedStringImpl.h: Copied from Source/JavaScriptCore/runtime/PrivateName.h.

2015-05-20  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Move MainThreadGtk, RunLoopGtk, WorkQueueGtk under Source/WTF/wtf/glib/
        https://bugs.webkit.org/show_bug.cgi?id=145117

        Reviewed by Csaba Osztrogonác.

        Move the MainThreadGtk, RunLoopGtk and WorkQueueGtk implementation files from
        Source/WTF/wtf/gtk/ to Source/WTF/wtf/glib/. These implementations are not
        GTK-specific and only depend on GLib, so they are renamed as well.

        There are other such implementations under Source/WTF/wtf/gobject/ (GObject
        is just a subset of GLib) that will be moved under the new directory in
        future patches.

        * wtf/PlatformGTK.cmake:
        * wtf/glib/MainThreadGLib.cpp: Renamed from Source/WTF/wtf/gtk/MainThreadGtk.cpp.
        (WTF::initializeMainThreadPlatform):
        (WTF::scheduleDispatchFunctionsOnMainThread):
        * wtf/glib/RunLoopGLib.cpp: Renamed from Source/WTF/wtf/gtk/RunLoopGtk.cpp.
        (WTF::RunLoop::RunLoop):
        (WTF::RunLoop::~RunLoop):
        (WTF::RunLoop::run):
        (WTF::RunLoop::stop):
        (WTF::RunLoop::wakeUp):
        (WTF::RunLoop::TimerBase::TimerBase):
        (WTF::RunLoop::TimerBase::~TimerBase):
        (WTF::RunLoop::TimerBase::start):
        (WTF::RunLoop::TimerBase::stop):
        (WTF::RunLoop::TimerBase::isActive):
        * wtf/glib/WorkQueueGLib.cpp: Renamed from Source/WTF/wtf/gtk/WorkQueueGtk.cpp.
        (WTF::WorkQueue::platformInitialize):
        (WTF::WorkQueue::platformInvalidate):
        (WTF::WorkQueue::registerSocketEventHandler):
        (WTF::WorkQueue::unregisterSocketEventHandler):
        (WTF::WorkQueue::dispatch):
        (WTF::WorkQueue::dispatchAfter):

2015-05-19  Andreas Kling  <akling@apple.com>

        Give StringView a utf8() API.
        <https://webkit.org/b/145201>

        Reviewed by Anders Carlsson

        Added an LChar version of StringImpl::utf8ForCharacters() and use that to give
        StringView a utf8() API just like String has.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::utf8ForCharacters):
        * wtf/text/StringImpl.h:
        * wtf/text/StringView.cpp:
        (WTF::StringView::utf8):
        * wtf/text/StringView.h:

2015-05-19  Yusuke Suzuki  <utatane.tea@gmail.com>

        Move AtomicStringImpl table related operations from AtomicString to AtomicStringImpl
        https://bugs.webkit.org/show_bug.cgi?id=145109

        Reviewed by Darin Adler.

        Now AtomicStringImpl table operations are located in AtomicString.
        But they should be under AtomicStringImpl.
        This patch simply moves these operations to AtomicStringImpl.

        And this patch renames static AtomicString::find to static AtomicStringImpl::lookUp
        because it conflicts with AtomicStringImpl's member function name.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.vcxproj/copy-files.cmd:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/PlatformMac.cmake:
        * wtf/PlatformWin.cmake:
        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::lower):
        (WTF::AtomicString::convertToASCIILowercase):
        (WTF::AtomicString::fromUTF8Internal):
        (WTF::AtomicStringTableLocker::AtomicStringTableLocker): Deleted.
        (WTF::stringTable): Deleted.
        (WTF::addToStringTable): Deleted.
        (WTF::CStringTranslator::hash): Deleted.
        (WTF::CStringTranslator::equal): Deleted.
        (WTF::CStringTranslator::translate): Deleted.
        (WTF::AtomicString::add): Deleted.
        (WTF::UCharBufferTranslator::hash): Deleted.
        (WTF::UCharBufferTranslator::equal): Deleted.
        (WTF::UCharBufferTranslator::translate): Deleted.
        (WTF::HashAndCharactersTranslator::hash): Deleted.
        (WTF::HashAndCharactersTranslator::equal): Deleted.
        (WTF::HashAndCharactersTranslator::translate): Deleted.
        (WTF::HashAndUTF8CharactersTranslator::hash): Deleted.
        (WTF::HashAndUTF8CharactersTranslator::equal): Deleted.
        (WTF::HashAndUTF8CharactersTranslator::translate): Deleted.
        (WTF::SubstringTranslator::translate): Deleted.
        (WTF::SubstringTranslator8::hash): Deleted.
        (WTF::SubstringTranslator8::equal): Deleted.
        (WTF::SubstringTranslator16::hash): Deleted.
        (WTF::SubstringTranslator16::equal): Deleted.
        (WTF::LCharBufferTranslator::hash): Deleted.
        (WTF::LCharBufferTranslator::equal): Deleted.
        (WTF::LCharBufferTranslator::translate): Deleted.
        (WTF::CharBufferFromLiteralDataTranslator::hash): Deleted.
        (WTF::CharBufferFromLiteralDataTranslator::equal): Deleted.
        (WTF::CharBufferFromLiteralDataTranslator::translate): Deleted.
        (WTF::AtomicString::addFromLiteralData): Deleted.
        (WTF::AtomicString::addSlowCase): Deleted.
        (WTF::AtomicString::remove): Deleted.
        (WTF::AtomicString::findSlowCase): Deleted.
        (WTF::AtomicString::findInternal): Deleted.
        (WTF::AtomicString::isInAtomicStringTable): Deleted.
        * wtf/text/AtomicString.h:
        (WTF::AtomicString::AtomicString):
        (WTF::AtomicString::fromUTF8):
        (WTF::AtomicString::find): Deleted.
        (WTF::AtomicString::add): Deleted.
        (WTF::AtomicString::addWithStringTableProvider): Deleted.
        * wtf/text/AtomicStringImpl.cpp: Copied from Source/WTF/wtf/text/AtomicString.cpp.
        (WTF::AtomicStringTableLocker::AtomicStringTableLocker):
        (WTF::stringTable):
        (WTF::addToStringTable):
        (WTF::CStringTranslator::hash):
        (WTF::CStringTranslator::equal):
        (WTF::CStringTranslator::translate):
        (WTF::AtomicStringImpl::add):
        (WTF::UCharBufferTranslator::hash):
        (WTF::UCharBufferTranslator::equal):
        (WTF::UCharBufferTranslator::translate):
        (WTF::HashAndCharactersTranslator::hash):
        (WTF::HashAndCharactersTranslator::equal):
        (WTF::HashAndCharactersTranslator::translate):
        (WTF::HashAndUTF8CharactersTranslator::hash):
        (WTF::HashAndUTF8CharactersTranslator::equal):
        (WTF::HashAndUTF8CharactersTranslator::translate):
        (WTF::SubstringTranslator::translate):
        (WTF::SubstringTranslator8::hash):
        (WTF::SubstringTranslator8::equal):
        (WTF::SubstringTranslator16::hash):
        (WTF::SubstringTranslator16::equal):
        (WTF::LCharBufferTranslator::hash):
        (WTF::LCharBufferTranslator::equal):
        (WTF::LCharBufferTranslator::translate):
        (WTF::CharBufferFromLiteralDataTranslator::hash):
        (WTF::CharBufferFromLiteralDataTranslator::equal):
        (WTF::CharBufferFromLiteralDataTranslator::translate):
        (WTF::AtomicStringImpl::addLiteral):
        (WTF::AtomicStringImpl::addSlowCase):
        (WTF::AtomicStringImpl::remove):
        (WTF::AtomicStringImpl::lookUpSlowCase):
        (WTF::AtomicStringImpl::addUTF8):
        (WTF::AtomicStringImpl::lookUpInternal):
        (WTF::AtomicStringImpl::isInAtomicStringTable):
        * wtf/text/AtomicStringImpl.h:
        (WTF::AtomicStringImpl::lookUp):
        (WTF::AtomicStringImpl::add):
        (WTF::AtomicStringImpl::addWithStringTableProvider):
        (WTF::AtomicStringImpl::AtomicStringImpl): Deleted.
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl):
        * wtf/text/StringImpl.h:
        * wtf/text/WTFString.h:
        (WTF::String::String):
        * wtf/text/cf/AtomicStringCF.cpp:
        (WTF::AtomicString::add): Deleted.
        * wtf/text/cf/AtomicStringImplCF.cpp: Renamed from Source/WTF/wtf/text/cf/AtomicStringCF.cpp.
        (WTF::AtomicStringImpl::add):

2015-05-19  Ting-Wei Lan  <lantw44@gmail.com>

        [SOUP] Use st_birthtime to get creation time of files on systems support it
        https://bugs.webkit.org/show_bug.cgi?id=144989

        Reviewed by Carlos Garcia Campos.

        Define HAVE(STAT_BIRTHTIME) as 1 on operating systems supporting
        getting creation time of files using st_birthtime in stat.

        * wtf/Platform.h:

2015-05-19  Chris Dumez  <cdumez@apple.com>

        Mark static variables as const when possible
        https://bugs.webkit.org/show_bug.cgi?id=145161

        Reviewed by Andreas Kling.

        * wtf/dtoa.cpp:
        (WTF::pow5mult):

2015-05-19  Gyuyoung Kim  <gyuyoung.kim@webkit.org>

        [EFL] Remove unnecessary PLATFORM(EFL) macro in EFL specific files
        https://bugs.webkit.org/show_bug.cgi?id=145160

        Reviewed by Csaba Osztrogonác.

        * wtf/efl/EflTypedefs.h: Remove PLATFORM(EFL).
        * wtf/efl/UniquePtrEfl.h: ditto.

2015-05-18  Michael Catanzaro  <mcatanzaro@igalia.com>

        [CMake] Ignore warnings in system headers
        https://bugs.webkit.org/show_bug.cgi?id=144747

        Reviewed by Darin Adler.

        Separate include directories into WebKit project includes and system includes. Suppress all
        warnings from headers in system include directories using the SYSTEM argument to
        the include_directories command.

        * wtf/CMakeLists.txt:
        * wtf/PlatformEfl.cmake:
        * wtf/PlatformGTK.cmake:

2015-05-18  Myles C. Maxfield  <mmaxfield@apple.com>

        Addressing post-review comments on r184353
        https://bugs.webkit.org/show_bug.cgi?id=145146

        Reviewed by Benjamin Poulain.

        Create an overload for equalIgnoringASCIICase() for AtomicString and string literals.

        * wtf/text/AtomicString.h:
        (WTF::equalIgnoringASCIICase):

2015-05-18  Skachkov Alexandr  <gskachkov@gmail.com>

        [ES6] Arrow function syntax. Feature flag for arrow function
        https://bugs.webkit.org/show_bug.cgi?id=145108

        Reviewed by Ryosuke Niwa.

        Added feature flag ENABLE_ES6_ARROWFUNCTION_SYNTAX for arrow function

        * wtf/FeatureDefines.h:

2015-05-17  Benjamin Poulain  <benjamin@webkit.org>

        Do not use fastMallocGoodSize anywhere
        https://bugs.webkit.org/show_bug.cgi?id=145103

        Reviewed by Michael Saboff.

        It is silly we see fastMallocGoodSize in profiles, it does absolutely nothing.

        This patch keeps fastMallocGoodSize() around for older code linking
        with newer WebKit, but remove any use of it inside WebKit.

        * wtf/FastMalloc.cpp:
        (WTF::fastMallocGoodSize):
        * wtf/FastMalloc.h:
        * wtf/Vector.h:
        (WTF::VectorBufferBase::allocateBuffer):
        (WTF::VectorBufferBase::tryAllocateBuffer):
        (WTF::VectorBufferBase::reallocateBuffer):

2015-05-15  Dan Bernstein  <mitz@apple.com>

        Build fix for some versions of clang.

        * wtf/SaturatedArithmetic.h:
        (signedAddOverflows):
        (signedSubtractOverflows):

2015-05-14  Dan Bernstein  <mitz@apple.com>

        Reverted r177753, now that <rdar://problem/19347133> is fixed.

        Rubber-stamped by Benjamin Poulain.

        * wtf/SaturatedArithmetic.h:
        (signedAddOverflows):
        (signedSubtractOverflows):

2015-05-14  Myles C. Maxfield  <mmaxfield@apple.com>

        Add String literal overloads to equalIgnoringASCIICase()
        https://bugs.webkit.org/show_bug.cgi?id=145008

        Reviewed by Benjamin Poulain.

        Create an overload for equalIgnoringASCIICase for string literals.

        * wtf/text/StringImpl.h:
        (WTF::equalIgnoringASCIICase): Use a non-templated helper function.
        * wtf/text/StringImpl.cpp:
        (WTF::equalIgnoringASCIICase): Implement it.
        * wtf/text/StringView.h:
        (WTF::equalIgnoringASCIICase): Use a non-templated helper function.
        * wtf/text/StringView.cpp:
        (WTF::equalIgnoringASCIICase): Implement it.
        * wtf/text/WTFString.h:
        (WTF::equalIgnoringASCIICase): Delegate to StringImpl's implementation.

2015-05-14  Žan Doberšek  <zdobersek@igalia.com>

        [GTK] RunLoop constructor should properly retrieve or establish the thread-default GMainContext
        https://bugs.webkit.org/show_bug.cgi?id=144732

        Reviewed by Carlos Garcia Campos.

        RunLoop constructor in the GTK implementation should use the
        existing thread-default context, create a new one if not on
        the main thread, or use the global-default one if on the main
        thread.

        In RunLoop::run(), the GMainContext should then be pushed as
        the thread-default before calling g_main_loop_run(), and popped
        off when the main loop stops.

        * wtf/gtk/RunLoopGtk.cpp:
        (WTF::RunLoop::RunLoop):
        (WTF::RunLoop::run):

2015-05-13  Oliver Hunt  <oliver@apple.com>
       Ensure that all the smart pointer types in WTF clear their pointer before deref
       https://bugs.webkit.org/show_bug.cgi?id=143789

       Reviewed by Ryosuke Niwa.

       In order to prevent use after free bugs caused by destructors
       that end up trying to access the smart pointer itself, we should
       make sure we always clear the m_ptr field before calling deref.

       Essentially the UaF path is:
       struct Foo : RefCounted<Foo> {
         Wibble* m_wibble;
         void doSomething();
         ~Foo() { m_wibble->doSomethingLikeCleanup(); }
       };

       struct Wibble {
         void doSomethingLikeCleanup()
         {
           if (m_foo) {
               /* if this branch is not here we get a null deref */
               m_foo->doSomething();
           }
         }
         void replaceFoo(Foo* foo) { m_foo = foo; }
         RefPtr<Foo> m_foo;
       };

       Wibble* someWibble = /* a Wibble with m_foo->m_refCount == 1 */;
                            /* and m_foo points to someWibble       */;

       someWibble->replaceFoo(someOtherFoo);
       + someWibble->m_foo->m_ptr->deref();
         + someWibble->m_foo->m_ptr->~Foo()
           + someWibble->m_foo->m_ptr->m_wibble->doSomethingLikeCleanup()
             + someWibble->m_foo->m_ptr->m_wibble /* someWibble */ ->m_foo->m_ptr /*logically dead*/ ->doSomething()

       By clearing m_ptr first we either force a null pointer deref or
       we force our code down a path that does not use the dead smart
       pointer.

       * wtf/PassRefPtr.h:
       (WTF::PassRefPtr::~PassRefPtr):
       * wtf/Ref.h:
       (WTF::Ref::~Ref):
       (WTF::Ref::operator=):
       * wtf/RefPtr.h:
       (WTF::RefPtr::~RefPtr):
       * wtf/RetainPtr.h:
       (WTF::RetainPtr::~RetainPtr):
       (WTF::RetainPtr<T>::clear):

2015-05-12  Michael Saboff  <msaboff@apple.com>

        If JSC cannot get executable memory, it shouldn't call madvise
        https://bugs.webkit.org/show_bug.cgi?id=144931

        Reviewed by Mark Lam.

        Made calling madvise conditional on really getting mmapped memory.

        * wtf/OSAllocatorPosix.cpp:
        (WTF::OSAllocator::reserveUncommitted):

2015-05-11  Brent Fulgham  <bfulgham@apple.com>

        [Win] Move Windows build target to Windows 7 (or newer)
        https://bugs.webkit.org/show_bug.cgi?id=144890
        <rdar://problem/20707307>

        Reviewed by Anders Carlsson.

        Update linked SDK and minimal Windows level to be compatible with
        Windows 7 or newer.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTFGenerated.vcxproj:
        * config.h:

2015-05-11  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] WorkQueue objects are not released
        https://bugs.webkit.org/show_bug.cgi?id=144824

        Reviewed by Žan Doberšek.

        Do not keep a reference of the WorkQueue for the entire life of
        its worker thread, since every task scheduled on the WorkQueue
        already takes a reference. Instead, take a reference of the main
        loop to make sure that when the worker thread starts, the main
        loop hasn't been released to avoid runtime warnings (see
        webkit.org/b/140998). Also removed the g_main_context_pop_thread_default()
        from the thread body, since the thread-specific context queue will
        be freed anyway when the thread exits.
        If the WorkQueue is released early, before the thread has started,
        schedule a main loop quit in the context, to make sure it will
        be the first thing run by the main loop and the thread will exit.

        * wtf/WorkQueue.h: Remove unused event loop mutex.
        * wtf/gtk/WorkQueueGtk.cpp:
        (WTF::WorkQueue::platformInitialize):
        (WTF::WorkQueue::platformInvalidate):

2015-05-09  Yoav Weiss  <yoav@yoav.ws>

        Remove the PICTURE_SIZES build flag
        https://bugs.webkit.org/show_bug.cgi?id=144679

        Reviewed by Benjamin Poulain.

        Removed the PICTURE_SIZES build time flag.

        * wtf/FeatureDefines.h:

2015-05-08  Myles C. Maxfield  <mmaxfield@apple.com>

        Remove convenience constructors for TextRun
        https://bugs.webkit.org/show_bug.cgi?id=144752

        Reviewed by Anders Carlsson.

        No reason why StringView shouldn't have a StringImpl* constructor.

        Test: StringView8Bit in TestWebKitAPI

        * wtf/text/StringView.h: Add the constructor.

2015-05-08  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r183996.
        https://bugs.webkit.org/show_bug.cgi?id=144806

        ASan detected use-after free (Requested by ap on #webkit).

        Reverted changeset:

        "Remove convenience constructors for TextRun"
        https://bugs.webkit.org/show_bug.cgi?id=144752
        http://trac.webkit.org/changeset/183996

2015-05-08  Myles C. Maxfield  <mmaxfield@apple.com>

        Remove convenience constructors for TextRun
        https://bugs.webkit.org/show_bug.cgi?id=144752

        Reviewed by Anders Carlsson.

        No reason why StringView shouldn't have a StringImpl* constructor.

        Test: StringView8Bit in TestWebKitAPI

        * wtf/text/StringView.h: Add the constructor.

2015-05-08  Andreas Kling  <akling@apple.com>

        Optimize serialization of quoted JSON strings.
        <https://webkit.org/b/144754>

        Reviewed by Darin Adler.

        Add a StringBuilder API for appending a quoted JSON string. This is used by
        JSON.stringify() to implement efficient appending of strings while escaping
        quotes, control characters and \uNNNN-style characters.

        The main benefit comes from only doing a single buffer expansion up front,
        instead of doing it every time we append something. The fudge factor is pretty
        large, since the maximum number of output characters per input character is 6.

        The first landing of this patch had two bugs in it:

        - Made \uNNNN escapes uppercase hexadecimal instead of lowercase.
        - Didn't preallocate enough space for 8-bit input strings.

        Both were caught by existing tests on our bots, and both were due to last-minute
        changes before landing. :/

        * wtf/text/StringBuilder.cpp:
        (WTF::appendQuotedJSONStringInternal):
        (WTF::StringBuilder::appendQuotedJSONString):
        * wtf/text/StringBuilder.h:

2015-05-07  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r183961.
        https://bugs.webkit.org/show_bug.cgi?id=144784

        Broke js/dom/JSON-stringify.html (Requested by kling on
        #webkit).

        Reverted changeset:

        "Optimize serialization of quoted JSON strings."
        https://bugs.webkit.org/show_bug.cgi?id=144754
        http://trac.webkit.org/changeset/183961

2015-05-07  Andreas Kling  <akling@apple.com>

        Optimize serialization of quoted JSON strings.
        <https://webkit.org/b/144754>

        Reviewed by Darin Adler.

        Add a StringBuilder API for appending a quoted JSON string. This is used by
        JSON.stringify() to implement efficient appending of strings while escaping
        quotes, control characters and \uNNNN-style characters.

        The main benefit comes from only doing a single buffer expansion up front,
        instead of doing it every time we append something. The fudge factor is pretty
        large for 16-bit strings, since the maximum number of output characters per
        input character is 6.

        * wtf/text/StringBuilder.cpp:
        (WTF::appendQuotedJSONStringInternal):
        (WTF::StringBuilder::appendQuotedJSONString):
        * wtf/text/StringBuilder.h:

2015-05-07  Martin Robinson  <mrobinson@igalia.com>

        [GTK] All spell checking layout tests fail
        https://bugs.webkit.org/show_bug.cgi?id=144648

        Reviewed by Carlos Garcia Campos.

        * wtf/Platform.h: Activate UNIFIED_TEXT_CHECKING for GTK+.

2015-05-07  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/19317140> [Xcode] Remove usage of AspenFamily.xcconfig in Source/
        https://bugs.webkit.org/show_bug.cgi?id=144727

        Reviewed by Darin Adler.

        * Configurations/Base.xcconfig: Don’t include AspenFamily.xcconfig, and define
        INSTALL_PATH_PREFIX and LD_DYLIB_INSTALL_NAME for the iOS 8.x Simulator.

2015-05-07  Žan Doberšek  <zdobersek@igalia.com>

        [GTK] Clean up RunLoop implementation
        https://bugs.webkit.org/show_bug.cgi?id=144729

        Reviewed by Carlos Garcia Campos.

        Clean up the RunLoop implementation for the GTK port,
        removing unnecessary methods and using simpler variable names.

        Nested GMainLoops in RunLoop::run() are now created for the
        RunLoop's GMainContext, and not for the default context (enforced
        through the null argument to g_main_loop_new()).

        * wtf/RunLoop.h:
        * wtf/gtk/RunLoopGtk.cpp:
        (WTF::RunLoop::RunLoop):
        (WTF::RunLoop::~RunLoop):
        (WTF::RunLoop::run):
        (WTF::RunLoop::stop):
        (WTF::RunLoop::wakeUp):
        (WTF::RunLoop::TimerBase::start):
        (WTF::RunLoop::innermostLoop): Deleted.
        (WTF::RunLoop::pushNestedMainLoop): Deleted.
        (WTF::RunLoop::popNestedMainLoop): Deleted.

2015-05-05  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Async operations running in the WorkQueue thread should schedule their sources to the WorkQueue main lopp
        https://bugs.webkit.org/show_bug.cgi?id=144541

        Reviewed by Žan Doberšek.

        They are currently sent to the main thread run loop, because we
        are not setting the WorkQueue main context as the default one in
        the worker thread.

        * wtf/gtk/WorkQueueGtk.cpp:
        (WTF::WorkQueue::platformInitialize): Call
        g_main_context_push_thread_default() to set the WorkQueue main
        context as the default of the thread before running the main loop,
        and g_main_context_pop_thread_default() when the main loop quits.

2015-05-04  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r183661.
        https://bugs.webkit.org/show_bug.cgi?id=144594

        Caused ~3.5MB regression on membuster(!) (Requested by kling_
        on #webkit).

        Reverted changeset:

        "Decrease minimum Vector size."
        https://bugs.webkit.org/show_bug.cgi?id=144453
        http://trac.webkit.org/changeset/183661

2015-05-04  Zan Dobersek  <zdobersek@igalia.com>

        [WTF] Remove Functional.h inclusions
        https://bugs.webkit.org/show_bug.cgi?id=144400

        Reviewed by Darin Adler.

        Remove most of the Functional.h header inclusions. The header is preserved
        since it's still used by older versions of Safari, and for the callOnMainThread()
        stub in DeprecatedSymbolsUsedBySafari.mm.

        * wtf/MainThread.cpp:
        * wtf/RunLoop.h:
        * wtf/WorkQueue.cpp:
        * wtf/WorkQueue.h:
        * wtf/efl/DispatchQueueEfl.h:
        * wtf/efl/DispatchQueueWorkItemEfl.h:

2015-05-02  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r183722.
        https://bugs.webkit.org/show_bug.cgi?id=144534

        Made all the tests assert (Requested by ap on #webkit).

        Reverted changeset:

        "Generated static StringImpls should have static flag set."
        https://bugs.webkit.org/show_bug.cgi?id=144516
        http://trac.webkit.org/changeset/183722

2015-05-02  Andreas Kling  <akling@apple.com>

        Generated static StringImpls should have static flag set.
        <https://webkit.org/b/144516>

        Reviewed by Darin Adler.

        Discovered this while tracking down a string ref leak. Turns out that the strings
        generated by StaticString.pm were not getting the static flag set on them.

        The only practical difference from this AFAICT is that now the garbage collector
        will correctly see that these strings have no extra memory cost to worry about.

        * wtf/text/StringImpl.h:

2015-05-01  Martin Robinson  <mrobinson@igalia.com>

        USE(...) macro should expect unprefixed variables
        https://bugs.webkit.org/show_bug.cgi?id=144454

        Reviewed by Daniel Bates.

        * wtf/Assertions.cpp: Replace all occurrences WTF_USE with USE.
        * wtf/Platform.h: Replace all occurrences WTF_USE with USE. Modify the USE
        macro to look for unprefixed variables.
        * wtf/WTFThreadData.h: Replace all occurrences WTF_USE with USE.

2015-05-01  Joseph Pecoraro  <pecoraro@apple.com>

        Enable ENABLE_ES6_TEMPLATE_LITERAL_SYNTAX by default on all ports (Windows was missed)
        https://bugs.webkit.org/show_bug.cgi?id=144495

        Reviewed by Csaba Osztrogonác.

        * wtf/FeatureDefines.h:
        This covers all ports that haven't defined the flag otherwise.

2015-04-30  Alex Christensen  <achristensen@webkit.org>

        Decrease minimum Vector size.
        https://bugs.webkit.org/show_bug.cgi?id=144453

        Reviewed by Andreas Kling.

        * wtf/Vector.h:
        Make the default min size 4 to save memory on small Vectors.

2015-04-30  Yusuke Suzuki  <utatane.tea@gmail.com>

        Use the default hash value for Symbolized StringImpl
        https://bugs.webkit.org/show_bug.cgi?id=144347

        Reviewed by Darin Adler.

        Use a default hash value calculation for symbolized StringImpl.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::createSymbol):
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):
        (WTF::StringImpl::symbolAwareHash):
        (WTF::StringImpl::existingSymbolAwareHash):
        (WTF::StringImpl::hashForSymbol):
        * wtf/text/StringStatics.cpp:
        (WTF::StringImpl::nextHashForSymbol):
        (WTF::StringImpl::hashAndFlagsForSymbol): Deleted.

2015-04-29  Alexey Proskuryakov  <ap@apple.com>

        LazyNeverDestroyed is not thread safe in debug builds, causing assertions
        https://bugs.webkit.org/show_bug.cgi?id=144378

        Reviewed by Darin Adler.

        * wtf/NeverDestroyed.h:

2015-04-28  Geoffrey Garen  <ggaren@apple.com>

        It shouldn't take 1846 lines of code and 5 FIXMEs to sort an array.
        https://bugs.webkit.org/show_bug.cgi?id=144013

        Reviewed by Mark Lam.

        Remove this custom tree implementation because it is unused. (It was
        previously used to achieve a stable array sort in certain cases.)

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/AVLTree.h: Removed.
        * wtf/CMakeLists.txt:

2015-04-29  Myles C. Maxfield  <mmaxfield@apple.com>

        [OS X] Use CTFontCreateForCSS instead of doing font search ourselves
        https://bugs.webkit.org/show_bug.cgi?id=132159

        Reviewed by Darin Adler.

        * wtf/Platform.h:

        Opt-in using ENABLE(PLATFORM_FONT_LOOKUP)

2015-04-29  Yusuke Suzuki  <utatane.tea@gmail.com>

        REGRESSION (r183373): ASSERT failed in wtf/SHA1.h
        https://bugs.webkit.org/show_bug.cgi?id=144257

        Reviewed by Darin Adler.

        * wtf/SHA1.h:
        (WTF::SHA1::addBytes):

2015-04-29  Martin Robinson  <mrobinson@igalia.com>

        [CMake] [GTK] Organize and clean up unused CMake variables
        https://bugs.webkit.org/show_bug.cgi?id=144364

        Reviewed by Gyuyoung Kim.

        * wtf/PlatformGTK.cmake: Add variables specific to this project.

2015-04-28  Michael Catanzaro  <mcatanzaro@igalia.com>

        Fully replace ENABLE_LLINT_C_LOOP with ENABLE_JIT
        https://bugs.webkit.org/show_bug.cgi?id=144304

        Reviewed by Geoffrey Garen.

        No longer check ENABLE_LLINT_C_LOOP to determine the value of ENABLE_JIT.

        * wtf/Platform.h:

2015-04-28  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r183514.
        https://bugs.webkit.org/show_bug.cgi?id=144359

        It broke cloop test bots (Requested by mcatanzaro on #webkit).

        Reverted changeset:

        "Fully replace ENABLE_LLINT_C_LOOP with ENABLE_JIT"
        https://bugs.webkit.org/show_bug.cgi?id=144304
        http://trac.webkit.org/changeset/183514

2015-04-28  Michael Catanzaro  <mcatanzaro@igalia.com>

        Fully replace ENABLE_LLINT_C_LOOP with ENABLE_JIT
        https://bugs.webkit.org/show_bug.cgi?id=144304

        Reviewed by Geoffrey Garen.

        No longer check ENABLE_LLINT_C_LOOP to determine the value of ENABLE_JIT.

        * wtf/Platform.h:

2015-04-28  Alex Christensen  <achristensen@webkit.org>

        Properly reset deleted count when clearing HashTables.
        https://bugs.webkit.org/show_bug.cgi?id=144343

        Reviewed by Andreas Kling.

        * wtf/HashTable.h:
        (WTF::KeyTraits>::clear):
        Reset m_deletedCount, which appears to have been forgotten.

2015-04-28  Alex Christensen  <achristensen@webkit.org>

        [Content Extensions] Use less memory for CombinedURLFilters.
        https://bugs.webkit.org/show_bug.cgi?id=144290

        Reviewed by Andreas Kling.

        * wtf/Forward.h:
        * wtf/Vector.h:
        Added a minCapacity template parameter to allow changing the minimum size of an 
        allocated buffer. The default minCapacity is kept at 16 unless otherwise specified 
        to have no change on existing code, but this could be changed later. A smaller 
        default minCapacity would use less memory with small Vectors but spend more time 
        copying when expanding to large Vectors.

2015-04-27  Brent Fulgham  <bfulgham@apple.com>

        [Win] Deactivate WebGL until Windows tests work properly
        https://bugs.webkit.org/show_bug.cgi?id=144291
        <rdar://problem/20707307>

        Reviewed by Zalan Bujtas.

        * wtf/FeatureDefines.h: Force WebGL off for Windows builds.

2015-04-27  Michael Catanzaro  <mcatanzaro@igalia.com>

        Rename WTF_USE_3D_GRAPHICS to ENABLE_GRAPHICS_CONTEXT_3D
        https://bugs.webkit.org/show_bug.cgi?id=144193

        Reviewed by Darin Adler.

        * wtf/FeatureDefines.h:
        * wtf/Platform.h:

2015-04-22  Martin Robinson  <mrobinson@igalia.com>

        [CMake] Autogenerate cmakeconfig.h.cmake
        https://bugs.webkit.org/show_bug.cgi?id=143997

        Reviewed by Csaba Osztrogonác.

        * wtf/Platform.h: Move a GTK-specific setting from cmakeconfig.h to here.

2015-04-25  Martin Robinson  <mrobinson@igalia.com>

        Rename ENABLE_3D_RENDERING to ENABLE_3D_TRANSFORMS
        https://bugs.webkit.org/show_bug.cgi?id=144182

        Reviewed by Simon Fraser.

        * wtf/FeatureDefines.h: Replace all instances of 3D_RENDERING with 3D_TRANSFORMS.

2015-04-24  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r183288.
        https://bugs.webkit.org/show_bug.cgi?id=144189

        Made js/sort-with-side-effecting-comparisons.html time out in
        debug builds (Requested by ap on #webkit).

        Reverted changeset:

        "It shouldn't take 1846 lines of code and 5 FIXMEs to sort an
        array."
        https://bugs.webkit.org/show_bug.cgi?id=144013
        http://trac.webkit.org/changeset/183288

2015-04-21  Geoffrey Garen  <ggaren@apple.com>

        It shouldn't take 1846 lines of code and 5 FIXMEs to sort an array.
        https://bugs.webkit.org/show_bug.cgi?id=144013

        Reviewed by Mark Lam.

        Remove this custom tree implementation because it is unused. (It was
        previously used to achieve a stable array sort in certain cases.)

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/AVLTree.h: Removed.
        * wtf/CMakeLists.txt:

2015-04-24  Darin Adler  <darin@apple.com>

        Convert OwnPtr and PassOwnPtr uses to std::unique_ptr
        https://bugs.webkit.org/show_bug.cgi?id=128007

        Reviewed by Anders Carlsson.

        * WTF.vcxproj/WTF.vcxproj: Removed OwnPtr source files.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * WTF.xcodeproj/project.pbxproj: Ditto.
        * wtf/CMakeLists.txt: Ditto.

        * wtf/Forward.h: Removed OwnPtr and PassOwnPtr.
        * wtf/HashTraits.h: Ditto.

        * wtf/OwnPtr.h: Removed.
        * wtf/OwnPtrCommon.h: Removed.
        * wtf/PassOwnPtr.h: Removed.

        * wtf/SizeLimits.cpp: Removed OwnPtr.
        * wtf/VectorTraits.h: Removed OwnPtr specialization.

2015-04-23  Jer Noble  <jer.noble@apple.com>

        Disable HAVE_AVKIT on AppleTV
        https://bugs.webkit.org/show_bug.cgi?id=144142

        Reviewed by Dan Bernstein.

        * wtf/Platform.h:

2015-04-23  Alexey Proskuryakov  <ap@apple.com>

        [iOS] WebKit services should inherit environment variables for home
        https://bugs.webkit.org/show_bug.cgi?id=144078
        rdar://problem/20571678

        Reviewed by Dan Bernstein.

        * wtf/spi/darwin/XPCSPI.h: Added xpc_copy_bootstrap and xpc_dictionary_apply.

2015-04-23  Alexey Proskuryakov  <ap@apple.com>

        Undo the WTF part of the previous build fix, we don't use private headers in WTF.

        * WTF.xcodeproj/project.pbxproj:

2015-04-23  Alexey Proskuryakov  <ap@apple.com>

        Build fix.

        * WTF.xcodeproj/project.pbxproj: Make RAMSize.h a private header, now that it's used
        from outside WTF.

2015-04-23  Andreas Kling  <akling@apple.com>

        There should only be one way to get the system memory size.
        <https://webkit.org/b/144081>

        Reviewed by Antti Koivisto.

        Merge all the logic from other RAM size fetcher helpers into WTF's.

        Darwin ports now use host_info() instead of sysctl(), since that was the more common way
        of doing this.

        Also bumped the fallback answer from 128 MB to 512 MB to bring it closer to today's hardware.

        Finally, the number is rounded up to the next multiple of 128 MB, to avoid misunderstandings
        on some systems where the number returned by the kernel is slightly lower than the marketing
        number. Removed the "fudging" that was used in some places, since this fixes that cleanly.

        * wtf/RAMSize.cpp:
        (WTF::computeRAMSize):

2015-04-22  Darin Adler  <darin@apple.com>

        Eliminate remaining uses of OwnPtr and PassOwnPtr in WebCore outside the editing and platform directories
        https://bugs.webkit.org/show_bug.cgi?id=143949

        Reviewed by Andreas Kling.

        * wtf/MathExtras.h:
        (wtf_ceil): Deleted. This was a workaround for a bug that was introduced in Leopard and
        fixed in Snow Leopard <rdar://problem/6286405>, so we don't need the workaround any more.

2015-04-22  Alexey Proskuryakov  <ap@apple.com>

        [Mac] In nightlies and local builds, WebKit services can get terminated under memory pressure
        https://bugs.webkit.org/show_bug.cgi?id=144052
        rdar://problem/19754404

        Build fix. Landing a forward declaration that should have been part of the original patch.

        * wtf/spi/darwin/XPCSPI.h:

2015-04-21  Chris Dumez  <cdumez@apple.com>

        Make Vector(const Vector<T, otherCapacity, otherOverflowBehaviour>&) constructor explicit
        https://bugs.webkit.org/show_bug.cgi?id=143970

        Reviewed by Darin Adler.

        Make Vector(const Vector<T, otherCapacity, otherOverflowBehaviour>&)
        constructor explicit as it copies the vector and it is easy to call it
        by mistake.

        * wtf/RefCountedArray.h:
        (WTF::RefCountedArray::RefCountedArray):
        * wtf/Vector.h:

2015-04-21  Darin Adler  <darin@apple.com>

        Remove some stray uses of OwnPtr and PassOwnPtr in WTF (outside of the template definitions and traits)
        https://bugs.webkit.org/show_bug.cgi?id=143944

        Reviewed by Andreas Kling.

        * wtf/FilePrintStream.h: Removed unneeded include.
        * wtf/HashTable.h: Fixed class template name in comment.
        * wtf/HashTraits.h: Removed unneeded forward declaration.
        * wtf/ListHashSet.h: Removed unneeded includes.
        * wtf/ThreadingWin.cpp: Removed unneeded includes.
        (WTF::wtfThreadEntryPoint): Changed code to use unique_ptr.
        (WTF::createThreadInternal): Changed code to use make_unique and release.
        * wtf/efl/RunLoopEfl.cpp: Removed unneeded includes.

2015-04-19  Darin Adler  <darin@apple.com>

        Update RefPtr documentation and deprecation
        https://bugs.webkit.org/show_bug.cgi?id=143936

        Reviewed by Andreas Kling.

        * WTF.vcxproj/WTF.vcxproj: Removed PassRef.h
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * WTF.xcodeproj/project.pbxproj: Ditto.
        * wtf/CMakeLists.txt: Ditto.

2015-04-17  Alexey Proskuryakov  <ap@apple.com>

        Use ASan poisoning to taint moved-out-of Refs
        https://bugs.webkit.org/show_bug.cgi?id=143894
        rdar://problem/19443723

        Reviewed by Darin Adler.

        * wtf/Ref.h: (WTF::Ref::~Ref):

2015-04-17  Alexey Proskuryakov  <ap@apple.com>

        Remove unused BoundsCheckedPointer
        https://bugs.webkit.org/show_bug.cgi?id=143896

        Reviewed by Geoffrey Garen.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/BoundsCheckedPointer.h: Removed.
        * wtf/CMakeLists.txt:

2015-04-16  Yusuke Suzuki  <utatane.tea@gmail.com>

        [ES6] Implement Symbol.for and Symbol.keyFor
        https://bugs.webkit.org/show_bug.cgi?id=143404

        Reviewed by Geoffrey Garen.

        When we register symbolized StringImpl* into SymbolRegistry, symbolized StringImpl* is aware of that.
        And when destructing it, it removes its reference from SymbolRegistry as if atomic StringImpl do so with AtomicStringTable.
        While AtomicStringTable (in WebCore case) exists in thread local storage,
        SymbolRegistry exists per VM and StringImpl* has a reference to the registered SymbolRegistry.

        Since StringImpl has isSymbol etc. members, it's class is aware of Symbol use cases.
        So introduce SymbolRegistry in WTF layers as if AtomicStringTable.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::addSlowCase):
        (WTF::AtomicString::findSlowCase):
        (WTF::AtomicString::findInternal):
        (WTF::AtomicString::find): Deleted.
        * wtf/text/AtomicString.h:
        (WTF::AtomicString::find):
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl):
        (WTF::StringImpl::createSymbol):
        (WTF::StringImpl::createSymbolEmpty):
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):
        (WTF::StringImpl::extractFoldedStringInSymbol):
        (WTF::StringImpl::symbolRegistry):
        (WTF::StringImpl::createSymbolEmpty): Deleted.
        * wtf/text/SymbolRegistry.cpp: Copied from Source/JavaScriptCore/runtime/SymbolConstructor.h.
        (WTF::SymbolRegistry::~SymbolRegistry):
        (WTF::SymbolRegistry::symbolForKey):
        (WTF::SymbolRegistry::keyForSymbol):
        (WTF::SymbolRegistry::remove):
        * wtf/text/SymbolRegistry.h: Added.
        (WTF::SymbolRegistryKey::hash):
        (WTF::SymbolRegistryKey::impl):
        (WTF::SymbolRegistryKey::isHashTableDeletedValue):
        (WTF::SymbolRegistryKey::hashTableDeletedValue):
        (WTF::DefaultHash<SymbolRegistryKey>::Hash::hash):
        (WTF::DefaultHash<SymbolRegistryKey>::Hash::equal):
        (WTF::HashTraits<SymbolRegistryKey>::isEmptyValue):
        (WTF::SymbolRegistryKey::SymbolRegistryKey):

2015-04-16  Antti Koivisto  <antti@apple.com>

        Use CommonCrypto for SHA1 and MD5
        https://bugs.webkit.org/show_bug.cgi?id=143826

        Reviewed by Anders Carlsson.

        CommonCrypto SHA1 implementation is ~4x faster than the naive WTF one. Use it when available.

        These are covered by existing API tests.

        * wtf/MD5.cpp:
        (WTF::MD5::MD5):
        (WTF::MD5::addBytes):
        (WTF::MD5::checksum):
        * wtf/MD5.h:
        * wtf/SHA1.cpp:
        (WTF::SHA1::SHA1):
        (WTF::SHA1::addBytes):
        (WTF::SHA1::computeHash):

            Remove the side effect where computeHash resets the state. No one relies on it.

        (WTF::SHA1::hexDigest):
        (WTF::SHA1::computeHexDigest):
        * wtf/SHA1.h:

2015-04-16  Csaba Osztrogonác  <ossy@webkit.org>

        Remove the unnecessary WTF_CHANGES define
        https://bugs.webkit.org/show_bug.cgi?id=143825

        Reviewed by Andreas Kling.

        * config.h:

2015-04-15  Руслан Ижбулатов  <lrn1986@gmail.com>

        Harmonize binary semaphore ifdefs

        They should be either OS(WINDOWS) (in which case we'd need
        BinarySemaphoreWin.cpp, which is not shipped by WebKitGTK)
        or PLATFORM(WIN) (in which case Mutex/ThreadCondition-based
        implementation is used).

        This fixes errors like:
          CXX      Source/WTF/wtf/threads/libWTF_la-BinarySemaphore.lo
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp: In constructor 'WTF::BinarySemaphore::BinarySemaphore()':
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:34:7: error: class 'WTF::BinarySemaphore' does not have any field named 'm_isSet'
             : m_isSet(false)
               ^
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp: In member function 'void WTF::BinarySemaphore::signal()':
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:44:24: error: 'm_mutex' was not declared in this scope
             MutexLocker locker(m_mutex);
                                ^
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:46:5: error: 'm_isSet' was not declared in this scope
             m_isSet = true;
             ^
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:47:5: error: 'm_condition' was not declared in this scope
             m_condition.signal();
             ^
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp: In member function 'bool WTF::BinarySemaphore::wait(double)':
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:52:24: error: 'm_mutex' was not declared in this scope
             MutexLocker locker(m_mutex);
                                ^
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:55:13: error: 'm_isSet' was not declared in this scope
             while (!m_isSet) {
                     ^
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:56:21: error: 'm_condition' was not declared in this scope
                 timedOut = !m_condition.timedWait(m_mutex, absoluteTime);
                             ^
        ../webkitgtk-2.4.8/Source/WTF/wtf/threads/BinarySemaphore.cpp:62:5: error: 'm_isSet' was not declared in this scope
             m_isSet = false;
             ^
        GNUmakefile:52762: recipe for target 'Source/WTF/wtf/threads/libWTF_la-BinarySemaphore.lo' failed

        [W32] Inconsistent ifdefs in BinarySemaphore.h and BinarySemaphore.cpp
        https://bugs.webkit.org/show_bug.cgi?id=143756

        Reviewed by Darin Adler.

        * wtf/threads/BinarySemaphore.h:

2015-04-12  Michael Catanzaro  <mcatanzaro@igalia.com>

        Fix -Wparentheses warning with GCC 5 in SaturatedArithmetic.h
        https://bugs.webkit.org/show_bug.cgi?id=143457

        Reviewed by Benjamin Poulain.

        Tested by WTF.SaturatedArithmeticAddition and WTF.SaturatedArithmeticSubtraction.

        * wtf/SaturatedArithmetic.h:
        (signedAddOverflows): Use && instead of & to avoid triggering -Wparentheses in newer
        versions of GCC and Clang, and to improve the clarity of the function.
        (signedSubtractOverflows): Changed correspondingly, although there was no warning here.

2015-04-08  Sam Weinig  <sam@webkit.org>

        Allow LaunchServices to handle URLs on link navigations
        <rdar://problem/19446826>
        https://bugs.webkit.org/show_bug.cgi?id=143544

        Reviewed by Anders Carlsson.

        * wtf/Platform.h:
        Add HAVE macro for this functionality.

2015-04-09  Andy Estes  <aestes@apple.com>

        [Cocoa] Add a HAVE(AVKIT) and use it
        https://bugs.webkit.org/show_bug.cgi?id=143593

        Reviewed by David Kilzer.

        * wtf/Platform.h: Defined HAVE(AVKIT) to be true on all Cocoa platforms except Watch OS.

2015-04-09  Andy Estes  <aestes@apple.com>

        [Content Filtering] Add a HAVE(PARENTAL_CONTROLS) and use it
        https://bugs.webkit.org/show_bug.cgi?id=143559

        Reviewed by David Kilzer.

        Added PLATFORM(WATCHOS). Used PLATFORM() since Watch OS is just a variant of OS(IOS).
        Defined HAVE(PARENTAL_CONTROLS) to be true on all Cocoa platforms except Watch OS.

        * wtf/Platform.h:

2015-04-08  Alex Christensen  <achristensen@webkit.org> and Patrick Gansterer  <paroga@webkit.org>

        Add CMake build system for WinCairo port.
        https://bugs.webkit.org/show_bug.cgi?id=115944

        Reviewed by Chris Dumez.

        * wtf/FeatureDefines.h:
        * wtf/PlatformWin.cmake:

2015-04-05  Antti Koivisto  <antti@apple.com>

        Bloom filter should support longer hashes
        https://bugs.webkit.org/show_bug.cgi?id=143419

        Reviewed by Dan Bernstein.

        It currently supports 'unsigned' hash only which is inconvenient and doesn't have enough independent bits for larger filters.

        Support arbitrarily sized hashes of type std::array<uint8_t, hashSize> (like SHA1::Digest and MD5::Digest).

        * wtf/BloomFilter.h:
        (WTF::BloomFilter<keyBits>::keysFromHash):
        (WTF::BloomFilter<keyBits>::mayContain):
        (WTF::BloomFilter<keyBits>::add):

2015-04-03  Antti Koivisto  <antti@apple.com>

        Add non-counting Bloom filter implementation
        https://bugs.webkit.org/show_bug.cgi?id=143366

        Reviewed by Sam Weinig.

        Add a traditional single-bit-per-bucket Bloom filter in addition to the existing counting implementation.

        - rename BloomFilter -> CountingBloomFilter.
        - add a new basic BloomFilter type.
        - update some terminology to match http://en.wikipedia.org/wiki/Bloom_filter and modernize the code a bit.
        - add API tests.

        * wtf/BloomFilter.h:
        (WTF::BloomFilter::BloomFilter):
        (WTF::BloomFilter::add):

            Also support merging.

        (WTF::BloomFilter::mayContain):
        (WTF::BloomFilter::arrayIndex):
        (WTF::BloomFilter::bitMask):
        (WTF::BloomFilter<keyBits>::mayContain):
        (WTF::BloomFilter<keyBits>::add):
        (WTF::BloomFilter<keyBits>::isBitSet):
        (WTF::BloomFilter<keyBits>::setBit):
        (WTF::BloomFilter<keyBits>::clear):
        (WTF::CountingBloomFilter::CountingBloomFilter):
        (WTF::CountingBloomFilter::mayContain):
        (WTF::CountingBloomFilter::firstBucket):
        (WTF::CountingBloomFilter::secondBucket):
        (WTF::CountingBloomFilter<keyBits>::add):
        (WTF::CountingBloomFilter<keyBits>::remove):
        (WTF::CountingBloomFilter<keyBits>::clear):
        (WTF::CountingBloomFilter<keyBits>::likelyEmpty):
        (WTF::CountingBloomFilter<keyBits>::isClear):
        (WTF::BloomFilter::maximumCount): Deleted.
        (WTF::BloomFilter::firstSlot): Deleted.
        (WTF::BloomFilter::secondSlot): Deleted.
        (WTF::BloomFilter<keyBits>::remove): Deleted.
        (WTF::BloomFilter<keyBits>::likelyEmpty): Deleted.
        (WTF::BloomFilter<keyBits>::isClear): Deleted.

015-04-01  Antti Koivisto  <antti@apple.com>

        Value assignment operator of Optional should be stricter
        https://bugs.webkit.org/show_bug.cgi?id=143303

        Reviewed by Andreas Kling.

        struct Foo { mutable Optional<std::chrono::seconds> s; };
        Foo foo, foo2;
        foo = foo2;

        doesn't build because it tries to use wrong operator=.

        * wtf/Optional.h:

            Add enable_if test similar to std::experimental::optional.

2015-04-01  Alex Christensen  <achristensen@webkit.org>

        Progress towards CMake on Windows and Mac.
        https://bugs.webkit.org/show_bug.cgi?id=143293

        Reviewed by Filip Pizlo.

        * wtf/CMakeLists.txt:
        Don't use bmalloc on Windows yet.
        * wtf/FeatureDefines.h:
        Temporarily disabled WebGL on Windows CMake builds.
        * wtf/PlatformMac.cmake:
        Tell open source builders where to find unicode headers.

2015-03-31  Alexey Proskuryakov  <ap@apple.com>

        Fix the build after <http://trac.webkit.org/changeset/182205>.

        * wtf/text/StringImpl.h: (WTF::StringImpl::extractFoldedStringInSymbol):
        A function cannot be both exported and inline.

2015-03-31  Yusuke Suzuki  <utatane.tea@gmail.com>

        Clean up Identifier factories to clarify the meaning of StringImpl*
        https://bugs.webkit.org/show_bug.cgi?id=143146

        Reviewed by Filip Pizlo.

        Introduce StringKind into `StringImpl`. There's 3 kinds
        1. StringNormal (non-atomic, non-symbol)
        2. StringAtomic (atomic, non-symbol)
        3. StringSymbol (non-atomic, symbol)
        They are mutually exclusive.

        * wtf/text/AtomicString.cpp:
        (WTF::AtomicString::addSlowCase):
        (WTF::AtomicString::findSlowCase):
        When registering a string into AtomicStringTable,
        it should not be a symbol string
        because symbol and atomic types are mutually exclusive.
        When a symbol string comes, we extract an owner string
        from a symbol string by using `StringImpl::extractFoldedStringInSymbol()`.
        It always succeeds because a symbol (non empty) string
        is always BufferSubstring and has an owner string.
        Empty symbol string doesn't have an owner string.
        This case is filtered by `!string.length()` guard.
        * wtf/text/AtomicString.h:
        (WTF::AtomicString::add):
        (WTF::AtomicString::addWithStringTableProvider):
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl):
        (WTF::StringImpl::createSymbol):
        (WTF::StringImpl::createUnique): Deleted.
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):
        (WTF::StringImpl::createSymbolEmpty):
        (WTF::StringImpl::flagIsAtomic):
        (WTF::StringImpl::flagIsSymbol):
        (WTF::StringImpl::maskStringKind):
        (WTF::StringImpl::stringKind):
        (WTF::StringImpl::isSymbol):
        (WTF::StringImpl::isAtomic):
        (WTF::StringImpl::setIsAtomic):
        (WTF::StringImpl::extractFoldedStringInSymbol):
        (WTF::StringImpl::createUniqueEmpty): Deleted.
        (WTF::StringImpl::flagIsUnique): Deleted.
        (WTF::StringImpl::isUnique): Deleted.
        * wtf/text/StringStatics.cpp:
        (WTF::StringImpl::hashAndFlagsForSymbol):
        (WTF::StringImpl::hashAndFlagsForUnique): Deleted.

2015-03-30  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [CMake][EFL] Remove redundant library link and include path
        https://bugs.webkit.org/show_bug.cgi?id=143221

        Reviewed by Csaba Osztrogonác.

        * wtf/PlatformEfl.cmake: Remove unnecessary library link and include path.

2015-03-27  Myles C. Maxfield  <mmaxfield@apple.com>

        Support building WTF on Windows without Cygwin
        https://bugs.webkit.org/show_bug.cgi?id=143084

        Reviewed by Brent Fulgham.

        Windows doesn't have "touch".

        * WTF.vcxproj/WTFGenerated.make:

2015-03-26  Alex Christensen  <achristensen@webkit.org>

        Progress towards CMake on Mac.
        https://bugs.webkit.org/show_bug.cgi?id=143112

        Reviewed by Chris Dumez.

        * wtf/PlatformMac.cmake:

2015-03-25  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, we have edited this file in 2015.

        * wtf/Platform.h:

2015-03-25  Filip Pizlo  <fpizlo@apple.com>

        Heap variables shouldn't end up in the stack frame
        https://bugs.webkit.org/show_bug.cgi?id=141174

        Reviewed by Geoffrey Garen.

        * wtf/FastBitVector.h:
        (WTF::FastBitVector::resize): Small change: don't resize if you don't have to resize.

2015-03-25  Filip Pizlo  <fpizlo@apple.com>

        Change Atomic methods from using the_wrong_naming_conventions to using theRightNamingConventions. Also make seq_cst the default.

        Rubber stamped by Geoffrey Garen.

        * wtf/Atomics.h:
        (WTF::Atomic::load):
        (WTF::Atomic::store):
        (WTF::Atomic::compareExchangeWeak):
        (WTF::Atomic::compareExchangeStrong):
        (WTF::Atomic::compare_exchange_weak): Deleted.
        (WTF::Atomic::compare_exchange_strong): Deleted.
        * wtf/ByteSpinLock.h:
        (WTF::ByteSpinLock::lock):
        * wtf/SpinLock.h:
        (WTF::SpinLockBase::lock):

2015-03-24  Beth Dakin  <bdakin@apple.com>

        Add events related to force click gesture
        https://bugs.webkit.org/show_bug.cgi?id=142836
        -and corresponding-
        rdar://problem/20210239

        Reviewed by Dean Jackson.

        New enable flag for the events.
        * wtf/FeatureDefines.h:

2015-03-23  Filip Pizlo  <fpizlo@apple.com>

        JSC should have a low-cost asynchronous disassembler
        https://bugs.webkit.org/show_bug.cgi?id=142997

        Reviewed by Mark Lam.

        * wtf/StringPrintStream.h:

2015-03-22  Benjamin Poulain  <benjamin@webkit.org>

        CSS Selectors: fix attribute case-insensitive matching of Contain and List
        https://bugs.webkit.org/show_bug.cgi?id=142932

        Reviewed by Darin Adler.

        Add some utility functions to the string classes to find substrings
        using ASCII case-insensitive comparisons.

        * wtf/text/AtomicString.h:
        (WTF::AtomicString::contains):
        Add the light version that only lock one register.

        (WTF::AtomicString::containsIgnoringASCIICase):
        (WTF::AtomicString::findIgnoringASCIICase):

        * wtf/text/StringCommon.h:
        (WTF::findIgnoringASCIICase):
        This is the common implementation used by StringView and StringImpl.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::findIgnoringASCIICase):
        * wtf/text/StringImpl.h:
        * wtf/text/StringView.cpp:
        (WTF::StringView::containsIgnoringASCIICase):
        (WTF::StringView::findIgnoringASCIICase):
        * wtf/text/StringView.h:
        * wtf/text/WTFString.h:
        (WTF::String::findIgnoringASCIICase):
        (WTF::String::contains):
        (WTF::String::containsIgnoringASCIICase):

2015-03-19  Andreas Kling  <akling@apple.com>

        DFGAllocator should use bmalloc's aligned allocator.
        <https://webkit.org/b/142871>

        Reviewed by Geoffrey Garen.

        Remove PageAllocationAligned since it has no more clients.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/PageAllocationAligned.cpp: Removed.
        * wtf/PageAllocationAligned.h: Removed.

2015-03-18  Dhi Aurrahman  <diorahman@rockybars.com>

        Fix StringView misplaced implementations after r181525 and r181558
        https://bugs.webkit.org/show_bug.cgi?id=142772

        Reviewed by Darin Adler.

        Fix misplaced implementations in StringView::startsWithIgnoringASCIICase and 
        StringView::endsWith. 

        Add some tests in [1] to cover the StringView::startsWith, 
        StringView::startsWithIgnoringASCIICase, StringView::endsWith and 
        StringView::endsWithIgnoringASCIICase implementations.

        [1] Tools/TestWebKitAPI/Tests/WTF/StringView.cpp.

        * wtf/text/StringView.cpp:
        (WTF::StringView::startsWithIgnoringASCIICase):
        (WTF::StringView::endsWith):
        (WTF::StringView::endsWithIgnoringASCIICase):

2015-03-17  Michael Saboff  <msaboff@apple.com>

        Windows X86-64 should use the fixed executable allocator
        https://bugs.webkit.org/show_bug.cgi?id=142749

        Reviewed by Filip Pizlo.

        Set ENABLE_EXECUTABLE_ALLOCATOR_FIXED for Windows.
        Needed to export MetaAllocator::currentStatistics() for use in JavaScriptCore.

        * wtf/MetaAllocator.h:
        * wtf/Platform.h:

2015-03-16  Ryosuke Niwa  <rniwa@webkit.org>

        Enable ES6 classes by default
        https://bugs.webkit.org/show_bug.cgi?id=142774

        Reviewed by Gavin Barraclough.

        * wtf/FeatureDefines.h:

2015-03-16  Csaba Osztrogonác  <ossy@webkit.org>

        [ARM] Enable generating idiv instructions if it is supported
        https://bugs.webkit.org/show_bug.cgi?id=142725

        Reviewed by Michael Saboff.

        * wtf/Platform.h: Set HAVE_ARM_IDIV_INSTRUCTIONS based on GCC macro too.

2015-03-16  Benjamin Poulain  <benjamin@webkit.org>

        Fix StringView after r181525
        Unreviewed.

        Fix 2 silly mistakes I made in r181525.

        * wtf/text/StringView.cpp:
        (WTF::StringView::startsWith):
        (WTF::StringView::startsWithIgnoringASCIICase):
        (WTF::StringView::endsWith):
        (WTF::StringView::endsWithIgnoringASCIICase):
        The implementation was inside the #ifdef.

        * wtf/text/StringView.h:
        The symbols were not exported.

2015-03-16  Max Stepin  <maxstepin@gmail.com>

        Add APNG support
        https://bugs.webkit.org/show_bug.cgi?id=17022

        Reviewed by Carlos Garcia Campos.

        * wtf/FeatureDefines.h:

2015-03-15  Benjamin Poulain  <benjamin@webkit.org>

        CSS: fix the case-insensitive matching of the attribute selectors Begin, End and Hyphen
        https://bugs.webkit.org/show_bug.cgi?id=142715

        Reviewed by Brent Fulgham.

        Add the necessary infrastructure to test startsWith() and endsWith() with
        ASCII case-insentive comparisons.

        * wtf/text/AtomicString.h:
        (WTF::AtomicString::startsWith):
        (WTF::AtomicString::startsWithIgnoringASCIICase):
        (WTF::AtomicString::endsWith):
        (WTF::AtomicString::endsWithIgnoringASCIICase):

        * wtf/text/StringCommon.h:
        (WTF::loadUnaligned):
        (WTF::equal):
        I moved the low level equal() code from StringImpl to StringCommon
        since it is used by both StringImpl and StringView.

        (WTF::equalCommon):
        (WTF::equalIgnoringASCIICaseCommon):
        Ideally we should drop the "Common" part of the name but StringView
        wants this inline for some reason. I prefered keeping the current behavior
        since I don't know how StringView's matching performance was evaluated.

        (WTF::startsWith):
        (WTF::startsWithIgnoringASCIICase):
        (WTF::endsWith):
        (WTF::endsWithIgnoringASCIICase):
        Make all that code shared between StringView and Stringimpl.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::startsWith):
        (WTF::StringImpl::startsWithIgnoringASCIICase):
        (WTF::StringImpl::endsWith):
        (WTF::StringImpl::endsWithIgnoringASCIICase):
        (WTF::equal):
        (WTF::stringImplContentEqual): Deleted.
        * wtf/text/StringImpl.h:
        (WTF::loadUnaligned): Deleted.
        (WTF::equal): Deleted.

        * wtf/text/StringView.cpp:
        (WTF::StringView::startsWith):
        (WTF::StringView::startsWithIgnoringASCIICase):
        (WTF::StringView::endsWith):
        (WTF::StringView::endsWithIgnoringASCIICase):
        * wtf/text/StringView.h:
        Since those are new, we can safely make them out-of-line and
        evaluate the inlining impact as needed.

        * wtf/text/WTFString.h:
        (WTF::String::startsWithIgnoringASCIICase):
        (WTF::String::endsWith):
        (WTF::String::endsWithIgnoringASCIICase):

2015-03-15  Benjamin Poulain  <bpoulain@apple.com>

        Change the exact attribute matching to be ASCII case-insensitive
        https://bugs.webkit.org/show_bug.cgi?id=142609

        Reviewed by Darin Adler.

        Add support for ASCII case insensitive comparisons to all the string
        classes.

        The new file StringCommon.h has the common algorithm to avoid repeating
        the same code with different types.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * wtf/ASCIICType.h:
        (WTF::toASCIILower):
        * wtf/CMakeLists.txt:
        * wtf/text/AtomicString.h:
        (WTF::equalIgnoringASCIICase):
        * wtf/text/StringCommon.h: Added.
        (WTF::equalIgnoringASCIICase):
        (WTF::equalIgnoringASCIICaseCommon):
        * wtf/text/StringImpl.cpp:
        (WTF::equalIgnoringASCIICase):
        (WTF::equalIgnoringASCIICaseNonNull):
        (WTF::StringImpl::utf8Impl):
        (WTF::StringImpl::defaultWritingDirection): Deleted.
        (WTF::StringImpl::adopt): Deleted.
        (WTF::StringImpl::sizeInBytes): Deleted.
        (WTF::putUTF8Triple): Deleted.
        (WTF::StringImpl::utf8): Deleted.
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::isSubString): Deleted.
        (WTF::find): Deleted.

2015-03-14  Michael Saboff  <msaboff@apple.com>

        Disable Yarr JIT for ARMv7k
        https://bugs.webkit.org/show_bug.cgi?id=142645

        Rubber stamped by Geoffrey Garen.

        Changed the setting of ENABLE_YARR_JIT to be predicated on ENABLED_JIT.

        * wtf/Platform.h:

2015-03-14  Michael Saboff  <msaboff@apple.com>

        ES6: Add binary and octal literal support
        https://bugs.webkit.org/show_bug.cgi?id=142681

        Reviewed by Ryosuke Niwa.

        * wtf/ASCIICType.h:
        (WTF::isASCIIBinaryDigit): New support function.
        (WTF::isASCIIOctalDigit): Updated to use logical and (&&) instead of binary and (&).

2015-03-13  Mark Lam  <mark.lam@apple.com>

        Replace TCSpinLock with a new WTF::SpinLock based on WTF::Atomic.
        <https://webkit.org/b/142674>

        Reviewed by Filip Pizlo.

        We no longer use TCMalloc in our code, and we now have C++11.  This replaces the
        TCMalloc_SpinLock with a new WTF::SpinLock based on WTF::Atomic (which is a
        wrapper around std::atomic).

        Note that there is a StaticSpinLock and a SpinLock:

        1. StaticSpinLock is an alias for SpinLockBase, and its initialization relies on
           static / global std:atomic being automatically initialized to 0 at compile time.
           Hence, StaticSpinLock should only be used for statics / globals (including
           static members of classes / structs).

        2. SpinLock is derived from SpinLockBase, and adds a default constructor to
           initialize its internal atomic value to 0.  Because SpinLock has a constructor,
           it cannot be used for statics / globals.  Objects that want to embed a spin
           lock as an instance field should use SpinLock so that it is initialized properly.
           std::atomic will not automatically initialize instance fields to 0.  Hence,
           StaticSpinLock will not work correctly as instance fields of a class / struct.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/MetaAllocator.cpp:
        (WTF::MetaAllocator::~MetaAllocator):
        (WTF::MetaAllocator::MetaAllocator):
        * wtf/MetaAllocator.h:
        * wtf/SpinLock.h: Added.
        (WTF::SpinLockBase::lock):
        (WTF::SpinLockBase::unlock):
        (WTF::SpinLockBase::isLocked):
        (WTF::SpinLockBase::slowLock):
        (WTF::SpinLock::SpinLock):
        * wtf/TCSpinLock.h: Removed.
        * wtf/text/AtomicString.cpp:

2015-03-13  Mark Lam  <mark.lam@apple.com>

        Introduce WTF::Atomic to wrap std::atomic for a friendlier CAS.
        <https://webkit.org/b/142661>

        Reviewed by Filip Pizlo.

        The CAS functions provided by std::atomic takes a reference to the expected
        value and modifies it if the CAS fails.  However, in a lot of our CAS usage,
        we don't want the expected value to change.  The solution to this is to
        provide a WTF::Atomic struct that wraps std::atomic, and provide CAS
        methods that won't alter the expected value if the CAS fails.

        The method names in WTF::Atomic are chosen to be identical to those
        in std::atomic so that WTF::Atomic can be a simple drop in replacement
        for std::atomic.

        Also changed ByteSpinLock to use WTF::Atomic instead of std::atomic.

        * wtf/Atomics.h:
        (WTF::Atomic::load):
        (WTF::Atomic::store):
        (WTF::Atomic::compare_exchange_weak):
        (WTF::Atomic::compare_exchange_strong):
        * wtf/ByteSpinLock.h:
        (WTF::ByteSpinLock::ByteSpinLock):
        (WTF::ByteSpinLock::lock):

2015-03-12  Filip Pizlo  <fpizlo@apple.com>

        Bytecode liveness analysis should have more lambdas and fewer sets
        https://bugs.webkit.org/show_bug.cgi?id=142647

        Reviewed by Mark Lam.
        
        Add a method for iterating each set bit in a FastBitVector. Uses a functor as a callback since
        this allows for a more efficient algorithm.

        * wtf/FastBitVector.h:
        (WTF::FastBitVector::forEachSetBit):

2015-03-12  Michael Saboff  <msaboff@apple.com>

        Disable Yarr JIT for ARMv7k
        https://bugs.webkit.org/show_bug.cgi?id=142645

        Reviewed by Oliver Hunt.

        Make the setting of ENABLE_YARR_JIT match ENABLE_JIT for ARMv7k.

        * wtf/Platform.h:

2015-03-12  Mark Lam  <mark.lam@apple.com>

        Change WTF::ByteSpinLock to use std::atomic.
        <https://webkit.org/b/142644>

        Reviewed by Filip Pizlo.

        * wtf/ByteSpinLock.h:
        (WTF::ByteSpinLock::ByteSpinLock):
        (WTF::ByteSpinLock::lock):
        (WTF::ByteSpinLock::unlock):
        (WTF::ByteSpinLock::isHeld):

2015-03-12  Csaba Osztrogonác  <ossy@webkit.org>

        [ARM][Linux] GC sometimes stuck in an infinite loop if parallel GC is enabled
        https://bugs.webkit.org/show_bug.cgi?id=141290

        Reviewed by Carlos Garcia Campos.

        * wtf/Platform.h: Enable parallel GC after r181319.

2015-03-11  Myles C. Maxfield  <mmaxfield@apple.com>

        Use out-of-band messaging for RenderBox::firstLineBaseline() and RenderBox::inlineBlockBaseline()
        https://bugs.webkit.org/show_bug.cgi?id=142569

        Reviewed by David Hyatt.

        Provide a callback to Optional::valueOrCompute() which is evaluated only if necessary.

        * wtf/Optional.h:
        (WTF::Optional::valueOrCompute):

2015-03-10  Brent Fulgham  <bfulgham@apple.com>

        [Win] 17 different JSC tests started to fail in DST
        https://bugs.webkit.org/show_bug.cgi?id=142531

        Reviewed by Chris Dumez.

        The stock 'GetTimeZoneInformation' call does not always match the actual Daylight
        Savings calendar. This results in a period of time when these tests fail.

        If available, we should take advantage of the new 'GetTimeZoneInformationForYear',
        which accesses a dynamic calendar of DST dates, which is presumbably updated by
        Microsoft from year-to-year.

        * wtf/DateMath.cpp:
        (WTF::timeZoneInformationForYearFunction): New function to conditionally access
        some Vista (and newer) functionality.
        (WTF::calculateUTCOffset): Call new function (if available) to calculate proper UTC
        time offset.

2015-03-10  Alex Christensen  <achristensen@webkit.org>

        Use unsigned for HashSet size.
        https://bugs.webkit.org/show_bug.cgi?id=142518

        Reviewed by Benjamin Poulain.

        * wtf/HashCountedSet.h:
        (WTF::Traits>::size):
        (WTF::Traits>::capacity):
        * wtf/HashMap.h:
        (WTF::X>::size):
        (WTF::X>::capacity):
        * wtf/HashSet.h:
        (WTF::V>::size):
        (WTF::V>::capacity):
        * wtf/HashTable.h:
        (WTF::HashTable::Stats::recordCollisionAtCount):
        (WTF::HashTable::Stats::dumpStats):
        (WTF::HashTable::size):
        (WTF::HashTable::capacity):
        (WTF::KeyTraits>::deallocateTable):
        (WTF::KeyTraits>::checkTableConsistencyExceptSize):
        * wtf/HashTraits.h:
        * wtf/ListHashSet.h:
        (WTF::U>::size):
        (WTF::U>::capacity):

2015-03-10  Said Abou-Hallawa  <sabouhallawa@apple.com>

        Remove PassRefPtr from svg/properties classes.
        https://bugs.webkit.org/show_bug.cgi?id=142063.

        Reviewed by Darin Adler.

        * wtf/Ref.h:
        (WTF::static_reference_cast): Add a stat_cast function to Ref<>.

2015-03-10  Mark Lam  <mark.lam@apple.com>

        [Win] JSC Build Warnings Need to be Resolved.
        <https://webkit.org/b/142366>

        Reviewed by Brent Fulgham.

        * wtf/Compiler.h:
        - MSVC also does not have the CONSIDERS_UNREACHABLE_CODE quirk.

2015-03-10  Geoffrey Garen  <ggaren@apple.com>

        bmalloc: tryFastMalloc shouldn't crash
        https://bugs.webkit.org/show_bug.cgi?id=142443

        Reviewed by Sam Weinig.

        Rolling back in r181307 with a check for whether bmalloc is enabled, to
        avoid crashes when running with ASan and GuardMalloc.

        * wtf/FastMalloc.cpp:
        (WTF::fastMalloc):
        (WTF::fastRealloc):
        (WTF::fastAlignedMalloc):
        (WTF::tryFastMalloc):
        (WTF::tryFastRealloc): Deleted.
        * wtf/FastMalloc.h:

2015-03-10  Michael Catanzaro  <mcatanzaro@igalia.com>

        GCC: CRASH() should be annotated with NORETURN
        https://bugs.webkit.org/show_bug.cgi?id=142524

        Reviewed by Anders Carlsson.

        Add COMPILER(GCC) to #ifdefs that already exist for Clang.

        * wtf/Assertions.cpp:
        * wtf/Assertions.h:

2015-03-09  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r181307.
        https://bugs.webkit.org/show_bug.cgi?id=142525

        Broke ASan tests (Requested by ap on #webkit).

        Reverted changeset:

        "bmalloc: tryFastMalloc shouldn't crash"
        https://bugs.webkit.org/show_bug.cgi?id=142443
        http://trac.webkit.org/changeset/181307

2015-03-09  Geoffrey Garen  <ggaren@apple.com>

        bmalloc: tryFastMalloc shouldn't crash
        https://bugs.webkit.org/show_bug.cgi?id=142443

        Reviewed by Darin Adler.

        * wtf/FastMalloc.cpp:
        (WTF::fastMalloc):
        (WTF::fastRealloc):
        (WTF::fastAlignedMalloc): Don't check for null. bmalloc automatically
        crashes on allocation failure, and we'd rather not pay for an extra check.

        (WTF::tryFastMalloc): Added an opt-out API to return null rather than
        crashing, since some clients need this.

        (WTF::tryFastRealloc): Deleted. Unused.

        * wtf/FastMalloc.h:

2015-03-09  Mark Lam  <mark.lam@apple.com>

        8-bit version of weakCompareAndSwap() can cause an infinite loop.
        https://webkit.org/b/142513>

        Reviewed by Filip Pizlo.

        Presently, Bitmap::concurrentTestAndSet() uses the 8-bit version of
        weakCompareAndSwap() (which compares and swaps an uint8_t value).
        Bitmap::concurrentTestAndSet() has a loop that checks if a bit in the
        byte of interest has been set.  If not, it will call the 8-bit CAS
        function to set the bit.

        Under the covers, for ARM, the 8-bit CAS function actually works with a
        32-bit CAS.  The 8-bit CAS will first fetch the 32-bit value in memory
        that should contain the 8-bit value, and check if it contains the
        expected byte.  If the value in memory doesn't have the expected byte,
        it will return early to its caller.  The expectation is that the caller
        will reload the byte from memory and call the 8-bit CAS again.

        Unfortunately, this code path that returns early does not have a
        compiler fence.  Without a compiler fence, the C++ compiler can
        optimize away the reloading of the expected byte value, leaving it
        unchanged.  As a result, we'll have a infinite loop here that checks a
        value that will never change, and the loop will not terminate until the
        value changes.

        The fix is to eliminate the early return check in the 8-bit CAS, and
        have it always call down to the 32-bit CAS.  The 32-bit CAS has a
        compiler fence which will prevent this issue.

        * wtf/Atomics.h:
        (WTF::weakCompareAndSwap):

2015-03-09  Martin Robinson  <mrobinson@igalia.com>

        [EFL] Move DispatchQueue to WTF
        https://bugs.webkit.org/show_bug.cgi?id=142493

        Reviewed by Csaba Osztrogonác.

        * wtf/PlatformEfl.cmake: Add DispatchQueue to the source list.
        * wtf/efl/DispatchQueueEfl.cpp: Renamed from Source/WebKit2/Platform/efl/DispatchQueueEfl.cpp.
        * wtf/efl/DispatchQueueEfl.h: Renamed from Source/WebKit2/Platform/efl/DispatchQueueEfl.h.
        * wtf/efl/DispatchQueueWorkItemEfl.h: Renamed from Source/WebKit2/Platform/efl/DispatchQueueWorkItemEfl.h.

2015-03-08  Brent Fulgham  <bfulgham@apple.com>

        [Win] WTF::WorkQueue does not balance ref/deref properly
        https://bugs.webkit.org/show_bug.cgi?id=142471

        Reviewed by Antti Koivisto.

        Make sure we deref the count when we execute a function in the
        WorkQueue.

        * wtf/win/WorkQueueWin.cpp:
        (WTF::WorkQueue::performWorkOnRegisteredWorkThread):

2015-03-07  Brent Fulgham  <bfulgham@apple.com>

        [Win] Revive WTF::WorkQueue on Windows
        https://bugs.webkit.org/show_bug.cgi?id=142432

        Reviewed by Darin Adler.

        Revive the Windows implementation of WTF::WorkQueue.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * wtf/WorkQueue.h:
        * wtf/win/WorkItemWin.cpp: Added.
        * wtf/win/WorkItemWin.h: Added.
        * wtf/win/WorkQueueWin.cpp: Added.

2015-03-06  Geoffrey Garen  <ggaren@apple.com>

        Fix crashes seen on the the Windows buildbots after my last patch.

        Unreviewed.

        * wtf/FastMalloc.cpp:
        (WTF::fastAlignedMalloc): Let's pass these arguments in the right order.

2015-03-06  Myles C. Maxfield  <mmaxfield@apple.com>

        Crash in -[WebCascadeList objectAtIndex:] + 195
        https://bugs.webkit.org/show_bug.cgi?id=141274

        Reviewed by David Kilzer.

        * wtf/WeakPtr.h:
        (WTF::WeakPtrFactory::createWeakPtr): WebCascadeList uses a const FontCascade,
        and it calls createWeakPtr() on it. Therefore, createWeakPtr has to be marked
        const.
        (WTF::WeakPtrFactory::operator=): Removed because it was broken and had no
        callers

2015-03-06  Simon Fraser  <simon.fraser@apple.com>

        Allow tree dumping functions to be used in release builds by switching a flag
        https://bugs.webkit.org/show_bug.cgi?id=142379

        Reviewed by Zalan Bujtas.

        There are various tree dumping functions that are useful for debugging, and sometimes
        you want to be able to use them in release builds. Currently they are surrounded by
        #ifndef NDEBUG. Change this to #if ENABLE(TREE_DEBUGGING), which is defined to 0 or 1
        in wtf/Platform.h

        * wtf/Platform.h:

2015-03-05  Chris Dumez  <cdumez@apple.com>

        Regression(r173761): ASSERTION FAILED: !is8Bit() in StringImpl::characters16()
        https://bugs.webkit.org/show_bug.cgi?id=142350

        Reviewed by Michael Saboff and Benjamin Poulain.

        Fix ASSERTION FAILED: !is8Bit() in StringImpl::characters16() from
        WTF::equalInner() after r173761. The code was incorrectly assuming that
        if stringImpl is 16-bit, then matchString is 16-bit too, which is not
        correct.

        Also rename WTFString::startsWith() / endsWith() taking an offset to
        hasInfixStartingAt() / hasInfixEndingAt() for clarity. It seems odd
        to call it startsWith even though it won't technically *start* with
        the pattern if the input offset is greater than zero.

        Also drop the caseSensitive argument as it is never used (always true
        at call sites.

        * wtf/text/StringImpl.cpp:
        (WTF::equalInner):
        (WTF::StringImpl::hasInfixStartingAt):
        (WTF::StringImpl::hasInfixEndingAt):
        (WTF::StringImpl::startsWith): Deleted.
        (WTF::StringImpl::endsWith): Deleted.
        * wtf/text/StringImpl.h:
        * wtf/text/WTFString.h:
        (WTF::String::hasInfixStartingAt):
        (WTF::String::hasInfixEndingAt):
        (WTF::String::startsWith): Deleted.
        (WTF::String::endsWith): Deleted.

2015-03-05  Chris Dumez  <cdumez@apple.com>

        NetworkCache efficacy logging is using too much CPU
        https://bugs.webkit.org/show_bug.cgi?id=142186
        <rdar://problem/19632080>

        Reviewed by Antti Koivisto.

        * wtf/HashMap.h:
        (WTF::copyToVector):
        Add copyToVector() utility function for HashMap that uses an std::pair<key, value>
        as element type.

        * wtf/text/WTFString.h:
        (WTF::StringCapture::StringCapture):
        (WTF::StringCapture::operator=):
        Add default constructor and assignment operator to StringCapture so that
        it can be used in a Vector.

2015-03-05  Antti Koivisto  <antti@apple.com>

        Support WorkQueue QOS classes on Mavericks
        https://bugs.webkit.org/show_bug.cgi?id=142328

        Reviewed by Anders Carlsson.

        "The priority of a dispatch queue is inherited from its target queue.  In order to
        change the priority of a queue created with dispatch_queue_create(), use the
        dispatch_get_global_queue() function to obtain a target queue of the desired prior-
        ity."

        * wtf/cocoa/WorkQueueCocoa.cpp:
        (WTF::targetQueueForQOSClass):
        (WTF::WorkQueue::platformInitialize):

2015-03-03  Anders Carlsson  <andersca@apple.com>

        Remove unused compression code
        https://bugs.webkit.org/show_bug.cgi?id=142237

        Reviewed by Geoffrey Garen.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/Compression.cpp: Removed.
        * wtf/Compression.h: Removed.

2015-03-02  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [WK2] Remove unnecessary create() factory functions.
        https://bugs.webkit.org/show_bug.cgi?id=142161

        Reviewed by Chris Dumez.

        We can replace some create() factory functions with std::make_unique(). Because
        it just returns new instance. Even some of those functions have used std::unique_ptr<>
        instead of std::make_unique<>. Fixed all.

        * wtf/efl/WorkQueueEfl.cpp:
        (WorkQueue::dispatch):

2015-03-02  Filip Pizlo  <fpizlo@apple.com>

        DFG compile time measurements should really report milliseconds
        https://bugs.webkit.org/show_bug.cgi?id=142209

        Reviewed by Benjamin Poulain.
        
        This bug was introduced because currentTimeMS() calls were converted to
        monotonicallyIncreasingTime() calls. Perhaps this bug would be less likely if there was a
        monotonicallyIncreasingTimeMS() function available, so this patch adds it.

        * wtf/CurrentTime.h:
        (WTF::monotonicallyIncreasingTimeMS):

2015-02-27  Darin Adler  <darin@apple.com>

        Remove unused PossiblyNull
        https://bugs.webkit.org/show_bug.cgi?id=142124

        Reviewed by Andreas Kling.

        * WTF.vcxproj/WTF.vcxproj: Removed the file.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * WTF.xcodeproj/project.pbxproj: Ditto.
        * wtf/CMakeLists.txt: Ditto.
        * wtf/PossiblyNull.h: Removed.

        * wtf/FastMalloc.h: Moved everything to the left.
        Moved member functions out of the TryMallocReturnValue class definition.
        (WTF::TryMallocReturnValue::operator PossiblyNull<T>): Deleted.
        (WTF::TryMallocReturnValue::getValue): Marked inline, changed to work
        only with pointer types, not arbitrary non-pointer types.

2015-02-26  Brent Fulgham  <bfulgham@apple.com>

        [Win] Make build logs more legible by reducing noise
        https://bugs.webkit.org/show_bug.cgi?id=142034

        Reviewed by Alexey Proskuryakov.

        Modify batch files, makefiles, and DOS commands to remove
        uninteresting/unhelpful output.

        * WTF.vcxproj/WTFGenerated.make:
        * WTF.vcxproj/WTFPreBuild.cmd:
        * WTF.vcxproj/copy-files.cmd:

2015-02-26  Landry Breuil  <landry@openbsd.org>

        Revert bug 19975, now that gcc 4.7 is required.
        https://bugs.webkit.org/show_bug.cgi?id=129927

        Reviewed by Andreas Kling.

        isfinite() and signbit() are provided by gcc's cmath header.

        * wtf/MathExtras.h:

2015-02-26  Csaba Osztrogonác  <ossy@webkit.org>

        UNREACHABLE_FOR_PLATFORM() should be release assert
        https://bugs.webkit.org/show_bug.cgi?id=141904

        Reviewed by Darin Adler.

        * wtf/Assertions.h:
        (UNREACHABLE_FOR_PLATFORM):

2015-02-25  Filip Pizlo  <fpizlo@apple.com>

        Enable concurrent JIT on GTK
        https://bugs.webkit.org/show_bug.cgi?id=142007

        Reviewed by Benjamin Poulain.

        Seems weird that GTK keeps it off. No good reason for that as far as I can tell.

        * wtf/Platform.h:

2015-02-23  Brent Fulgham  <bfulgham@apple.com>

        WTF::WeakPtr should rename 'forgot' to 'clear' and support nullptr assignment
        https://bugs.webkit.org/show_bug.cgi?id=141935

        Reviewed by Myles C. Maxfield.

        * wtf/WeakPtr.h:
        (WTF::WeakPtr::operator=): Added 'nullptr_t' overload.
        (WTF::WeakPtr::clear): Renamed from 'forget'
        (WTF::WeakPtr::forget): Deleted.

2015-02-23  Brent Fulgham  <bfulgham@apple.com>

        WTF::WeakPtr should have a 'forget' method
        https://bugs.webkit.org/show_bug.cgi?id=141923

        Reviewed by Myles C. Maxfield.

        * wtf/WeakPtr.h:
        (WTF::WeakPtr::forget): Added.

2015-02-20  Geoffrey Garen  <ggaren@apple.com>

        Remove TCMalloc
        https://bugs.webkit.org/show_bug.cgi?id=141844

        Reviewed by Andreas Kling.

        It's unused.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/FastMalloc.cpp:
        (WTF::EntropySource<4>::value): Deleted.
        (WTF::EntropySource<8>::value): Deleted.
        (WTF::internalEntropyValue): Deleted.
        (WTF::freedObjectStartPoison): Deleted.
        (WTF::freedObjectEndPoison): Deleted.
        (WTF::ClassIndex): Deleted.
        (WTF::HardenedSLL::create): Deleted.
        (WTF::HardenedSLL::null): Deleted.
        (WTF::HardenedSLL::setValue): Deleted.
        (WTF::HardenedSLL::value): Deleted.
        (WTF::HardenedSLL::operator!): Deleted.
        (WTF::HardenedSLL::operator UnspecifiedBoolType): Deleted.
        (WTF::HardenedSLL::operator!=): Deleted.
        (WTF::HardenedSLL::operator==): Deleted.
        (WTF::LgFloor): Deleted.
        (WTF::SLL_Next): Deleted.
        (WTF::SLL_SetNext): Deleted.
        (WTF::SLL_Push): Deleted.
        (WTF::SLL_Pop): Deleted.
        (WTF::SLL_PopRange): Deleted.
        (WTF::SLL_PushRange): Deleted.
        (WTF::SizeClass): Deleted.
        (WTF::ByteSizeForClass): Deleted.
        (WTF::NumMoveSize): Deleted.
        (WTF::InitSizeClasses): Deleted.
        (WTF::MetaDataAlloc): Deleted.
        (WTF::PageHeapAllocator::Init): Deleted.
        (WTF::PageHeapAllocator::New): Deleted.
        (WTF::PageHeapAllocator::Delete): Deleted.
        (WTF::PageHeapAllocator::inuse): Deleted.
        (WTF::pages): Deleted.
        (WTF::AllocationSize): Deleted.
        (WTF::spanInitializerCookie): Deleted.
        (WTF::Span::next): Deleted.
        (WTF::Span::remoteNext): Deleted.
        (WTF::Span::prev): Deleted.
        (WTF::Span::setNext): Deleted.
        (WTF::Span::setPrev): Deleted.
        (WTF::Span::initCookie): Deleted.
        (WTF::Span::clearCookie): Deleted.
        (WTF::Span::isValid): Deleted.
        (WTF::Event): Deleted.
        (WTF::NewSpan): Deleted.
        (WTF::DeleteSpan): Deleted.
        (WTF::DLL_Init): Deleted.
        (WTF::DLL_Remove): Deleted.
        (WTF::DLL_IsEmpty): Deleted.
        (WTF::DLL_Length): Deleted.
        (WTF::DLL_Print): Deleted.
        (WTF::DLL_Prepend): Deleted.
        (WTF::TCMalloc_Central_FreeList::length): Deleted.
        (WTF::TCMalloc_Central_FreeList::tc_length): Deleted.
        (WTF::TCMalloc_Central_FreeList::enumerateFreeObjects): Deleted.
        (WTF::TCMalloc_Central_FreeList::entropy): Deleted.
        (WTF::FastMallocZone::goodSize): Deleted.
        (WTF::FastMallocZone::check): Deleted.
        (WTF::FastMallocZone::print): Deleted.
        (WTF::FastMallocZone::log): Deleted.
        (WTF::FastMallocZone::forceLock): Deleted.
        (WTF::FastMallocZone::forceUnlock): Deleted.
        (WTF::FastMallocZone::statistics): Deleted.
        (WTF::FastMallocZone::zoneValloc): Deleted.
        (WTF::FastMallocZone::zoneDestroy): Deleted.
        (WTF::MallocHook::record): Deleted.
        (WTF::MallocHook::recordAllocation): Deleted.
        (WTF::MallocHook::recordDeallocation): Deleted.
        (WTF::MallocHook::init): Deleted.
        (WTF::MallocHook::InvokeNewHook): Deleted.
        (WTF::MallocHook::InvokeDeleteHook): Deleted.
        (WTF::KernelSupportsTLS): Deleted.
        (WTF::CheckIfKernelSupportsTLS): Deleted.
        (WTF::TCMalloc_PageHeap::GetDescriptor): Deleted.
        (WTF::TCMalloc_PageHeap::GetDescriptorEnsureSafe): Deleted.
        (WTF::TCMalloc_PageHeap::SystemBytes): Deleted.
        (WTF::TCMalloc_PageHeap::FreeBytes): Deleted.
        (WTF::TCMalloc_PageHeap::GetSizeClassIfCached): Deleted.
        (WTF::TCMalloc_PageHeap::CacheSizeClass): Deleted.
        (WTF::TCMalloc_PageHeap::RecordSpan): Deleted.
        (WTF::TCMalloc_PageHeap::init): Deleted.
        (WTF::TCMalloc_PageHeap::initializeScavenger): Deleted.
        (WTF::TCMalloc_PageHeap::isScavengerSuspended): Deleted.
        (WTF::TCMalloc_PageHeap::scheduleScavenger): Deleted.
        (WTF::TCMalloc_PageHeap::rescheduleScavenger): Deleted.
        (WTF::TCMalloc_PageHeap::suspendScavenger): Deleted.
        (WTF::TCMalloc_PageHeap::scavengerTimerFired): Deleted.
        (WTF::TCMalloc_PageHeap::runScavengerThread): Deleted.
        (WTF::TCMalloc_PageHeap::signalScavenger): Deleted.
        (WTF::TCMalloc_PageHeap::scavenge): Deleted.
        (WTF::TCMalloc_PageHeap::shouldScavenge): Deleted.
        (WTF::TCMalloc_PageHeap::New): Deleted.
        (WTF::TCMalloc_PageHeap::AllocLarge): Deleted.
        (WTF::TCMalloc_PageHeap::Split): Deleted.
        (WTF::TCMalloc_PageHeap::Carve): Deleted.
        (WTF::mergeDecommittedStates): Deleted.
        (WTF::TCMalloc_PageHeap::Delete): Deleted.
        (WTF::TCMalloc_PageHeap::IncrementalScavenge): Deleted.
        (WTF::TCMalloc_PageHeap::RegisterSizeClass): Deleted.
        (WTF::TCMalloc_PageHeap::ReturnedBytes): Deleted.
        (WTF::PagesToMB): Deleted.
        (WTF::TCMalloc_PageHeap::Dump): Deleted.
        (WTF::TCMalloc_PageHeap::GrowHeap): Deleted.
        (WTF::TCMalloc_PageHeap::Check): Deleted.
        (WTF::TCMalloc_PageHeap::CheckList): Deleted.
        (WTF::TCMalloc_PageHeap::ReleaseFreeList): Deleted.
        (WTF::TCMalloc_PageHeap::ReleaseFreePages): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::Init): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::length): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::empty): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::lowwatermark): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::clear_lowwatermark): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::Push): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::PushRange): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::PopRange): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::Pop): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::Validate): Deleted.
        (WTF::TCMalloc_ThreadCache_FreeList::enumerateFreeObjects): Deleted.
        (WTF::TCMalloc_ThreadCache::freelist_length): Deleted.
        (WTF::TCMalloc_ThreadCache::Size): Deleted.
        (WTF::TCMalloc_ThreadCache::enumerateFreeObjects): Deleted.
        (WTF::getPageHeap): Deleted.
        (WTF::fastMallocGoodSize): Deleted.
        (WTF::TCMalloc_PageHeap::periodicScavenge): Deleted.
        (WTF::TCMalloc_PageHeap::scavengerThread): Deleted.
        (WTF::setThreadHeap): Deleted.
        (WTF::TCMalloc_Central_FreeList::Init): Deleted.
        (WTF::TCMalloc_Central_FreeList::ReleaseListToSpans): Deleted.
        (WTF::TCMalloc_Central_FreeList::ReleaseToSpans): Deleted.
        (WTF::TCMalloc_Central_FreeList::EvictRandomSizeClass): Deleted.
        (WTF::TCMalloc_Central_FreeList::MakeCacheSpace): Deleted.
        (WTF::TCMalloc_Central_FreeList::ShrinkCache): Deleted.
        (WTF::TCMalloc_Central_FreeList::InsertRange): Deleted.
        (WTF::TCMalloc_Central_FreeList::RemoveRange): Deleted.
        (WTF::TCMalloc_Central_FreeList::FetchFromSpansSafe): Deleted.
        (WTF::TCMalloc_Central_FreeList::FetchFromSpans): Deleted.
        (WTF::TCMalloc_Central_FreeList::Populate): Deleted.
        (WTF::TCMalloc_ThreadCache::SampleAllocation): Deleted.
        (WTF::TCMalloc_ThreadCache::Init): Deleted.
        (WTF::TCMalloc_ThreadCache::Cleanup): Deleted.
        (WTF::TCMalloc_ThreadCache::Allocate): Deleted.
        (WTF::TCMalloc_ThreadCache::Deallocate): Deleted.
        (WTF::TCMalloc_ThreadCache::FetchFromCentralCache): Deleted.
        (WTF::TCMalloc_ThreadCache::ReleaseToCentralCache): Deleted.
        (WTF::TCMalloc_ThreadCache::Scavenge): Deleted.
        (WTF::TCMalloc_ThreadCache::PickNextSample): Deleted.
        (WTF::TCMalloc_ThreadCache::InitModule): Deleted.
        (WTF::TCMalloc_ThreadCache::NewHeap): Deleted.
        (WTF::TCMalloc_ThreadCache::GetThreadHeap): Deleted.
        (WTF::TCMalloc_ThreadCache::GetCache): Deleted.
        (WTF::TCMalloc_ThreadCache::GetCacheIfPresent): Deleted.
        (WTF::TCMalloc_ThreadCache::InitTSD): Deleted.
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary): Deleted.
        * wtf/TCPackedCache.h: Removed.
        * wtf/TCPageMap.h: Removed.
        * wtf/TCSystemAlloc.cpp: Removed.
        * wtf/TCSystemAlloc.h: Removed.

2015-02-20  Alexey Proskuryakov  <ap@apple.com>

        Remove svn:keywords property.

        As far as I can tell, the property had no effect on any of these files, but also,
        when it has effect it's likely harmful.

        * wtf/DecimalNumber.cpp: Removed property svn:keywords.
        * wtf/spi/darwin/XPCSPI.h: Removed property svn:keywords.

2015-02-20  Csaba Osztrogonác  <ossy@webkit.org>

        EFL URTBF

        * wtf/PlatformEfl.cmake:

2015-02-20  Simon Fraser  <simon.fraser@apple.com>

        RunLoop::dispatch() should drop the mutex before calling wakeUp().
        https://bugs.webkit.org/show_bug.cgi?id=141820

        Reviewed by Alexey Proskuryakov.
        
        RunLoop::wakeUp() calls into CoreFoundation which could take time,
        so scope the mutex just to protect m_functionQueue.

        * wtf/RunLoop.cpp:
        (WTF::RunLoop::dispatch):

2015-02-20  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        Unreviewed, EFL build fix since r180410.

        * wtf/PlatformEfl.cmake: Add WEBKIT2/Platform/efl path in order to include DispatchQueueEfl.h.

2015-02-20  Antti Koivisto  <antti@apple.com>

        Move WorkQueue from WK2 to WTF
        https://bugs.webkit.org/show_bug.cgi?id=141797

        Reviewed by Anders Carlsson.

        It may be useful in WebCore.

        Windows implementation is still missing.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/PlatformGTK.cmake:
        * wtf/WorkQueue.cpp: Copied from Source/WebKit2/Platform/WorkQueue.cpp.
        * wtf/WorkQueue.h: Copied from Source/WebKit2/Platform/WorkQueue.h.
        * wtf/cocoa: Added.
        * wtf/cocoa/WorkQueueCocoa.cpp: Copied from Source/WebKit2/Platform/mac/WorkQueueMac.cpp.
        * wtf/efl/WorkQueueEfl.cpp: Copied from Source/WebKit2/Platform/efl/WorkQueueEfl.cpp.
        * wtf/gtk/WorkQueueGtk.cpp: Copied from Source/WebKit2/Platform/gtk/WorkQueueGtk.cpp.

2015-02-13  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [EFL] Enable bmalloc for EFL port 
        https://bugs.webkit.org/show_bug.cgi?id=141459

        Reviewed by Csaba Osztrogonác.

        * wtf/CMakeLists.txt: Remove TCSystemAlloc.cpp/h.
        * wtf/FastMalloc.cpp: Enable BMALLOC for EFL port.

2015-02-13  Anders Carlsson  <andersca@apple.com>

        Add a move constructor and move assignment operator to Deque
        https://bugs.webkit.org/show_bug.cgi?id=141571

        Reviewed by Andreas Kling.

        * wtf/Deque.h:
        (WTF::inlineCapacity>::Deque):
        (WTF::=): Deleted.

2015-02-13  Anders Carlsson  <andersca@apple.com>

        Add an initializer list constructor to Deque
        https://bugs.webkit.org/show_bug.cgi?id=141565

        Reviewed by Andreas Kling.

        * wtf/Deque.h:
        (WTF::inlineCapacity>::Deque):

2015-02-13  Anders Carlsson  <andersca@apple.com>

        Re-indent Deque.h

        Rubber-stamped by Antti Koivisto.

        * wtf/Deque.h:

2015-02-11  Brent Fulgham  <bfulgham@apple.com>

        [Win] [64-bit] Work around MSVC2013 Runtime Bug
        https://bugs.webkit.org/show_bug.cgi?id=141498
        <rdar://problem/19803642>

        Reviewed by Anders Carlsson.

        Disable FMA3 instruction use in the MSVC math library to
        work around a VS2013 runtime crash. We can remove this
        workaround when we switch to VS2015.

        * WTF.vcxproj/WTF.vcxproj: Add new files.
        * WTF.vcxproj/WTF.vcxproj.filters: Ditto.
        * wtf/win/WTFDLL.cpp: Added.

2015-02-11  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [EFL][GTK] Use bmalloc instead of tcmalloc
        https://bugs.webkit.org/show_bug.cgi?id=140162

        Reviewed by Carlos Garcia Campos.

        * wtf/CMakeLists.txt:
        * wtf/FastMalloc.cpp:
            Enable bmalloc on GTK ports, but EFL port will enable it when bmalloc supports
            memory statistics.

2015-02-10  Darin Adler  <darin@apple.com>

        Add the crash-on-failure behavior to bmalloc-based fastMalloc
        https://bugs.webkit.org/show_bug.cgi?id=141434

        Reviewed by Alexey Proskuryakov.

        * wtf/FastMalloc.cpp: Removed unneeded includes.
        (WTF::fastMalloc): Added null check and CRASH.
        (WTF::fastCalloc): Added overflow checking, null check, and CRASH.
        (WTF::fastRealloc): Added null check and CRASH.
        (WTF::fastMallocSize): Added FIXME comment.
        (WTF::fastMallocGoodSize): Added FIXME comment.
        (WTF::fastAlignedMalloc): Added null check and CRASH.
        (WTF::tryFastMalloc): Changed to call bmalloc directly instead of
        calling fastMalloc, since fastMalloc will now crash on failure.
        (WTF::tryFastRealloc): Changed to call bmalloc directly instead of
        calling fastRealloc, since fastRealloc will now crash on failure.
        (WTF::tryFastCalloc): Added overflow checking.
        (WTF::fastMallocStatistics): Added FIXME comment.

2015-02-10  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] GMutexLocker build issue
        https://bugs.webkit.org/show_bug.cgi?id=141381

        Reviewed by Žan Doberšek.

        Remove using WTF::GMutexLocker from the header, since newer glib
        versions have a GMutexLocker in the public API.

        * wtf/gobject/GMutexLocker.h:

2015-02-09  Alexey Proskuryakov  <ap@apple.com>

        REGRESSION: tryFastCalloc is no longer "try"
        https://bugs.webkit.org/show_bug.cgi?id=141406

        Reviewed by Darin Adler.

        This causes crashes on some WebKit regression test bots.

        * wtf/FastMalloc.cpp: (WTF::tryFastCalloc): Fix what looks like a copy/paste mistake.

2015-02-07  Csaba Osztrogonác  <ossy@webkit.org>

        [ARM] GC sometimes stuck in an infinite loop if parallel GC is enabled
        https://bugs.webkit.org/show_bug.cgi?id=141290

        Reviewed by Anders Carlsson.

        * wtf/Platform.h:

2015-02-07  Chris Dumez  <cdumez@apple.com>

        Add Vector::removeFirstMatching() / removeAllMatching() methods taking lambda functions
        https://bugs.webkit.org/show_bug.cgi?id=141321

        Reviewed by Darin Adler.

        Add Vector::removeFirstMatching() / removeAllMatching() methods taking
        lambda functions to match the element(s) to remove. This simplifies the
        code a bit. Vector::removeAllMatching() is also more efficient than the
        manual removal alternative.

        * wtf/Vector.h:

2015-02-06  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r179743.
        https://bugs.webkit.org/show_bug.cgi?id=141335

        caused missing symbols in non-WebKit clients of WTF::Vector
        (Requested by kling on #webkit).

        Reverted changeset:

        "Remove WTF::fastMallocGoodSize()."
        https://bugs.webkit.org/show_bug.cgi?id=141020
        http://trac.webkit.org/changeset/179743

2015-02-06  Andreas Kling  <akling@apple.com>

        Remove WTF::fastMallocGoodSize().
        <https://webkit.org/b/141020>

        Reviewed by Anders Carlsson.

        bmalloc's good-size API just returns exactly whatever you pass it,
        so it's of no utility to us anymore.

        This gets rid of a bunch of pointless out-of-line calls in Vector
        construction and growth.

        * wtf/Compression.cpp:
        (WTF::GenericCompressedData::create):
        * wtf/FastMalloc.cpp:
        (WTF::fastMallocGoodSize): Deleted.
        * wtf/FastMalloc.h:
        * wtf/Vector.h:
        (WTF::VectorBufferBase::allocateBuffer):
        (WTF::VectorBufferBase::tryAllocateBuffer):
        (WTF::VectorBufferBase::reallocateBuffer):

2015-02-05  Youenn Fablet  <youenn.fablet@crf.canon.fr> and Xabier Rodriguez Calvar <calvaris@igalia.com>

        [Streams API] Implement a barebone ReadableStream interface
        https://bugs.webkit.org/show_bug.cgi?id=141045

        Reviewed by Benjamin Poulain.

        * wtf/FeatureDefines.h:

2015-02-04  Alexey Proskuryakov  <ap@apple.com>

        Optimized equal() functions in StringImpl.h are not ASan compatible
        https://bugs.webkit.org/show_bug.cgi?id=141258

        Reviewed by Daniel Bates.

        * wtf/text/StringImpl.h: (WTF::equal): Add custom implementations for ASan.

2015-02-04  Chris Dumez  <cdumez@apple.com>

        Add removeFirst(value) / removeAll(value) methods to WTF::Vector
        https://bugs.webkit.org/show_bug.cgi?id=141192

        Reviewed by Benjamin Poulain.

        Add removeFirst(value) / removeAll(value) convenience methods to
        WTF::Vector to reduce complexity a bit at call sites.

        I am planning to add overloads for these taking a lambda function for
        matching in a follow-up patch as well. I have seen quite a few
        Vector::remove(index) call sites that would benefit from it.

        * wtf/Vector.h:
        (WTF::OverflowHandler>::removeFirst):
        (WTF::OverflowHandler>::removeAll):

2015-02-02  Dhi Aurrahman  <diorahman@rockybars.com>

        Optimize matchesLangPseudoClass() of :lang()
        https://bugs.webkit.org/show_bug.cgi?id=140873

        Reviewed by Darin Adler.

        Add some basic equality comparison operators.

        * wtf/text/StringView.h:
        (WTF::operator==):
        (WTF::operator!=):
        (WTF::equal):
        (WTF::equalIgnoringASCIICase):

2015-02-02  Geoffrey Garen  <ggaren@apple.com>

        Use FastMalloc (bmalloc) instead of BlockAllocator for GC pages
        https://bugs.webkit.org/show_bug.cgi?id=140900

        Reviewed by Mark Hahnenberg.

        Re-landing just the HandleBlock piece of this patch.

        * wtf/FastMalloc.cpp:
        (WTF::fastAlignedMalloc):
        (WTF::fastAlignedFree):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/FastMalloc.h:

2015-02-02  Daniel Bates  <dabates@apple.com>

        [iOS] ASSERTION FAILED: m_scriptExecutionContext->isContextThread() in ContextDestructionObserver::observeContext
        https://bugs.webkit.org/show_bug.cgi?id=141057
        <rdar://problem/19068790>

        Reviewed by Alexey Proskuryakov.

        * wtf/MainThread.h:
        * wtf/mac/MainThreadMac.mm:
        (WTF::callOnWebThreadOrDispatchAsyncOnMainThread): Added.

2015-01-31  Sam Weinig  <sam@webkit.org>

        Remove even more Mountain Lion support
        https://bugs.webkit.org/show_bug.cgi?id=141124

        Reviewed by Alexey Proskuryakov.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:
        * wtf/Assertions.cpp:
        * wtf/FeatureDefines.h:
        * wtf/Platform.h:

2015-01-31  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r179426.
        https://bugs.webkit.org/show_bug.cgi?id=141119

        "caused a memory use regression" (Requested by Guest45 on
        #webkit).

        Reverted changeset:

        "Use FastMalloc (bmalloc) instead of BlockAllocator for GC
        pages"
        https://bugs.webkit.org/show_bug.cgi?id=140900
        http://trac.webkit.org/changeset/179426

2015-01-31  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r179408.
        https://bugs.webkit.org/show_bug.cgi?id=141117

        This didn't fully fix the issue (Requested by anttik on
        #webkit).

        Reverted changeset:

        "OSObjectPtr does not work with dispatch_data_t on Maverics"
        https://bugs.webkit.org/show_bug.cgi?id=141081
        http://trac.webkit.org/changeset/179408

2015-01-30  Yusuke Suzuki  <utatane.tea@gmail.com>

        Implement ES6 Symbol
        https://bugs.webkit.org/show_bug.cgi?id=140435

        Reviewed by Geoffrey Garen.

        Introduce new unique string mechanizm into StringImpl.
        It is used for implementing Symbol which holds a [[Description]] value.

        * wtf/text/AtomicString.h:
        (WTF::AtomicString::add):
        (WTF::AtomicString::addWithStringTableProvider):

        Previously, we checked `isAtomic()` or `!length()`. This guard can filter out EmptyUnique.
        But now, we introduced new unique StringImpl. Since it has an actual string value, we need to check `isUnique()`.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl):
        (WTF::StringImpl::createUnique):

        In createUnique, we leverage Substring mechanizm to produce a new unique
        string from an existing string.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):
        (WTF::StringImpl::createUniqueEmpty):
        (WTF::StringImpl::flagIsUnique):
        (WTF::StringImpl::isUnique):
        (WTF::StringImpl::setIsAtomic):
        (WTF::StringImpl::createEmptyUnique): Deleted.
        (WTF::StringImpl::isEmptyUnique): Deleted.

        Instead of EmptyUnique, we introduced new flag to StringImpl, `isUnique`.
        While EmptyUnique cannot hold any string values except for empty string,
        the unique StringImpl can hold any String values.
        We fold the Symbol's descriptiveString value here.

        * wtf/text/StringStatics.cpp:
        (WTF::StringImpl::hashAndFlagsForUnique):
        (WTF::StringImpl::hashAndFlagsForEmptyUnique): Deleted.

2015-01-30  Geoffrey Garen  <ggaren@apple.com>

        Use FastMalloc (bmalloc) instead of BlockAllocator for GC pages
        https://bugs.webkit.org/show_bug.cgi?id=140900

        Reviewed by Mark Hahnenberg.

        Re-landing just the HandleBlock piece of this patch.

        * wtf/FastMalloc.cpp:
        (WTF::fastAlignedMalloc):
        (WTF::fastAlignedFree):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/FastMalloc.h:

2015-01-30  Namhoon Kim  <yanhkim@gmail.com>

        Call vsnprintf instead of _vsnprintf in vprintf_stderr_common
        https://bugs.webkit.org/show_bug.cgi?id=141078

        In windows _vsnprintf api does not place null character
        automatically. Simply replace it with vsnprintf. Which is
        polyfill to call wtf_vsnprintf in windows.

        Reviewed by Brent Fulgham.

        * wtf/Assertions.cpp:

2015-01-30  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: ASSERT in InspectorTimelineAgent::internalStop
        https://bugs.webkit.org/show_bug.cgi?id=141039

        Reviewed by Timothy Hatcher.

        Add messages to Stopwatch assertions, and clean up constructor.

        * wtf/Stopwatch.h:
        (WTF::Stopwatch::Stopwatch):
        (WTF::Stopwatch::start):
        (WTF::Stopwatch::stop):

2015-01-30  Chris Dumez  <cdumez@apple.com>

        Add match_constness<Reference, T> helper struct
        https://bugs.webkit.org/show_bug.cgi?id=140905

        Reviewed by Benjamin Poulain.

        Add match_constness<Reference, T> helper struct to simplify downcast<>()
        a bit. The purpose of this helper is to update T's constness to match
        Reference's.

        * wtf/TypeCasts.h:
        (WTF::downcast):

2015-01-30  Chris Dumez  <cdumez@apple.com>

        Add assertion in RefPtr's operator*() to make sure we don't dereference nullptr
        https://bugs.webkit.org/show_bug.cgi?id=141092

        Reviewed by Anders Carlsson.

        Add assertion in RefPtr's operator*() to make sure we don't dereference
        nullptr.

        * wtf/RefPtr.h:
        (WTF::RefPtr::operator*):

2015-01-30  Geoffrey Garen  <ggaren@apple.com>

        GC marking threads should clear malloc caches
        https://bugs.webkit.org/show_bug.cgi?id=141097

        Reviewed by Andreas Kling.

        Split the scavenging API into per-thread vs global, so that you can
        request to scavenge your own thread without scavenging the whole heap.

        * wtf/FastMalloc.cpp:
        (WTF::releaseFastMallocFreeMemoryForThisThread):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        * wtf/FastMalloc.h:

2015-01-30  Antti Koivisto  <antti@apple.com>

        OSObjectPtr does not work with dispatch_data_t on Maverics
        https://bugs.webkit.org/show_bug.cgi?id=141081

        Reviewed by Pratik Solanki.
        
        Trying to use OSObjectPtr<dispatch_data_t> throws 
        
        -[OS_dispatch_data _xref_dispose]: unrecognized selector sent to instance 0

        * wtf/OSObjectPtr.h:
        (WTF::retainOSObject<dispatch_data_t>):
        (WTF::releaseOSObject<dispatch_data_t>):
        
            Add specialization for dispatch_data_t on Maverics.

2015-01-29  Santosh Mahto  <santoshbit2007@gmail.com>

        Refactor String::format to handle unreached va_end.
        https://bugs.webkit.org/show_bug.cgi?id=140938

        Reviewed by Alexey Proskuryakov.

        Now va_end is called for all platform after getting length
        of formatted string and again va_start/va_end is called to write
        formatted string in buffer. This way it ensure va_end is always
        reached for each va_start.

        * wtf/text/WTFString.cpp:

2015-01-29  Csaba Osztrogonác  <ossy@webkit.org>

        Move HAVE_DTRACE definition back to Platform.h
        https://bugs.webkit.org/show_bug.cgi?id=141033

        Reviewed by Dan Bernstein.

        * wtf/Platform.h:

2015-01-28  Namhoon Kim  <namkim@ea.com>

        Windows return -1 when calling vsnprintf with arguments that exceed target buffer size
        https://bugs.webkit.org/show_bug.cgi?id=140917

        Reviewed by Brent Fulgham.

        Fix return value of vsnprintf when windows API return -1 to denote
        requested buffer exceeded. Replace return value by calling vscprintf.

        * wtf/StringExtras.h:
        (snprintf): Fix return value by calling vscprintf when buffer exceeded.
        (wtf_vsnprintf): Ditto.

2015-01-28  Geoffrey Garen  <ggaren@apple.com>

        Removed fastMallocForbid / fastMallocAllow
        https://bugs.webkit.org/show_bug.cgi?id=141012

        Reviewed by Mark Hahnenberg.

        Removed the forbid / allow API because it is no longer used.

        * wtf/FastMalloc.cpp:
        (WTF::tryFastMalloc):
        (WTF::fastMalloc):
        (WTF::tryFastCalloc):
        (WTF::fastCalloc):
        (WTF::fastFree):
        (WTF::tryFastRealloc):
        (WTF::fastRealloc):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        (WTF::isForbidden): Deleted.
        (WTF::fastMallocForbid): Deleted.
        (WTF::fastMallocAllow): Deleted.
        (WTF::initializeIsForbiddenKey): Deleted.
        * wtf/FastMalloc.h:

2015-01-28  Dana Burkart  <dburkart@apple.com>

        Move ASan flag settings from DebugRelease.xcconfig to Base.xcconfig
        https://bugs.webkit.org/show_bug.cgi?id=136765

        Reviewed by Alexey Proskuryakov.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:

2015-01-28  Darin Adler  <darin@apple.com>

        Fix small leak in Collator
        https://bugs.webkit.org/show_bug.cgi?id=140990

        Reviewed by Andreas Kling.

        * wtf/unicode/icu/CollatorICU.cpp:
        (WTF::Collator::Collator): Use fastStrDup instead of strdup.
        (WTF::Collator::~Collator): Use fastFree on the collator locale that we
        are abandoning. The old code instead just called free on a null pointer.

2015-01-27  Geoffrey Garen  <ggaren@apple.com>

        Removed WTF_MALLOC_VALIDATION
        https://bugs.webkit.org/show_bug.cgi?id=140958

        Reviewed by Anders Carlsson.

        I don't think anyone has been using this, and the #ifdefs were driving
        me crazy.

        We have other options for validation -- like MallocGuardEdges,
        MallocCheckHeapEach, MallocScribble, and GuardMalloc.

        * wtf/FastMalloc.cpp:
        (WTF::tryFastMalloc):
        (WTF::fastMalloc):
        (WTF::tryFastCalloc):
        (WTF::fastCalloc):
        (WTF::fastFree):
        (WTF::tryFastRealloc):
        (WTF::fastRealloc):
        (WTF::fastMallocSize):
        (WTF::TCMalloc_ThreadCache::CreateCacheIfNecessary):
        (WTF::Internal::fastMallocMatchFailed): Deleted.
        * wtf/FastMalloc.h:
        (WTF::Internal::fastMallocValidationHeader): Deleted.
        (WTF::Internal::fastMallocValidationSuffix): Deleted.
        (WTF::Internal::fastMallocMatchValidationType): Deleted.
        (WTF::Internal::setFastMallocMatchValidationType): Deleted.
        (WTF::fastMallocMatchValidateMalloc): Deleted.
        (WTF::fastMallocMatchValidateFree): Deleted.
        (WTF::fastMallocValidate): Deleted.

2015-01-27  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r179192.
        https://bugs.webkit.org/show_bug.cgi?id=140953

        Caused numerous layout test failures (Requested by mattbaker_
        on #webkit).

        Reverted changeset:

        "Use FastMalloc (bmalloc) instead of BlockAllocator for GC
        pages"
        https://bugs.webkit.org/show_bug.cgi?id=140900
        http://trac.webkit.org/changeset/179192

2015-01-26  Geoffrey Garen  <ggaren@apple.com>

        Use FastMalloc (bmalloc) instead of BlockAllocator for GC pages
        https://bugs.webkit.org/show_bug.cgi?id=140900

        Reviewed by Mark Hahnenberg.

        New interface for aligned allocation: fastAlignedMalloc / fastAlignedFree.
        We require a special function call on free because Windows.

        * wtf/FastMalloc.cpp:
        (WTF::fastAlignedMalloc):
        (WTF::fastAlignedFree): Do it.

        (WTF::do_memalign): Un-ifdef this, since we use it now.

        * wtf/FastMalloc.h: Make our new function names visible like the rest
        of fastMalloc.

2015-01-26  Brent Fulgham  <bfulgham@apple.com>

        [Win] ASSERTION FAILED !m_ptr under AccessibilityController::winAddNotificationListener
        https://bugs.webkit.org/show_bug.cgi?id=87426
        <rdar://problem/11527899>

        Reviewed by Darin Adler.

        Revise internal containers to use std::addressof in preference to
        to using the '&' operator.

        * wtf/Deque.h:
        (WTF::inlineCapacity>::append):
        (WTF::inlineCapacity>::prepend):
        (WTF::inlineCapacity>::removeFirst):
        (WTF::inlineCapacity>::removeLast):
        (WTF::inlineCapacity>::remove):
        (WTF::inlineCapacity>::after):
        (WTF::inlineCapacity>::before):
        * wtf/GetPtr.h:
        * wtf/HashTable.h:
        (WTF::HashTableBucketInitializer<false>::initialize):
        * wtf/HashTraits.h:
        (WTF::SimpleClassHashTraits::constructDeletedValue):
        (WTF::CustomHashTraits::constructDeletedValue):
        * wtf/ListHashSet.h:
        (WTF::ListHashSetConstIterator::get):
        * wtf/Vector.h:
        (WTF::Vector::swap):
        (WTF::OverflowHandler>::append):
        (WTF::OverflowHandler>::tryAppend):
        (WTF::OverflowHandler>::insert):

2015-01-24  Chris Dumez  <cdumez@apple.com>

        Provide implementation for WTF::DefaultHash<bool>
        https://bugs.webkit.org/show_bug.cgi?id=140848

        Reviewed by Anders Carlsson.

        Provide implementation for WTF::DefaultHash<bool> so that we can use
        HashMap<std::pair<XXX, bool>> in the code base. Right now, we need to
        use some integer type to work around the issue.

        * wtf/HashFunctions.h:

2015-01-23  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Add missing null check in some derefGPtr implementations
        https://bugs.webkit.org/show_bug.cgi?id=140822

        Reviewed by Sergio Villar Senin.

        It's missing in GHashTable and GVariant implementations.

        * wtf/gobject/GRefPtr.cpp:
        (WTF::derefGPtr):

2015-01-23  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Add initial database process support
        https://bugs.webkit.org/show_bug.cgi?id=139491

        Reviewed by Sergio Villar Senin.

        Add support for using GRefPtr with GVariantBuilder.

        * wtf/gobject/GRefPtr.cpp:
        (WTF::refGPtr):
        (WTF::derefGPtr):
        * wtf/gobject/GRefPtr.h:
        * wtf/gobject/GTypedefs.h:

2015-01-22  Ryosuke Niwa  <rniwa@webkit.org>

        Add a build flag for ES6 class syntax
        https://bugs.webkit.org/show_bug.cgi?id=140760

        Reviewed by Michael Saboff.

        * wtf/FeatureDefines.h:

2015-01-21  Csaba Osztrogonác  <ossy@webkit.org>

        Remove ENABLE(INSPECTOR) ifdef guards
        https://bugs.webkit.org/show_bug.cgi?id=140668

        Reviewed by Darin Adler.

        * wtf/FeatureDefines.h:

2015-01-20  YunQiang Su  <wzssyqa@gmail.com>

        Fix failed to build for Linux/MIPS64EL
        https://bugs.webkit.org/show_bug.cgi?id=124370

        Reviewed by Darin Adler.

        Add MIPS64EL support.

        * wtf/Platform.h:
        * wtf/dtoa/utils.h:

2015-01-19  Alexey Proskuryakov  <ap@apple.com>

        Make ASan do bounds checks for WTF::Vector
        https://bugs.webkit.org/show_bug.cgi?id=140631
        rdar://problem/19437718

        Reviewed by Darin Adler.

        * wtf/SizeLimits.cpp: Disable Vector object size checks for ASan enabled builds.

        * wtf/Vector.h:
        (WTF::VectorBuffer::endOfBuffer):
        (WTF::Vector::Vector):
        (WTF::Vector::~Vector):
        (WTF::Vector::swap):
        (WTF::OverflowHandler>::Vector):
        (WTF::=):
        (WTF::OverflowHandler>::fill):
        (WTF::OverflowHandler>::resize):
        (WTF::OverflowHandler>::shrink):
        (WTF::OverflowHandler>::grow):
        (WTF::OverflowHandler>::asanSetInitialBufferSizeTo):
        (WTF::OverflowHandler>::asanSetBufferSizeToFullCapacity):
        (WTF::OverflowHandler>::asanBufferSizeWillChangeTo):
        (WTF::OverflowHandler>::reserveCapacity):
        (WTF::OverflowHandler>::tryReserveCapacity):
        (WTF::OverflowHandler>::shrinkCapacity):
        (WTF::OverflowHandler>::append):
        (WTF::OverflowHandler>::tryAppend):
        (WTF::OverflowHandler>::appendSlowCase):
        (WTF::OverflowHandler>::uncheckedAppend):
        (WTF::OverflowHandler>::insert):
        (WTF::OverflowHandler>::remove):
        (WTF::OverflowHandler>::releaseBuffer):

        * wtf/Compiler.h: Changed ASAN_ENABLED macro fallback value from false to 0,
        MSVC was not happy with false.

2015-01-20  Csaba Osztrogonác  <ossy@webkit.org>

        Remove non-Windows cruft from WebKit/win/Plugins
        https://bugs.webkit.org/show_bug.cgi?id=140675

        Reviewed by Anders Carlsson.

        * wtf/FeatureDefines.h:

2015-01-16  Myles C. Maxfield  <mmaxfield@apple.com>

        WeakPtr functions crash when created with default constructor
        https://bugs.webkit.org/show_bug.cgi?id=140479

        Reviewed by Andreas Kling.

        This patch rearranges how WeakPtr works, and has the following ideas behind it:

        1. WeakPtr should use Ref internally. This solves the crash by always having a
        valid WeakReference.
        2. Clients should not be able to construct WeakReferences directly. Instead,
        only WeakPtrFactory (and WeakPtr's default constructor) should be able to
        construct them. They are considered an implementation detail of WeakPtr.
        3. Except for the default constructor, clients should not be able to construct
        WeakPtrs directly. Instead, the WeakPtrFactory must construct them. This
        guarantees that the WeakPtrs all reference the same WeakReference.
        4. Clients can construct a WeakPtr using its default constructor, and then
        use the assignment operator to make it non-null. (Or they could use
        WeakPtrFactory to make it non-null at creation-time.)
        5. No one was using WeakReference::bindTo(), and it doesn't seem useful, so I
        removed it.

        Tests: WTF_WeakPtr API tests

        * wtf/Ref.h:
        (WTF::Ref::Ref): Added extra ASSERT()s, and explicitly deleted copy
        constructors with a comment.
        (WTF::Ref::operator=): Added extra ASSERT()s, and explicitly deleted copy
        assignment operators with a comment.
        * wtf/WeakPtr.h:
        (WTF::WeakReference::clear): Used nullptr.
        (WTF::WeakReference::create): Moved to private:
        (WTF::WeakPtr::WeakPtr): For the default constructor, initialized the Ref with
        a new WeakReference. For the other constructor, moved it to private:. Also added
        copy constructors and copy assignment operators (since Ref doesn't have them but
        RefPtr does). These constructors/operators are relied upon in various places
        throughout WebCore.
        (WTF::WeakPtr::operator bool): Made non-explicit.
        (WTF::WeakReference::createUnbound): Deleted.
        (WTF::WeakReference::bindTo): Deleted.
        (WTF::WeakReference::WeakReference): Deleted.
        (WTF::WeakPtrFactory::WeakPtrFactory): Deleted.

2015-01-16  Yusuke Suzuki  <utatane.tea@gmail.com>

        std::all_of requires complete C++ iterators in GCC 4.8
        https://bugs.webkit.org/show_bug.cgi?id=140530

        Reviewed by Darin Adler.

        In the WebKit2/UIProcess/WebProcessLifetimeObserver.cpp, std::all_of
        is used for HashIterators. However, std::all_of requires the complete
        C++ iterator interface including iterator_category typedef member and
        it raises compile error in GCC 4.8 (and libstdc++) environment.

        This patch inherits std::iterator with appropriate type parameters.
        It automatically defines required typedefs including iterator_category.

        * wtf/HashIterators.h:

2015-01-15  Csaba Osztrogonác  <ossy@webkit.org>

        Remove ENABLE(SQL_DATABASE) guards
        https://bugs.webkit.org/show_bug.cgi?id=140434

        Reviewed by Darin Adler.

        * wtf/FeatureDefines.h:

2015-01-14  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed fix after r163330.

        * wtf/Platform.h: Use C style comment.

2015-01-14  Marc Juul  <juul@sudomesh.org>

        C++ style comment was preventing compile if CPU(ARM_NEON)
        https://bugs.webkit.org/show_bug.cgi?id=133827

        Reviewed by Csaba Osztrogonác.

        * wtf/Platform.h:

2015-01-13  Chris Dumez  <cdumez@apple.com>

        Make WTF::Optional work with msvc 2013
        https://bugs.webkit.org/show_bug.cgi?id=140401

        Reviewed by Anders Carlsson.

        Update the WTF::Optional implementation to use std::aligned_memory and
        placement new instead of an unrestricted union because msvc 2013 still
        doesn't support unrestricted unions.

        This change is a pre-requirement to fix Bug 140347 as this change uses
        WTF::Optional with types that have non-trivial copy constructors.

        This change is covered by the existing Optional WTF test.

        * wtf/Optional.h:

2015-01-11  Sam Weinig  <sam@webkit.org>

        Remove support for SharedWorkers
        https://bugs.webkit.org/show_bug.cgi?id=140344

        Reviewed by Anders Carlsson.

        * wtf/FeatureDefines.h:

2015-01-12  Darin Adler  <darin@apple.com>

        Modernize and streamline HTMLTokenizer
        https://bugs.webkit.org/show_bug.cgi?id=140166

        Reviewed by Sam Weinig.

        * wtf/Forward.h: Removed PassRef, added OrdinalNumber and TextPosition.

2015-01-09  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r178154, r178163, and r178164.
        https://bugs.webkit.org/show_bug.cgi?id=140292

        Still multiple assertion failures on tests (Requested by ap on
        #webkit).

        Reverted changesets:

        "Modernize and streamline HTMLTokenizer"
        https://bugs.webkit.org/show_bug.cgi?id=140166
        http://trac.webkit.org/changeset/178154

        "Unreviewed speculative buildfix after r178154."
        http://trac.webkit.org/changeset/178163

        "One more unreviewed speculative buildfix after r178154."
        http://trac.webkit.org/changeset/178164

2015-01-08  Darin Adler  <darin@apple.com>

        Modernize and streamline HTMLTokenizer
        https://bugs.webkit.org/show_bug.cgi?id=140166

        Reviewed by Sam Weinig.

        * wtf/Forward.h: Removed PassRef, added OrdinalNumber and TextPosition.

2015-01-08  Benjamin Poulain  <benjamin@webkit.org>

        [WK2] Start a prototype for declarative site specific extensions
        https://bugs.webkit.org/show_bug.cgi?id=140160

        Reviewed by Andreas Kling.

        * wtf/FeatureDefines.h:

2015-01-07  Daniel Bates  <dabates@apple.com>

        [iOS] Make WebKit2 build with public iOS SDK and more build fixes for DRT
        https://bugs.webkit.org/show_bug.cgi?id=137371

        As pointed out by Tim Horton, use C-style comment instead of C++-style comment as
        wtf/Compiler.h is included in the sandbox profile and the sandbox profile compiler
        doesn't understand C++-style comments.

        * wtf/Compiler.h:

2015-01-07  Daniel Bates  <dabates@apple.com>

        [iOS] Make WebKit2 build with public iOS SDK and more build fixes for DRT
        https://bugs.webkit.org/show_bug.cgi?id=137371

        Reviewed by David Kilzer.

        Move EXTERN_C_BEGIN and EXTERN_C_END macros from file WebKit2/config.h to here and
        rename them to WTF_EXTERN_C_BEGIN and WTF_EXTERN_C_END, respectively, so that we
        can make use of these macros in SPI wrapper headers (e.g. UIKitSPI.h).

        I'll look to transition existing code to WTF_EXTERN_C_BEGIN/WTF_EXTERN_C_END and
        remove EXTERN_C in a subsequent commit(s).

        * wtf/Compiler.h:

2015-01-07  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r178068.
        https://bugs.webkit.org/show_bug.cgi?id=140235

        Breaks the iOS build (Requested by enrica on #webkit).

        Reverted changeset:

        "[iOS] Make WebKit2 build with public iOS SDK and more build
        fixes for DRT"
        https://bugs.webkit.org/show_bug.cgi?id=137371
        http://trac.webkit.org/changeset/178068

2015-01-07  Daniel Bates  <dabates@apple.com>

        [iOS] Make WebKit2 build with public iOS SDK and more build fixes for DRT
        https://bugs.webkit.org/show_bug.cgi?id=137371

        Reviewed by David Kilzer.

        Move EXTERN_C_BEGIN and EXTERN_C_END macros from file WebKit2/config.h to here and
        rename them to WTF_EXTERN_C_BEGIN and WTF_EXTERN_C_END, respectively, so that we
        can make use of these macros in SPI wrapper headers (e.g. UIKitSPI.h).

        I'll look to transition existing code to WTF_EXTERN_C_BEGIN/WTF_EXTERN_C_END and
        remove EXTERN_C in a subsequent commit(s).

        * wtf/Compiler.h:

2015-01-07  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: purge PassRefPtr from Inspector code and use Ref for typed and untyped protocol objects
        https://bugs.webkit.org/show_bug.cgi?id=140053

        Reviewed by Andreas Kling.

        * wtf/Stopwatch.h:
        (WTF::Stopwatch::create): Return a Ref.

2015-01-07  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r178039.
        https://bugs.webkit.org/show_bug.cgi?id=140187

        Breaks ObjC Inspector Protocol (Requested by JoePeck on
        #webkit).

        Reverted changeset:

        "Web Inspector: purge PassRefPtr from Inspector code and use
        Ref for typed and untyped protocol objects"
        https://bugs.webkit.org/show_bug.cgi?id=140053
        http://trac.webkit.org/changeset/178039

2015-01-06  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: purge PassRefPtr from Inspector code and use Ref for typed and untyped protocol objects
        https://bugs.webkit.org/show_bug.cgi?id=140053

        Reviewed by Andreas Kling.

        * wtf/Stopwatch.h:
        (WTF::Stopwatch::create): Return a Ref.

2015-01-06  Alexey Proskuryakov  <ap@apple.com>

        ADDRESS_SANITIZER macro is overloaded
        https://bugs.webkit.org/show_bug.cgi?id=140130

        Reviewed by Anders Carlsson.

        * wtf/Compiler.h: Added an ASAN_ENABLED macro. The abbreviation should become well
        known - we already use it in tools.

        * wtf/Assertions.h:
        * wtf/RefCounted.h:
        * wtf/SizeLimits.cpp:
        Change the conditional to ENABLE(SECURITY_ASSERTIONS). These checks will be used
        in debug builds, and also when one explicitly passes -DENABLE_SECURITY_ASSERTIONS.

2015-01-05  Andreas Kling  <akling@apple.com>

        Purge PassRefPtr from Page.
        <https://webkit.org/b/140089>

        Reviewed by Anders Carlsson.

        Make SchedulePair::create() return Ref since it never fails.

        * wtf/SchedulePair.h:
        (WTF::SchedulePair::create):

2015-01-01  Darin Adler  <darin@apple.com>

        Rework code that hides characters in password fields to streamline a little
        https://bugs.webkit.org/show_bug.cgi?id=140035

        Reviewed by Sam Weinig.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::fill): Deleted.
        * wtf/text/StringImpl.h: Deleted StringImpl::fill.
        * wtf/text/WTFString.h:
        (WTF::String::fill): Deleted.

2014-12-26  Dan Bernstein  <mitz@apple.com>

        Build fix.

        Removed use of __builtin_s{add,sub}_overflow introduced in r177729 that was causing a compiler used at Apple to crash because of <rdar://problem/19347133>.

        * wtf/SaturatedArithmetic.h:
        (signedAddOverflows):
        (signedSubtractOverflows):

2014-12-26  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/19348208> REGRESSION (r177027): iOS builds use the wrong toolchain
        https://bugs.webkit.org/show_bug.cgi?id=139950

        Reviewed by David Kilzer.

        * Configurations/Base.xcconfig: Only define TOOLCHAINS when building for OS X, doing so
        in a manner that works with Xcode 5.1.1.

2014-12-25  Dan Bernstein  <mitz@apple.com>

        Try to fix the Windows build after r177733.

        * wtf/Ref.h:

2014-12-25  Alexey Proskuryakov  <ap@apple.com>

        Simplify saturated integer add/sub
        https://bugs.webkit.org/show_bug.cgi?id=139854

        Address Darin's post-commit feedback to fix API tests.

        * wtf/SaturatedArithmetic.h: (saturatedSubtraction):

2014-12-24  Benjamin Poulain  <benjamin@webkit.org>

        Simplify saturated integer add/sub
        https://bugs.webkit.org/show_bug.cgi?id=139854

        Reviewed by Darin Adler.

        * wtf/Compiler.h:
        Make a wrapper for __has_builtin for compilers that do not support it.

        * wtf/SaturatedArithmetic.h:
        (saturatedAddition):
        (saturatedSubtraction):
        Use the builtins when possible instead of reinventing the wheel.
        On ARMv7, use the saturated math instructions.

2014-12-23  Anders Carlsson  <andersca@apple.com>

        Move dynamic_objc_cast to RetainPtr.h
        https://bugs.webkit.org/show_bug.cgi?id=139915

        Reviewed by Sam Weinig.

        * wtf/RetainPtr.h:
        (WTF::dynamic_objc_cast):

2014-12-23  Anders Carlsson  <andersca@apple.com>

        Re-indent RefPtr.h and RetainPtr.h.

        Rubber-stamped by Sam Weinig.

        * wtf/RefPtr.h:
        * wtf/RetainPtr.h:

2014-12-20  Eric Carlson  <eric.carlson@apple.com>

        [iOS] add optimized fullscreen API
        https://bugs.webkit.org/show_bug.cgi?id=139833
        <rdar://problem/18844486>

        Reviewed by Simon Fraser.

        * wtf/Platform.h: Define ENABLE_VIDEO_PRESENTATION_MODE.

2014-12-18  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        Fix build break on EFL and GTK since r177523
        https://bugs.webkit.org/show_bug.cgi?id=139805

        Reviewed by Csaba Osztrogonác.

        * wtf/Ref.h: Include <wtf/StdLibExtras.h> to use std::exchange().

2014-12-18  Gavin Barraclough  <barraclough@apple.com>

        Add strong typing to RefCounter interface, return value as a bool.
        https://bugs.webkit.org/show_bug.cgi?id=139776

        Unreviewed style fixes.

        * wtf/RefCounter.h:
        (WTF::=):

2014-12-18  Brent Fulgham  <bfulgham@apple.com>

        [Win] Build correction after r177541.

        * wtf/RefCounter.h:
        (WTF::RefCounter::Token<T>::Token): Revise constructor inlines to correct
        syntax error.

2014-12-18  Gavin Barraclough  <barraclough@apple.com>

        Add strong typing to RefCounter interface, return value as a bool.
        https://bugs.webkit.org/show_bug.cgi?id=139776

        Reviewed by Geoff Garen.

        Currently all token vended by a RefCounter have the same type - Ref<RefCounter::Count>.
        This means there is no compile time type checking to prevent mistakes. Update the count()
        method to token<>(), templated on type used to identify the token being returned.
        Calls to token<T>() will return a result of type RefCounter::Token<T>.

        There are a few problems with the fact the counter will return you an exact count of the
        number of outstanding tokens:
          - It is desirable to only fire the callback on zero-edge changes; it is more consistent
            to do so if the value is only readable as a boolean.
          - It is desirable to provide the value as an argument to the callback, however to make
            this useful for integer values it is also necessary to indicate the direction of change
            (0->1 is often interesting where 2->1 is not).
          - There is a mismatch between the precision of returning a count, and the inherent
            imprecision of a token based mechanism, where it may be difficult to guarantee
            absolutely no unnecessary refcount churn, and thus unintentional counter values.

        * wtf/RefCounter.cpp:
        (WTF::RefCounter::Count::ref):
        (WTF::RefCounter::Count::deref):
            - only call the callback on zero-edge changes; provide the value.
        (WTF::RefCounter::RefCounter):
            - callback now takes a bool argument.
        * wtf/RefCounter.h:
        (WTF::RefCounter::Token::Token):
            - New opaque type to reference the RefCounter::Count.
        (WTF::RefCounter::Token::operator!):
            - ! operator checks for null / anasigned Tokens.
        (WTF::RefCounter::RefCounter):
            - callback now takes a bool argument.
        (WTF::RefCounter::token):
            - renamed from count(), templated on type of token returned.
        (WTF::RefCounter::value):
            - now returns a bool.
        (WTF::RefCounter::Token<T>::Token):
        (WTF::=):
            - Tokens can be copied & assigned.
        (WTF::RefCounter::count): Deleted.
            - renamed to token<>().

2014-12-18  Anders Carlsson  <andersca@apple.com>

        Simplify smart pointer classes by using std::exchange
        https://bugs.webkit.org/show_bug.cgi?id=139790

        Reviewed by Andreas Kling.

        * wtf/MallocPtr.h:
        * wtf/OSObjectPtr.h:
        * wtf/OwnPtr.h:
        (WTF::OwnPtr<T>::clear):
        (WTF::OwnPtr<T>::release):
        (WTF::OwnPtr<T>::leakPtr):
        (WTF::=):
        * wtf/PassOwnPtr.h:
        (WTF::PassOwnPtr<T>::leakPtr):
        * wtf/PassRefPtr.h:
        (WTF::PassRefPtr<T>::leakRef):
        * wtf/Ref.h:
        * wtf/RefPtr.h:
        (WTF::RefPtr<T>::clear):
        (WTF::RefPtr<T>::leakRef):
        * wtf/RetainPtr.h:
        (WTF::RetainPtr<T>::leakRef):

2014-12-18  Anders Carlsson  <andersca@apple.com>

        Clean up MachSendRight and add a copySendRight member function
        https://bugs.webkit.org/show_bug.cgi?id=139788

        Reviewed by Tim Horton.

        * wtf/StdLibExtras.h:
        (std::exchange):
        Add an implementation of std::exchange.

2014-12-17  Chris Dumez  <cdumez@apple.com>

        [iOS] Make it possible to toggle FeatureCounter support at runtime
        https://bugs.webkit.org/show_bug.cgi?id=139688
        <rdar://problem/19266254>

        Reviewed by Andreas Kling.

        Remove FeatureCounter API from WTF and move it to WebCore/platform
        instead so that it can log conditionally based on a WebCore setting.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:

2014-12-17  Brent Fulgham  <bfulgham@apple.com>

        [Win] Correct DebugSuffix builds under MSBuild
        https://bugs.webkit.org/show_bug.cgi?id=139733
        <rdar://problem/19276880>

        Reviewed by Simon Fraser.

        * WTF.vcxproj/WTF.proj: Make sure to use the '_debug' suffix
        when building the DebugSuffix target.

2014-12-17  Anders Carlsson  <andersca@apple.com>

        Make Ref::copyRef const and ref-qualified
        https://bugs.webkit.org/show_bug.cgi?id=139730

        Reviewed by Andreas Kling.

        * wtf/Ref.h:

2014-12-16  Daniel Bates  <dabates@apple.com>

        [iOS] WTF fails to build with public SDK due to missing header CPAggregateDictionary.h
        https://bugs.webkit.org/show_bug.cgi?id=139695

        Reviewed by Chris Dumez.

        Add USE(APPLE_INTERNAL_SDK)-guard around iOS-specific feature counter implementation
        as we are only interested in counting features in builds of iOS WebKit that were built
        with the Apple Internal SDK.

        * wtf/FeatureCounter.cpp:
        * wtf/ios/FeatureCounter.mm:

2014-12-16  Geoffrey Garen  <ggaren@apple.com>

        Enable FastMalloc in debug builds
        https://bugs.webkit.org/show_bug.cgi?id=139692

        Reviewed by Alexey Proskuryakov.

        This will give debug builds greater fidelity to the real thing.

        FastMalloc now transparently supports all the malloc debugging APIs I
        know of by disabling itself at runtime -- and it should be easy to add
        support for any APIs I missed -- so there's no need to turn it off in
        debug builds.

        * wtf/FastMalloc.cpp:

2014-12-16  Anders Carlsson  <andersca@apple.com>

        RefPtr::copyRef should be const
        https://bugs.webkit.org/show_bug.cgi?id=139689

        Reviewed by Andreas Kling.

        copyRef() doesn't modify the original object so it should be const.
        Also, add a && qualified overload and mark it deleted so that calls to copyRef() where
        the object is an rvalue will fail to compile.

        * wtf/RefPtr.h:

2014-12-15  Chris Dumez  <cdumez@apple.com>

        [iOS] Add feature counting support
        https://bugs.webkit.org/show_bug.cgi?id=139652
        <rdar://problem/19255690>

        Reviewed by Gavin Barraclough.

        Add a FeatureCounter API for to log / count when a feature
        is used. For now, this is only implementated on iOS.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/FeatureCounter.cpp: Added.
        (WTF::incrementFeatureCounterKey):
        (WTF::setFeatureCounterKey):
        * wtf/FeatureCounter.h: Added.
        * wtf/ios/FeatureCounter.mm: Added.
        (WTF::incrementFeatureCounterKey):
        (WTF::setFeatureCounterKey):

2014-12-12  Anders Carlsson  <andersca@apple.com>

        Get rid of the DONT_FINALIZE_ON_MAIN_THREAD #define
        https://bugs.webkit.org/show_bug.cgi?id=139613

        Reviewed by Sam Weinig.

        * wtf/Platform.h:
        Remove the #define.

2014-12-15  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r177284.
        https://bugs.webkit.org/show_bug.cgi?id=139658

        "Breaks API tests and LayoutTests on Yosemite Debug"
        (Requested by msaboff on #webkit).

        Reverted changeset:

        "Make sure range based iteration of Vector<> still receives
        bounds checking"
        https://bugs.webkit.org/show_bug.cgi?id=138821
        http://trac.webkit.org/changeset/177284

2014-12-15  Andreas Kling  <akling@apple.com>

        Purge PassRefPtr from FocusEvent code.
        <https://webkit.org/b/139647>

        Reviewed by Anders Carlsson.

        Add a RefPtr::copyRef() to use when passing a RefPtr to a RefPtr&& without
        transferring the ownership.

        * wtf/RefPtr.h:

2014-12-15  Oliver Hunt  <oliver@apple.com>

        Make sure range based iteration of Vector<> still receives bounds checking
        https://bugs.webkit.org/show_bug.cgi?id=138821

        Reviewed by Mark Lam.

        Add a new IndexedIterator struct to WTF that wraps a
        Vector type and index to provide pointer like semantics
        while still performing runtime bounds checking, even in
        release builds. We store a simple index into the vector
        which means that this iterator allows vector resizing
        during iteration. If the vector is resized such that the
        iterator is out of bounds, then any attempt to dereference
        the iterator will crash safely.

        For the purpose of retaining semantically equivalent
        behaviour, the iterator can be moved to m_index == size()
        as that is the standard "end" terminator for these types.
        Attempting to dereference at that point will still crash
        rather than perform an unsafe memory operation.

        By necessity there are many overrides for operator + and - as
        we otherwise hit many different type promotion ambiguities when
        performing arithmetic with iterators. These ambiguities are also
        different for 32- vs. 64-bit, so duplicating the functions
        and then forwarding to the core implementations that performed
        the bounds checking and mutation seemed like the right call.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/IndexedIterator.h: Added.
        (WTF::IndexedIterator::IndexedIterator):
        (WTF::IndexedIterator::operator->):
        (WTF::IndexedIterator::operator*):
        (WTF::IndexedIterator::get):
        (WTF::IndexedIterator::operator++):
        (WTF::IndexedIterator::operator--):
        (WTF::IndexedIterator::operator UnspecifiedBoolType):
        (WTF::IndexedIterator::operator-):
        (WTF::IndexedIterator::operator=):
        (WTF::IndexedIterator::operator==):
        (WTF::IndexedIterator::operator!=):
        (WTF::IndexedIterator::operator<):
        (WTF::IndexedIterator::operator<=):
        (WTF::IndexedIterator::operator>):
        (WTF::IndexedIterator::operator>=):
        (WTF::IndexedIterator::operator const_iterator):
        (WTF::IndexedIterator::unsafeGet):
        (WTF::getPtr):
        (WTF::operator-):
        (WTF::operator==):
        (WTF::operator!=):
        (WTF::operator<=):
        (WTF::operator>=):
        (WTF::operator<):
        (WTF::operator>):
        (WTF::IndexedIteratorSelector::makeIterator):
        (WTF::IndexedIteratorSelector::makeConstIterator):
        * wtf/RefCountedArray.h:
        (WTF::RefCountedArray::RefCountedArray):
        * wtf/Vector.h:
        (WTF::Vector::Vector):
        (WTF::Vector::begin):
        (WTF::Vector::end):
        (WTF::OverflowHandler>::Vector):
        (WTF::=):
        (WTF::OverflowHandler>::fill):
        (WTF::OverflowHandler>::expandCapacity):
        (WTF::OverflowHandler>::tryExpandCapacity):
        (WTF::OverflowHandler>::resize):
        (WTF::OverflowHandler>::shrink):
        (WTF::OverflowHandler>::grow):
        (WTF::OverflowHandler>::reserveCapacity):
        (WTF::OverflowHandler>::tryReserveCapacity):
        (WTF::OverflowHandler>::shrinkCapacity):
        (WTF::OverflowHandler>::append):
        (WTF::OverflowHandler>::tryAppend):
        (WTF::OverflowHandler>::appendSlowCase):
        (WTF::OverflowHandler>::uncheckedAppend):
        (WTF::OverflowHandler>::appendVector):
        (WTF::OverflowHandler>::insert):
        (WTF::OverflowHandler>::insertVector):
        (WTF::OverflowHandler>::remove):

2014-12-14  Andreas Kling  <akling@apple.com>

        Minor follow-up tweaks suggested by Darin on bug 139587.

        * wtf/text/WTFString.h:
        (WTF::String::String):

2014-12-14  Andreas Kling  <akling@apple.com>

        Replace PassRef with Ref/Ref&& across the board.
        <https://webkit.org/b/139587>

        Reviewed by Darin Adler.

        Kill the PassRef class and replace it by Ref/Ref&&.
        Usage is simple:

            - For locals and members, keep using Ref<T>.
            - For return types, use Ref<T>.
            - For (ownership-transferring) arguments, use Ref<T>&&.

        When passing to a Ref&&, use WTF::move() to mobilize the value
        at the call site, e.g:

            void myFunction(Ref<Foo>&&);

            Ref<Foo> myFoo(Foo::create());
            myFunction(WTF::move(myFoo));
            // 'myFoo' is invalid from this point forward.

        As you can see, it works a lot like PassRefPtr, but unlike PassRefPtr
        it won't surprise you by becoming null *unless* you WTF::move it.

        I've also added a Ref::copyRef() for instances where you want to
        return a Ref *without* transferring ownership, e.g code like:

            Ref<Foo> foo() { return m_foo; }

        ... now becomes ...

            Ref<Foo> foo() { return m_foo.copyRef(); }

        This makes it explicit that a refcount bump will occur.

        Finally, do note that unlike last year's PassRef, Ref&& does not
        require you to move it to avoid leaking; it will clean itself up.

        * wtf/PassRef.h:
        (WTF::adopted): Deleted.
        (WTF::PassRef<T>::PassRef): Deleted.
        (WTF::PassRef<T>::~PassRef): Deleted.
        (WTF::PassRef<T>::get): Deleted.
        (WTF::PassRef<T>::ptr): Deleted.
        (WTF::PassRef<T>::leakRef): Deleted.
        (WTF::adoptRef): Deleted.
        (WTF::createRefCounted): Deleted.
        * wtf/PassRefPtr.h:
        (WTF::PassRefPtr::PassRefPtr):
        * wtf/Ref.h:
        (WTF::adopted):
        (WTF::Ref::~Ref):
        (WTF::Ref::Ref):
        (WTF::Ref::operator=):
        (WTF::Ref::operator->):
        (WTF::Ref::ptr):
        (WTF::Ref::get):
        (WTF::Ref::operator T&):
        (WTF::Ref::operator const T&):
        (WTF::Ref<T>::replace):
        (WTF::adoptRef):
        * wtf/RefCounter.h:
        (WTF::RefCounter::count):
        * wtf/RefPtr.h:
        (WTF::RefPtr::releaseNonNull):
        (WTF::RefPtr<T>::RefPtr):
        (WTF::=):
        * wtf/text/AtomicString.cpp:
        (WTF::addToStringTable):
        (WTF::AtomicString::add):
        (WTF::AtomicString::addFromLiteralData):
        (WTF::AtomicString::addSlowCase):
        * wtf/text/AtomicString.h:
        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::createFromLiteral):
        (WTF::StringImpl::createWithoutCopying):
        (WTF::StringImpl::createUninitializedInternal):
        (WTF::StringImpl::createUninitializedInternalNonEmpty):
        (WTF::StringImpl::createUninitialized):
        (WTF::StringImpl::reallocateInternal):
        (WTF::StringImpl::reallocate):
        (WTF::StringImpl::createInternal):
        (WTF::StringImpl::create):
        (WTF::StringImpl::create8BitIfPossible):
        (WTF::StringImpl::substring):
        (WTF::StringImpl::lower):
        (WTF::StringImpl::upper):
        (WTF::StringImpl::fill):
        (WTF::StringImpl::foldCase):
        (WTF::StringImpl::convertToASCIILowercase):
        (WTF::StringImpl::stripMatchedCharacters):
        (WTF::StringImpl::stripWhiteSpace):
        (WTF::StringImpl::removeCharacters):
        (WTF::StringImpl::simplifyMatchedCharactersToSpace):
        (WTF::StringImpl::simplifyWhiteSpace):
        (WTF::StringImpl::replace):
        (WTF::StringImpl::adopt):
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::create8BitIfPossible):
        (WTF::StringImpl::create):
        (WTF::StringImpl::createSubstringSharingImpl8):
        (WTF::StringImpl::createSubstringSharingImpl):
        (WTF::StringImpl::createFromLiteral):
        (WTF::StringImpl::createEmptyUnique):
        (WTF::StringImpl::adopt):
        (WTF::StringImpl::replace):
        (WTF::StringImpl::constructInternal<LChar>):
        (WTF::StringImpl::constructInternal<UChar>):
        (WTF::StringImpl::isolatedCopy):
        * wtf/text/WTFString.h:
        (WTF::String::String):

2014-12-10  Geoffrey Garen  <ggaren@apple.com>

        Please disable the webkitFirstVersionWithInitConstructorSupport check on Apple TV
        https://bugs.webkit.org/show_bug.cgi?id=139501

        Reviewed by Gavin Barraclough.

        Added a platform definition for APPLETV.

        (It's not an OS because it's not mutually exclusive with other OS definitions.)

        * wtf/Platform.h:

2014-12-10  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Add support for text-decoration-skip
        https://bugs.webkit.org/show_bug.cgi?id=131540

        Reviewed by Gustavo Noronha Silva.

        * wtf/Platform.h: Enable text decoration skip by default.

2014-12-09  David Kilzer  <ddkilzer@apple.com>

        Switch from using PLATFORM_NAME to SDK selectors in ANGLE, bmalloc, gtest, JavaScriptCore, WTF
        <http://webkit.org/b/139212>

        Reviewed by Joseph Pecoraro.

        * Configurations/Base.xcconfig:
        - Only set GCC_ENABLE_OBJC_GC, GCC_MODEL_TUNING and TOOLCHAINS
          on OS X.
        * Configurations/DebugRelease.xcconfig:
        - Only set MACOSX_DEPLOYMENT_TARGET and SDKROOT on OS X.

2014-12-09  Dean Jackson  <dino@apple.com>

        [Apple] Use Accelerate framework to speed-up FEGaussianBlur
        https://bugs.webkit.org/show_bug.cgi?id=139310

        Unreviewed followup, after comments by Andreas Kling.

        It was pointed out that we already have a USE(ACCELERATE), so
        we don't need a HAVE(ACCELERATE) :)

        * wtf/Platform.h:

2014-12-09  Alberto Garcia  <berto@igalia.com>

        Undefined Symbol build error "_objc_registerThreadWithCollector" when building WebKit GTK Mac OS X on Snow Leopard
        https://bugs.webkit.org/show_bug.cgi?id=58737

        Reviewed by Darin Adler.

        Replace OS(MAC_OS_X) with PLATFORM(MAC) to prevent using
        osx-specific code in WebKitGTK+ builds.

        * wtf/ThreadingPthreads.cpp:
        (WTF::initializeCurrentThreadInternal):

2014-12-08  Dean Jackson  <dino@apple.com>

        [Apple] Use Accelerate framework to speed-up FEGaussianBlur
        https://bugs.webkit.org/show_bug.cgi?id=139310
        <rdar://problem/18434594>

        Reviewed by Simon Fraser.

        Add a HAVE_ACCELERATE flag, true on Apple platforms.

        * wtf/Platform.h:

2014-12-08  Myles C. Maxfield  <mmaxfield@apple.com>

        Fix iOS build after r176971.

        I had previously modified the WTF forwarding header instead of modifying the real source.

        * wtf/unicode/CharacterNames.h:

2014-12-08  Anders Carlsson  <andersca@apple.com>

        Change WTF::currentCPUTime to return std::chrono::microseconds and get rid of currentCPUTimeMS
        https://bugs.webkit.org/show_bug.cgi?id=139410

        Reviewed by Andreas Kling.

        * wtf/CurrentTime.cpp:
        (WTF::currentCPUTime):
        (WTF::currentCPUTimeMS): Deleted.
        * wtf/CurrentTime.h:

2014-12-08  Chris Dumez  <cdumez@apple.com>

        Revert r176293 & r176275

        Unreviewed, revert r176293 & r176275 changing the Vector API to use unsigned type
        instead of size_t. There is some disagreement regarding the long-term direction
        of the API and we shouldn’t leave the API partly transitioned to unsigned type
        while making a decision.

        * wtf/Forward.h:
        * wtf/Vector.h:
        (WTF::VectorTypeOperations::compare):
        (WTF::VectorBufferBase::allocateBuffer):
        (WTF::VectorBufferBase::tryAllocateBuffer):
        (WTF::VectorBufferBase::shouldReallocateBuffer):
        (WTF::VectorBufferBase::reallocateBuffer):
        (WTF::VectorBufferBase::capacity):
        (WTF::VectorBufferBase::VectorBufferBase):
        (WTF::VectorBuffer::VectorBuffer):
        (WTF::VectorBuffer::allocateBuffer):
        (WTF::VectorBuffer::tryAllocateBuffer):
        (WTF::VectorBuffer::shouldReallocateBuffer):
        (WTF::VectorBuffer::reallocateBuffer):
        (WTF::VectorBuffer::swap):
        (WTF::VectorBuffer::swapInlineBuffer):
        (WTF::VectorBuffer::swapInlineBuffers):
        (WTF::Vector::Vector):
        (WTF::Vector::capacity):
        (WTF::Vector::at):
        (WTF::Vector::operator[]):
        (WTF::OverflowHandler>::find):
        (WTF::OverflowHandler>::reverseFind):
        (WTF::OverflowHandler>::fill):
        (WTF::OverflowHandler>::expandCapacity):
        (WTF::OverflowHandler>::tryExpandCapacity):
        (WTF::OverflowHandler>::resize):
        (WTF::OverflowHandler>::resizeToFit):
        (WTF::OverflowHandler>::shrink):
        (WTF::OverflowHandler>::grow):
        (WTF::OverflowHandler>::reserveCapacity):
        (WTF::OverflowHandler>::tryReserveCapacity):
        (WTF::OverflowHandler>::reserveInitialCapacity):
        (WTF::OverflowHandler>::shrinkCapacity):
        (WTF::OverflowHandler>::append):
        (WTF::OverflowHandler>::tryAppend):
        (WTF::OverflowHandler>::insert):
        (WTF::OverflowHandler>::insertVector):
        (WTF::OverflowHandler>::remove):
        (WTF::OverflowHandler>::reverse):
        (WTF::OverflowHandler>::checkConsistency):
        * wtf/text/AtomicString.h:
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::adopt):
        (WTF::equalIgnoringNullity):
        * wtf/text/StringView.h:
        (WTF::append):
        * wtf/text/WTFString.h:

2014-12-07  Andreas Kling  <akling@apple.com>

        Use more PassRef in AtomicString.
        <https://webkit.org/b/139319>

        Reviewed by Antti Koivisto.

        Make a pass over AtomicString and convert functions that return PassRefPtr
        into returning RefPtr (where it may be null) and PassRef otherwise.
        This allows the compiler to skip null checks in many places.

        * wtf/text/AtomicString.cpp:
        (WTF::addToStringTable):
        (WTF::AtomicString::add):
        (WTF::AtomicString::addFromLiteralData):
        (WTF::AtomicString::addSlowCase):
        * wtf/text/AtomicString.h:
        (WTF::AtomicString::add):
        (WTF::AtomicString::addWithStringTableProvider):
        * wtf/text/cf/AtomicStringCF.cpp:
        (WTF::AtomicString::add):

2014-12-05  Roger Fong  <roger_fong@apple.com>

        [Win] proj files copying over too many resources..
        https://bugs.webkit.org/show_bug.cgi?id=139315.
        <rdar://problem/19148278>

        Reviewed by Brent Fulgham.

        * WTF.vcxproj/WTF.proj: Only copy WTF.dll.

2014-12-05  Andreas Kling  <akling@apple.com>

        PassRef should deref on destruction if pointee was not moved.
        <https://webkit.org/b/139309>

        Reviewed by Antti Koivisto.

        Let PassRef become nullptr internally after having WTF::move()'d the pointee.
        This means that PassRef is now essentially a PassRefPtr that can only be
        constructed with a non-null pointee.

        This should make it possible for all ::create()-style construction helpers to
        return PassRef, removing a branch in each case.

        * wtf/PassRef.h:
        (WTF::PassRef<T>::PassRef):
        (WTF::PassRef<T>::~PassRef):
        (WTF::PassRef<T>::get):
        (WTF::PassRef<T>::ptr):
        (WTF::PassRef<T>::leakRef):
        (WTF::PassRef<T>::dropRef): Deleted.

2014-12-05  Jer Noble  <jer.noble@apple.com>

        [WTF] MediaTime should support round-tripping from and to doubles.
        https://bugs.webkit.org/show_bug.cgi?id=139248

        Reviewed by Eric Carlson.

        MediaTimes should be able to return precisely the same double value as was used
        when the MediaTime was created, so long as that MediaTime was not modified in a
        non-destructive way. This will allow API which accepts floating-point values to
        return the exact same value when asked, but still be able to store that value
        as a MediaTime.

        * wtf/MediaTime.cpp:
        (WTF::MediaTime::createWithFloat): Added; store the floating-point value in a union.
        (WTF::MediaTime::createWithDouble): Ditto.
        (WTF::MediaTime::toFloat): If the value is a double, just return it.
        (WTF::MediaTime::toDouble): Ditto.
        (WTF::MediaTime::operator+): Special case when one or both sides are doubles.
        (WTF::MediaTime::operator-): Ditto.
        (WTF::MediaTime::operator*): Ditto.
        (WTF::MediaTime::compare): Ditto.
        (WTF::abs): Ditto.
        (WTF::MediaTime::setTimeScale): Convert the MediaTime from a double.

2014-12-05  peavo@outlook.com  <peavo@outlook.com>

        [WinCairo] WTF project is missing a GStreamer source file.
        https://bugs.webkit.org/show_bug.cgi?id=139296

        Reviewed by Philippe Normand.

        The WTF project file is missing a GStreamer source file,
        causing a link error when compiling with GStreamer enabled.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:

2014-12-04  David Kilzer  <ddkilzer@apple.com>

        REGRESSION (r176683): RefCounter.h is installed outside SDKROOT

        * WTF.xcodeproj/project.pbxproj: Don't mark RefCounter.h as a
        private header.  WTF headers use a special build phase script to
        be installed.

2014-12-04  Anders Carlsson  <andersca@apple.com>

        Make API::String copy the underlying strings if needed, for thread safety
        https://bugs.webkit.org/show_bug.cgi?id=139261

        Reviewed by Sam Weinig.

        * wtf/RefPtr.h:
        (WTF::RefPtr<T>::leakRef):
        Add a leakRef() to RefPtr so we don't have to go through PassRefPtr.

        * wtf/text/WTFString.cpp:
        (WTF::String::isSafeToSendToAnotherThread):
        Check if the string is empty before checking whether it's in an atomic string table.
        It's safe to send empty strings to other threads even if they're in the atomic string table
        since they will never be deallocated.

2014-12-04  Csaba Osztrogonác  <ossy@webkit.org>

        Fix cast-align warning in StringImpl.h
        https://bugs.webkit.org/show_bug.cgi?id=139222

        Reviewed by Anders Carlsson.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::tailPointer):

2014-12-02  Mark Lam  <mark.lam@apple.com>

        Rolling out r176592, r176603, r176616, and r176705 until build and perf issues are resolved.
        https://bugs.webkit.org/show_bug.cgi?id=138821

        Not reviewed.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/IndexedIterator.h: Removed.
        * wtf/RefCountedArray.h:
        (WTF::RefCountedArray::RefCountedArray):
        * wtf/Vector.h:
        (WTF::Vector::Vector):
        (WTF::Vector::begin):
        (WTF::Vector::end):
        (WTF::OverflowHandler>::Vector):
        (WTF::=):
        (WTF::OverflowHandler>::fill):
        (WTF::OverflowHandler>::expandCapacity):
        (WTF::OverflowHandler>::tryExpandCapacity):
        (WTF::OverflowHandler>::resize):
        (WTF::OverflowHandler>::shrink):
        (WTF::OverflowHandler>::grow):
        (WTF::OverflowHandler>::reserveCapacity):
        (WTF::OverflowHandler>::tryReserveCapacity):
        (WTF::OverflowHandler>::shrinkCapacity):
        (WTF::OverflowHandler>::append):
        (WTF::OverflowHandler>::tryAppend):
        (WTF::OverflowHandler>::appendSlowCase):
        (WTF::OverflowHandler>::uncheckedAppend):
        (WTF::OverflowHandler>::appendVector):
        (WTF::OverflowHandler>::insert):
        (WTF::OverflowHandler>::insertVector):
        (WTF::OverflowHandler>::remove):

2014-12-02  Oliver Hunt  <oliver@apple.com>

        Fix IOS builds.

        * wtf/IndexedIterator.h:

2014-12-02  Gavin Barraclough  <barraclough@apple.com>

        Generalize PageActivityAssertionToken
        https://bugs.webkit.org/show_bug.cgi?id=139106

        Reviewed by Sam Weinig.

        PageActivityAssertionToken is a RAII mechanism implementing a counter, used by PageThrottler
        to count user visible activity in progress on the page (currently page load and media playback).
        Use of an RAII type is prevents a number of possible errors, including double counting a single
        media element, or failing to decrement the count after a media element has been deallocated.

        The current implementation has a number of drawbacks that have been addressed by this refactoring:
         - specific to single use in PageThrottler class - not reusable.
         - incomplete encapsulation - the counter and WeakPtrFactory that comprise the current implementation
           are not encapsulated (are in the client type, PageThrottler).
         - tokens are not shared - PageActivityAssertionToken instances are managed by std::unique, every
           increment requires an object allocation.
         - redundancy - the current implementation uses a WeakPtr to safely reference the PageThrottler, this
           is internally implemented using a reference counted type, resulting in two counters being
           incremented (one in the PageActivityAssertionToken, one in the PageThrottler).

        In the reimplementation:
         - a callback is provided via a lambda function, which allows for easy reuse without a lot of
           boilerplate code.
         - the counter, callback and ownership of the otherwise weakly-owned token is encapsulated within the
           RefCounter type.
         - a single count within RefCounter::Count stores the counter value, and also manage the lifetime
           of this object.
         - standard RefPtrs are used to manage references to the RefCounter::Count.

        * WTF.xcodeproj/project.pbxproj:
            - added RefCounter.cpp/.h
        * wtf/RefCounter.cpp: Added.
        (WTF::RefCounter::Count::ref):
            - increment the counter.
        (WTF::RefCounter::Count::deref):
            - decrement the counter, and delete as necessary.
        (WTF::RefCounter::RefCounter):
            - create a RefCounter::Count.
        (WTF::RefCounter::~RefCounter):
            - eagerly delete the Counter if it has no references, otherwise let it be deleted on last deref.
        * wtf/RefCounter.h: Added.
        (WTF::RefCounter::Count::Count):
            - initialize count to 0.
        (WTF::RefCounter::RefCounter):
            - takes a lambda to be called when the value changes.
        (WTF::RefCounter::count):
            - reference the counter (and in doing so increment the count).
        (WTF::RefCounter::value):
            - access the current value of the counter.

2014-12-01  Andreas Kling  <akling@apple.com>

        Optimize constructing JSC::Identifier from AtomicString.
        <https://webkit.org/b/139157>

        Reviewed by Michael Saboff.

        Make AtomicString::isInAtomicStringTable() public so it can be used
        in some Identifier assertions.

        * wtf/text/AtomicString.h:

2014-12-01  Oliver Hunt  <oliver@apple.com>

        Fix non-mac builds.

        * wtf/IndexedIterator.h:

2014-12-01  Oliver Hunt  <oliver@apple.com>

        Fix 32-bit build.

        * wtf/IndexedIterator.h:

2014-11-17  Oliver Hunt  <oliver@apple.com>

        Make sure range based iteration of Vector<> still receives bounds checking
        https://bugs.webkit.org/show_bug.cgi?id=138821

        Reviewed by Mark Lam.

        Add a new IndexedIterator struct to WTF that wraps a
        Vector type and index to provide pointer like semantics
        while still performing runtime bounds checking, even in
        release builds. We store a simple index into the vector
        which means that this iterator allows vector resizing
        during iteration. If the vector is resized such that the
        iterator is out of bounds, then any attempt to dereference
        the iterator will crash safely. Any other errors, including
        overflows, and over extending the iterator will likewise
        crash.

        For the purpose of retaining semantically equivalent
        behaviour, the iterator can be moved to m_index == size()
        as that is the standard "end" terminator for these types.
        Attempting to dereference at that point will still crash
        rather than perform an unsafe memory operation.

        In order to maintain the validity of all the bounds checking,
        we perform full integer range checking prior to any mutation
        of the iterator location. If we detect an arithmetic overflow
        we will crash rather than attempting to carry on.

        By necessity there are many overrides for operator + and - as
        we otherwise hit many different type promotion ambiguities when
        performing arithmetic with iterators. These ambiguities are also
        different for 32- vs. 64-bit, so duplicating the functions
        and then forwarding to the core implementations that performed
        the bounds checking and mutation seemed like the right call.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/IndexedIterator.h: Added.
        (WTF::IndexedIterator::IndexedIterator):
        (WTF::IndexedIterator::operator->):
        (WTF::IndexedIterator::operator*):
        (WTF::IndexedIterator::get):
        (WTF::IndexedIterator::operator++):
        (WTF::IndexedIterator::operator--):
        (WTF::IndexedIterator::operator UnspecifiedBoolType):
        (WTF::IndexedIterator::operator+=):
        (WTF::IndexedIterator::operator-=):
        (WTF::IndexedIterator::operator+):
        (WTF::IndexedIterator::operator-):
        (WTF::IndexedIterator::operator=):
        (WTF::IndexedIterator::operator==):
        (WTF::IndexedIterator::operator!=):
        (WTF::IndexedIterator::operator<):
        (WTF::IndexedIterator::operator<=):
        (WTF::IndexedIterator::operator>):
        (WTF::IndexedIterator::operator>=):
        (WTF::IndexedIterator::operator const_iterator):
        (WTF::IndexedIterator::isSafeToCompare):
        (WTF::IndexedIterator::unsafeGet):
        (WTF::getPtr):
        (WTF::operator-):
        (WTF::operator==):
        (WTF::operator!=):
        (WTF::operator<=):
        (WTF::operator>=):
        (WTF::operator<):
        (WTF::operator>):
        (WTF::IndexedIteratorSelector::makeIterator):
        (WTF::IndexedIteratorSelector::makeConstIterator):
        * wtf/RefCountedArray.h:
        (WTF::RefCountedArray::RefCountedArray):
        * wtf/Vector.h:
        (WTF::Vector::Vector):
        (WTF::Vector::begin):
        (WTF::Vector::end):
        (WTF::OverflowHandler>::Vector):
        (WTF::=):
        (WTF::OverflowHandler>::fill):
        (WTF::OverflowHandler>::expandCapacity):
        (WTF::OverflowHandler>::tryExpandCapacity):
        (WTF::OverflowHandler>::resize):
        (WTF::OverflowHandler>::shrink):
        (WTF::OverflowHandler>::grow):
        (WTF::OverflowHandler>::reserveCapacity):
        (WTF::OverflowHandler>::tryReserveCapacity):
        (WTF::OverflowHandler>::shrinkCapacity):
        (WTF::OverflowHandler>::append):
        (WTF::OverflowHandler>::tryAppend):
        (WTF::OverflowHandler>::appendSlowCase):
        (WTF::OverflowHandler>::uncheckedAppend):
        (WTF::OverflowHandler>::appendVector):
        (WTF::OverflowHandler>::insert):
        (WTF::OverflowHandler>::insertVector):
        (WTF::OverflowHandler>::remove):

2014-11-30  Ryuan Choi  <ryuan.choi@navercorp.com>

        [EFL] Drop support for the EFL 1.7
        https://bugs.webkit.org/show_bug.cgi?id=139114

        Reviewed by Gyuyoung Kim.

        * wtf/efl/EflTypedefs.h: Removed old definitions which EFL 1.7 used.

2014-11-21  Anders Carlsson  <andersca@apple.com>

        Remove the Timer parameters from timer callbacks
        https://bugs.webkit.org/show_bug.cgi?id=138974

        Reviewed by Antti Koivisto.

        * wtf/RunLoopTimer.h:
        (WTF::RunLoopTimer::RunLoopTimer):
        (WTF::RunLoopTimer::fired):

2014-11-18  Chris Dumez  <cdumez@apple.com>

        Have Vector::capacity() return an unsigned instead of a size_t
        https://bugs.webkit.org/show_bug.cgi?id=138842

        Reviewed by Andreas Kling.

        Have Vector::capacity() return an unsigned instead of a size_t as
        capacity is stored as an unsigned internally.

        * wtf/Vector.h:
        (WTF::Vector::capacity):
        (WTF::OverflowHandler>::expandCapacity):
        (WTF::OverflowHandler>::tryExpandCapacity):

2014-11-18  Geoffrey Garen  <ggaren@apple.com>

        Removed the custom allocator for ListHashSet nodes
        https://bugs.webkit.org/show_bug.cgi?id=138841

        Reviewed by Andreas Kling.

        bmalloc is fast, so we don't need a custom allocator.

        The MallocBench test for linked list node allocation (list_allocate) is
        4.09X faster in bmalloc than TCMalloc. Also, I wrote a stress test to
        add/remove link elements, which modify a ListHashSet on insertion and
        removal, and it was 1% faster / in the noise with bmalloc enabled.

        * wtf/ListHashSet.h:
        (WTF::ListHashSetNode::ListHashSetNode):
        (WTF::ListHashSetTranslator::translate):
        (WTF::U>::ListHashSet):
        (WTF::=):
        (WTF::U>::swap):
        (WTF::U>::~ListHashSet):
        (WTF::U>::size):
        (WTF::U>::capacity):
        (WTF::U>::isEmpty):
        (WTF::U>::first):
        (WTF::U>::removeFirst):
        (WTF::U>::takeFirst):
        (WTF::U>::last):
        (WTF::U>::removeLast):
        (WTF::U>::takeLast):
        (WTF::U>::contains):
        (WTF::U>::remove):
        (WTF::U>::clear):
        (WTF::U>::unlink):
        (WTF::U>::unlinkAndDelete):
        (WTF::U>::appendNode):
        (WTF::U>::prependNode):
        (WTF::U>::insertNodeBefore):
        (WTF::U>::deleteAllNodes):
        (WTF::ListHashSetNodeAllocator::ListHashSetNodeAllocator): Deleted.
        (WTF::ListHashSetNodeAllocator::allocate): Deleted.
        (WTF::ListHashSetNodeAllocator::deallocate): Deleted.
        (WTF::ListHashSetNodeAllocator::pool): Deleted.
        (WTF::ListHashSetNodeAllocator::pastPool): Deleted.
        (WTF::ListHashSetNodeAllocator::inPool): Deleted.
        (WTF::ListHashSetNode::operator new): Deleted.
        (WTF::ListHashSetNode::destroy): Deleted.

2014-11-18  Chris Dumez  <cdumez@apple.com>

        Update the Vector API to deal with unsigned types instead of size_t
        https://bugs.webkit.org/show_bug.cgi?id=138824

        Reviewed by Andreas Kling.

        Update part of the Vector API to deal with unsigned types instead of
        size_t. The Vector class is already using unsigned type for its
        capacity and size data members. However, the Vector API was never
        updated accordingly.

        The rest of the Vector API will be ported in follow-up patches to
        make the change smaller and more easily reviewable.

        * wtf/Forward.h:
        * wtf/Vector.h:
        (WTF::VectorTypeOperations::compare):
        (WTF::VectorBufferBase::allocateBuffer):
        (WTF::VectorBufferBase::tryAllocateBuffer):
        (WTF::VectorBufferBase::shouldReallocateBuffer):
        (WTF::VectorBufferBase::reallocateBuffer):
        (WTF::VectorBufferBase::capacity):
        (WTF::VectorBufferBase::VectorBufferBase):
        (WTF::VectorBuffer::VectorBuffer):
        (WTF::VectorBuffer::allocateBuffer):
        (WTF::VectorBuffer::tryAllocateBuffer):
        (WTF::VectorBuffer::shouldReallocateBuffer):
        (WTF::VectorBuffer::reallocateBuffer):
        (WTF::VectorBuffer::swap):
        (WTF::VectorBuffer::swapInlineBuffer):
        (WTF::VectorBuffer::swapInlineBuffers):
        (WTF::Vector::Vector):
        (WTF::Vector::at):
        (WTF::Vector::operator[]):
        (WTF::OverflowHandler>::find):
        (WTF::OverflowHandler>::reverseFind):
        (WTF::OverflowHandler>::fill):
        (WTF::OverflowHandler>::expandCapacity):
        (WTF::OverflowHandler>::tryExpandCapacity):
        (WTF::OverflowHandler>::resize):
        (WTF::OverflowHandler>::resizeToFit):
        (WTF::OverflowHandler>::shrink):
        (WTF::OverflowHandler>::grow):
        (WTF::OverflowHandler>::reserveCapacity):
        (WTF::OverflowHandler>::tryReserveCapacity):
        (WTF::OverflowHandler>::reserveInitialCapacity):
        (WTF::OverflowHandler>::shrinkCapacity):
        (WTF::OverflowHandler>::append):
        (WTF::OverflowHandler>::tryAppend):
        (WTF::OverflowHandler>::insert):
        (WTF::OverflowHandler>::insertVector):
        (WTF::OverflowHandler>::remove):
        (WTF::OverflowHandler>::reverse):
        (WTF::OverflowHandler>::checkConsistency):
        * wtf/text/AtomicString.h:
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::adopt):
        (WTF::equalIgnoringNullity):
        * wtf/text/StringView.h:
        (WTF::append):
        * wtf/text/WTFString.h:

2014-11-18  peavo@outlook.com  <peavo@outlook.com>

        [WinCairo] Compile errors when GStreamer is enabled.
        https://bugs.webkit.org/show_bug.cgi?id=137000

        Reviewed by Philippe Normand.

        MSVC does not allow the keyword default on move constructors and move assignment operators.

        * wtf/gobject/GMainLoopSource.cpp:
        (WTF::GMainLoopSource::cancel):
        (WTF::GMainLoopSource::socketCallback):
        * wtf/gobject/GMainLoopSource.h:
        (WTF::GMainLoopSource::Context::operator=):

2014-11-17  Anders Carlsson  <andersca@apple.com>

        Fix WTF build with newer versions of clang.
        <rdar://problem/18978705>

        * wtf/HashTable.h:
        (WTF::removeIterator):
        * wtf/dtoa/utils.h:
        (WTF::double_conversion::BitCast):

2014-11-13  Myles C. Maxfield  <mmaxfield@apple.com>

        Allow constructing a base PassRef with a derived Ref
        https://bugs.webkit.org/show_bug.cgi?id=138701

        Reviewed by Andreas Kling

        * wtf/PassRef.h:
        (WTF::PassRef<T>::PassRef):

2014-11-12  Ryuan Choi  <ryuan.choi@navercorp.com>

        [EFL] Fix the build with EFL 1.12
        https://bugs.webkit.org/show_bug.cgi?id=138245

        Reviewed by Gyuyoung Kim.

        * wtf/efl/UniquePtrEfl.h:
        Removed Evas_GL.h from UniquePtrEfl.h, which is commonly included, because
        it should not be included with official GL headers.

2014-11-12  Mark Lam  <mark.lam@apple.com>

        Rename USE(MASM_PROBE) to ENABLE(MASM_PROBE).
        <https://webkit.org/b/138661>

        Reviewed by Michael Saboff.

        Also move the switch for enabling the use of MASM_PROBE from JavaScriptCore's
        config.h to WTF's Platform.h.  This ensures that the setting is consistently
        applied even when building WebCore parts as well.

        * wtf/Platform.h:

2014-11-09  Antti Koivisto  <antti@apple.com>

        Remove BloomFilter size limit
        https://bugs.webkit.org/show_bug.cgi?id=138549

        Reviewed by Andreas Kling.

        * wtf/BloomFilter.h: Remove the static_assert, the code works fine with somewhat larger sizes.

2014-11-09  Chris Dumez  <cdumez@apple.com>

        Add a more correct way to compare floating point numbers and use it
        https://bugs.webkit.org/show_bug.cgi?id=138527

        Reviewed by Darin Adler.

        To compare floating point numbers in the code base, we would often rely
        on the following check:
        std::abs(a - b) <= std::numeric_limits<T>::epsilon()

        However, this is not correct for arbitrary floating point values, and
        will fail for values that are not close to zero.

        This patch introduces a WTF::areEssentiallyEqual() templated function
        that can only be called with floating point types and relies on the
        following formula from [1][2] that defines u as being "essentially
        equal" to v if: | u - v | / |u| <= e and | u - v | / |v| <= e

        [1] Knuth, D. E. "Accuracy of Floating Point Arithmetic." The Art of
            Computer Programming. 3rd ed. Vol. 2. Boston: Addison-Wesley, 1998.
            229-45.
        [2] http://www.boost.org/doc/libs/1_34_0/libs/test/doc/components/test_tools/floating_point_comparison.html

        * wtf/MathExtras.h:
        (WTF::safeFPDivision):
        (WTF::areEssentiallyEqual):
        (WTF::withinEpsilon): Deleted.

2014-11-08  Darin Adler  <darin@apple.com>

        Replace FileThread class with a single function
        https://bugs.webkit.org/show_bug.cgi?id=138282

        Reviewed by Alexey Proskuryakov.

        * wtf/MessageQueue.h: Made queue work on any type and not require wrapping
        everything in a unique_ptr.

        * wtf/Threading.cpp:
        (WTF::threadEntryPoint): Changed to use a std::function instead of a function pointer.
        (WTF::createThread): Add a version that takes a std::function. Reimplemented the
        old version using lambdas. Removed the obsolete versions that were there just to support
        binary compatibility with very old versions of Safari.

        * wtf/Threading.h: Removed an incorrect license header that covers code that was long ago
        moved to a different file. Changed createThread to take a std::function instead of a function
        pointer and data pointer. Moved internal functions after public functions.

2014-11-05  Chris Dumez  <cdumez@apple.com>

        Assertion hit DOMTimer::updateTimerIntervalIfNecessary()
        https://bugs.webkit.org/show_bug.cgi?id=138440

        Reviewed by Geoffrey Garen.

        Move the withinEpsilon() function to WTF to avoid code duplication.

        * wtf/MathExtras.h:
        (WTF::withinEpsilon):

2014-11-05  Chris Dumez  <cdumez@apple.com>

        Allow constructing a PassRef from a Ref
        https://bugs.webkit.org/show_bug.cgi?id=138389

        Reviewed by Andreas Kling.

        Allow constructing a PassRef from a Ref, similarly to PassRefPtr that
        can be constructed from a RefPtr already. This avoids having to call
        Ref::get() and simplifies the code a bit.

        * wtf/PassRef.h:
        (WTF::PassRef<T>::PassRef):

2014-11-05  Dan Bernstein  <mitz@apple.com>

        Remove the unused deletion UI feature
        https://bugs.webkit.org/show_bug.cgi?id=138442

        Rubber-stamped by Alexey Proskuryakov.

        * wtf/FeatureDefines.h: Removed definition of ENABLE_DELETION_UI.

2014-11-03  Dean Jackson  <dino@apple.com>

        Add ENABLE_FILTERS_LEVEL_2 feature guard.
        https://bugs.webkit.org/show_bug.cgi?id=138362

        Reviewed by Tim Horton.

        Add a new feature define for Level 2 of CSS Filters.
        http://dev.w3.org/fxtf/filters-2/

        * wtf/FeatureDefines.h:

2014-11-05  Csaba Osztrogonác  <ossy@webkit.org>

        Enable ARMv7 disassembler for all platforms
        https://bugs.webkit.org/show_bug.cgi?id=138415

        Reviewed by Darin Adler.

        * wtf/Platform.h:

2014-11-04  Chris Dumez  <cdumez@apple.com>

        Add ptr() method to Ref class
        https://bugs.webkit.org/show_bug.cgi?id=138361

        Reviewed by Darin Adler.

        It is a very common pattern in our code base to get a pointer from a
        Ref object. Previously, we have to call Ref.get() and take its address
        which is not very nice. This patch adds a ptr() method to Ref class
        to simplify the code a bit.

        * wtf/PassRef.h:
        (WTF::PassRef<T>::ptr):
        * wtf/Ref.h:
        (WTF::Ref::ptr):
        (WTF::GetPtrHelper<Ref<T>>::getPtr):

2014-11-04  Dániel Bátyai  <dbatyai.u-szeged@partner.samsung.com>

        ATTR_USED incorrectly applying to Clang
        https://bugs.webkit.org/show_bug.cgi?id=138313

        Reviewed by Csaba Osztrogonác.

        ATTR_USED was only intended for GCC. Also limit it to ENABLE(FTL_NATIVE_CALL_INLINING)
        since that's the only thing it's needed for.

        * wtf/Platform.h:

2014-11-03  Chris Dumez  <cdumez@apple.com>

        Allow implicit conversion from Ref<T> to T&
        https://bugs.webkit.org/show_bug.cgi?id=138331

        Reviewed by Andreas Kling.

        Allow implicit conversion from Ref<T> to T& to reduce the amount of
        Ref<>::get() calls in the code and increase readability. Unlike for
        RefPtr, doing this for Ref should not be error prone.

        * wtf/Ref.h:
        (WTF::Ref::operator T&):
        (WTF::Ref::operator const T&):
        * wtf/RunLoop.cpp:
        (WTF::RunLoop::Holder::runLoop):

2014-10-31  Jeffrey Pfau  <jpfau@apple.com>

        Unreviewed, fix ASan build after r175382

        * wtf/SizeLimits.cpp:

2014-10-31  Geoffrey Garen  <ggaren@apple.com>

        Rolled in r175389.

        WebKit was failing to build 32bit on some Apple internal systems because
        those systems were configured to build bmalloc 64-bit-only. Those systems
        have been updated to build bmalloc as a universal binary, so everything
        should work fine now.

        The relevant setting is controlled by an environment variable on the
        build system, and not by the project file in the source tree, so there's
        no new code change here.

                Enable bmalloc in 32bit builds
                https://bugs.webkit.org/show_bug.cgi?id=138232

                Reviewed by Andreas Kling.

        * wtf/FastMalloc.cpp:

2014-10-31  Lucas Forschler  <lforschler@apple.com>

        Unreviewed rollout r175389.
        
2014-10-30  Dana Burkart  <dburkart@apple.com>

        <rdar://problem/18821260> Prepare for the mysterious future

        Reviewed by Lucas Forschler.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:

2014-10-30  Geoffrey Garen  <ggaren@apple.com>

        Enable bmalloc in 32bit builds
        https://bugs.webkit.org/show_bug.cgi?id=138232

        Reviewed by Andreas Kling.

        Seems to work fine.

        * wtf/FastMalloc.cpp:

2014-10-30  Jeffrey Pfau  <jpfau@apple.com>

        ASSERT(!m_deletionHasBegun) in RefCounted.h should be ASSERT_WITH_SECURITY_IMPLICATION
        https://bugs.webkit.org/show_bug.cgi?id=138141

        Reviewed by Alexey Proskuryakov.

        * wtf/RefCounted.h:
        (WTF::RefCountedBase::ref):
        (WTF::RefCountedBase::relaxAdoptionRequirement):
        (WTF::RefCountedBase::derefBase):
        (WTF::adopted):

2014-10-28  Milan Crha  <mcrha@redhat.com>

        Use constants from wtf/MathExtras.h
        https://bugs.webkit.org/show_bug.cgi?id=137967

        Reviewed by Darin Adler.

        * wtf/MathExtras.h:

2014-10-28  Tibor Meszaros  <tmeszaros.u-szeged@partner.samsung.com>

        [EFL] Remove unnecessary defines from OptionsEfl.cmake
        https://bugs.webkit.org/show_bug.cgi?id=138132

        Reviewed by Csaba Osztrogonác.

        * wtf/Platform.h:

2014-10-27  Chris Dumez  <cdumez@apple.com>

        Use separate HashMaps for common and uncommon headers in HTTPHeaderMap
        https://bugs.webkit.org/show_bug.cgi?id=138079

        Reviewed by Anders Carlsson.

        Add HashTraits for C++11 strong enum types. Using integer HashTraits for
        strong enums would be inconvenient as it would require casting between
        integer and strong enum types.

        * wtf/HashTraits.h:
        (WTF::StrongEnumHashTraits::emptyValue):
        (WTF::StrongEnumHashTraits::constructDeletedValue):
        (WTF::StrongEnumHashTraits::isDeletedValue):

2014-10-25  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: timelines should not count time elapsed while paused in the debugger
        https://bugs.webkit.org/show_bug.cgi?id=136351

        Unreviewed, follow-up fix after r175203. The debugger agent should not assume
        that the inspector environment's stopwatch has already been started.

        * wtf/Stopwatch.h:
        (WTF::Stopwatch::isActive): Added. Allow peeking at the stopwatch state.

2014-10-18  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: timelines should not count time elapsed while paused in the debugger
        https://bugs.webkit.org/show_bug.cgi?id=136351

        Reviewed by Timothy Hatcher.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/Stopwatch.h: Added. This implements a refcounted monotonic stopwatch.
        (WTF::Stopwatch::create):
        (WTF::Stopwatch::Stopwatch):
        (WTF::Stopwatch::reset):
        (WTF::Stopwatch::start):
        (WTF::Stopwatch::stop):
        (WTF::Stopwatch::elapsedTime):

2014-10-23  Joseph Pecoraro  <pecoraro@apple.com>

        Web Inspector: Provide a way to have alternate inspector agents
        https://bugs.webkit.org/show_bug.cgi?id=137901

        Reviewed by Brian Burg.

        * wtf/FeatureDefines.h:

2014-10-23  Alberto Garcia  <berto@igalia.com>

        [GTK] Fix build on Hurd
        https://bugs.webkit.org/show_bug.cgi?id=138003

        Reviewed by Carlos Garcia Campos.

        * wtf/InlineASM.h:
        * wtf/Platform.h:

2014-10-22  Byungseon Shin  <sun.shin@lge.com>

        String(new Date(Mar 30 2014 01:00:00)) is wrong in CET
        https://bugs.webkit.org/show_bug.cgi?id=130967

        Reviewed by Mark Lam.

        By definition of calculateLocalTimeOffset, input time should be UTC time.
        But there are many cases when input time is based on local time.
        So, it gives erroneous results while calculating offset of DST boundary time.
        By adding a argument to distinguish UTC and local time, we can get the correct offset.

        * wtf/DateMath.cpp:
        (WTF::calculateLocalTimeOffset):
        (WTF::parseDateFromNullTerminatedCharacters):
        Compensate time offset depends on UTC time or local time.
        * wtf/DateMath.h:
        Add argument to differenciate UTC or local time.

2014-10-21  Dániel Bátyai  <dbatyai.u-szeged@partner.samsung.com>

        Fix FTL Native Inlining for EFL
        https://bugs.webkit.org/show_bug.cgi?id=137774

        Reviewed by Michael Saboff.

        Updated guard definition for Native Inlining, and added an attribute define for marking functions
        that should not be left out of the symbol table.

        * wtf/Platform.h:

2014-10-20  Chris Dumez  <cdumez@apple.com>

        Use is<>() / downcast<>() for Accessibility objects
        https://bugs.webkit.org/show_bug.cgi?id=137286

        Reviewed by Darin Adler.

        Remove the legacy TYPE_CASTS_BASE() macro now that it is no longer
        used.

        * wtf/Assertions.h:

2014-10-18  Dan Bernstein  <mitz@apple.com>

        WorkQueue dispatches functions but isn’t a FunctionDispatcher
        https://bugs.webkit.org/show_bug.cgi?id=137853

        Reviewed by Anders Carlsson.

        * wtf/FunctionDispatcher.h: Added header guards.

2014-10-17  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GLIB] Add API to GMainLoopSource to schedule sources after a delay in microseconds
        https://bugs.webkit.org/show_bug.cgi?id=137782

        Reviewed by Sergio Villar Senin.

        In some cases when we have a double with the time in seconds, the
        conversion to milliseconds ends up truncating the value to 0, and
        the source scheduled immediately.

        * wtf/gobject/GMainLoopSource.cpp:
        (WTF::createMicrosecondsTimeoutSource): Use a custom timeout
        source that handles the interval in microseconds instead of milliseconds.
        (WTF::GMainLoopSource::scheduleAfterDelay): Use MicrosecondsTimeoutSource.
        (WTF::GMainLoopSource::scheduleAfterDelayAndDeleteOnDestroy): Ditto.
        * wtf/gobject/GMainLoopSource.h:

2014-10-17  Dan Bernstein  <mitz@apple.com>

        Reverted incorrect build fix attempt.

        * wtf/Threading.cpp:

2014-10-17  Dan Bernstein  <mitz@apple.com>

        Tried to fix the Yosemite build.

        * wtf/Threading.cpp:

2014-10-16  Dan Bernstein  <mitz@apple.com>

        OSObjectPtr is missing leakRef()
        https://bugs.webkit.org/show_bug.cgi?id=137798

        Reviewed by Sam Weinig.

        * wtf/OSObjectPtr.h:

2014-10-14  Brent Fulgham  <bfulgham@apple.com>

        [Win] Unreviewed gardening. Ignore Visual Studio *.sdf files.

        * WTF.vcxproj: Modified property svn:ignore.

2014-10-13  Antti Koivisto  <antti@apple.com>

        Add StringCapture helper for thread-safe lambda capture
        https://bugs.webkit.org/show_bug.cgi?id=137664

        Reviewed by Anders Carlsson.

        There is currently no clean way to capture a String in a thread-safe manner. This will now work:

        StringCapture stringCapture(string);
        auto lambdaThatRunsInAnotherThread = [stringCapture] { String string = stringCapture.string(); ... }

        This type won't be necessary with C++14 initialized lambda capture: [string = string.isolatedCopy()].

        * wtf/text/WTFString.h:
        (WTF::StringCapture::StringCapture): Create isolated copy in copy-constructor.
        (WTF::StringCapture::string):

2014-10-11  KwangHyuk Kim  <hyuki.kim@samsung.com>

        [EFL] Enable WebP support.
        https://bugs.webkit.org/show_bug.cgi?id=136156

        Reviewed by Gyuyoung Kim.

        Enable WTF_USE_WEBP macro for WK2 Efl.

        * wtf/Platform.h:

2014-10-11  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GLIB] Split GMainLoopSource moving thread safe implementation to its own class GThreadSafeMainLoopSource
        https://bugs.webkit.org/show_bug.cgi?id=137485

        Reviewed by Sergio Villar Senin.

        We made GMainLoopSource thread safe, but in most of the cases we
        know the sources are used by a single thread, which has an impact
        in the performance (mutex, GCancellable, etc.). The new class
        GThreadSafeMainLoopSource inherits from GMainLoopSource overriding
        the new virtual methods and calling the parent for the common code.
        GMutexLocker now supports recursive mutexes, it's a template that
        can wrap a GMutex or a GRecMutex. GThreadSafeMainLoopSource uses a
        recursive mutex using the new GMutexLocker API.

        * wtf/PlatformEfl.cmake: Add new file to compilation.
        * wtf/PlatformGTK.cmake: Ditto.
        * wtf/gobject/GMainLoopSource.cpp:
        (WTF::GMainLoopSource::GMainLoopSource):
        (WTF::GMainLoopSource::~GMainLoopSource):
        (WTF::GMainLoopSource::cancel):
        (WTF::GMainLoopSource::schedule):
        (WTF::GMainLoopSource::scheduleAfterDelay):
        (WTF::GMainLoopSource::prepareVoidCallback):
        (WTF::GMainLoopSource::finishVoidCallback):
        (WTF::GMainLoopSource::voidCallback):
        (WTF::GMainLoopSource::prepareBoolCallback):
        (WTF::GMainLoopSource::finishBoolCallback):
        (WTF::GMainLoopSource::boolCallback):
        (WTF::GMainLoopSource::socketCallback):
        (WTF::GMainLoopSource::cancelWithoutLocking): Deleted.
        * wtf/gobject/GMainLoopSource.h:
        * wtf/gobject/GMutexLocker.h:
        (WTF::MutexWrapper<GMutex>::lock):
        (WTF::MutexWrapper<GMutex>::unlock):
        (WTF::MutexWrapper<GRecMutex>::lock):
        (WTF::MutexWrapper<GRecMutex>::unlock):
        (WTF::GMutexLocker::GMutexLocker):
        (WTF::GMutexLocker::lock):
        (WTF::GMutexLocker::unlock):
        * wtf/gobject/GThreadSafeMainLoopSource.cpp: Added.
        (WTF::GThreadSafeMainLoopSource::GThreadSafeMainLoopSource):
        (WTF::GThreadSafeMainLoopSource::~GThreadSafeMainLoopSource):
        (WTF::GThreadSafeMainLoopSource::cancel):
        (WTF::GThreadSafeMainLoopSource::schedule):
        (WTF::GThreadSafeMainLoopSource::scheduleAfterDelay):
        (WTF::GThreadSafeMainLoopSource::prepareVoidCallback):
        (WTF::GThreadSafeMainLoopSource::finishVoidCallback):
        (WTF::GThreadSafeMainLoopSource::voidCallback):
        (WTF::GThreadSafeMainLoopSource::prepareBoolCallback):
        (WTF::GThreadSafeMainLoopSource::finishBoolCallback):
        (WTF::GThreadSafeMainLoopSource::boolCallback):
        * wtf/gobject/GThreadSafeMainLoopSource.h: Added.

2014-10-09  Dean Jackson  <dino@apple.com>

        Remove ENABLE_CSS3_CONDITIONAL_RULES
        https://bugs.webkit.org/show_bug.cgi?id=137571

        Reviewed by Simon Fraser.

        * wtf/FeatureDefines.h:

2014-10-09  Akos Kiss  <akiss@inf.u-szeged.hu>

        Enable ARM64 disassembler for all platforms
        https://bugs.webkit.org/show_bug.cgi?id=137560

        Reviewed by Michael Saboff.

        Remove PLATFORM conditions from around WTF_USE_ARM64_DISASSEMBLER since
        the ARM64 disassembler has no platform dependencies anymore.

        * wtf/Platform.h:

2014-10-08  peavo@outlook.com  <peavo@outlook.com>

        [WinCairo] Enable JIT on 32-bit.
        https://bugs.webkit.org/show_bug.cgi?id=137521

        Reviewed by Mark Lam.

        Enable JIT on Windows 32-bit, but disable it at runtime if SSE2 is not present.

        * wtf/Platform.h:

2014-10-08  Brent Fulgham  <bfulgham@apple.com>

        [Win] Resolve warnings about missing __has_include macro under MSVC
        https://bugs.webkit.org/show_bug.cgi?id=137524

        Reviewed by Anders Carlsson.

        * wtf/Compiler.h: Provide a dummy implementation of __has_include that
        avoids the warning without changing compile behavior.

2014-10-07  Brent Fulgham  <bfulgham@apple.com>

        [Win] Resolve some MSVC static analyzer warnings
        https://bugs.webkit.org/show_bug.cgi?id=137504

        Reviewed by Dean Jackson.

        * wtf/GregorianDateTime.cpp:
        (WTF::GregorianDateTime::setToCurrentLocalTime): Properly handle
        possible timezone error case.
        * wtf/OSAllocatorWin.cpp:
        (WTF::OSAllocator::decommit): Silence a spurious warning about using
        MEM_DECOMMIT instead of MEM_RELEASE.
        * wtf/ThreadingWin.cpp: Silence a spurious warning about how the
        tryLock method is implemented.

2014-10-07  Christophe Dumez  <cdumez@apple.com>

        [WK2] Use is<>() / downcast<>() for DrawingAreaProxy subclasses
        https://bugs.webkit.org/show_bug.cgi?id=137477

        Reviewed by Andreas Kling.

        Rename wtf/cf/TypeCasts.h to wtf/cf/TypeCastsCF.h to avoid conflict
        with wtf/TypeCasts.h. They were using the same #ifndef guard and it
        was causing problems when both were included in the same context.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/cf/TypeCastsCF.h: Renamed from Source/WTF/wtf/cf/TypeCasts.h.
        (WTF::dynamic_cf_cast):
        (WTF::checked_cf_cast):

2014-10-07  Anders Carlsson  <andersca@apple.com>

        Try to fix the Mountain Lion build.

        * wtf/text/StringView.h:
        (WTF::StringView::underlyingStringIsValid):
        (WTF::StringView::setUnderlyingString):
        (WTF::StringView::invalidate):

2014-10-07  Anders Carlsson  <andersca@apple.com>

        Use "1", not "true".

        * wtf/text/StringView.h:

2014-10-07  Anders Carlsson  <andersca@apple.com>

        Temporarily disable the StringView lifetime checking.

        * wtf/text/StringView.h:

2014-10-07  Anders Carlsson  <andersca@apple.com>

        Another build fix attempt.

        * wtf/text/StringView.cpp:
        (WTF::StringView::UnderlyingString::UnderlyingString):

2014-10-07  Anders Carlsson  <andersca@apple.com>

        Try to fix the Windows build.

        * wtf/text/StringView.cpp:
        (WTF::StringView::UnderlyingString::UnderlyingString):

2014-10-06  Darin Adler  <darin@apple.com>

        Make StringView check the lifetime of the StringImpl it's created from
        https://bugs.webkit.org/show_bug.cgi?id=137202

        Reviewed by Anders Carlsson.

        * WTF.vcxproj/WTF.vcxproj: Added StringView.cpp.
        * WTF.vcxproj/WTF.vcxproj.filters: Added StringView.cpp.
        * WTF.xcodeproj/project.pbxproj: Added StringView.cpp.
        * wtf/CMakeLists.txt: Added StringView.cpp.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::~StringImpl): Call StringView::invalidate.

        * wtf/text/StringView.cpp: Added.
        (WTF::underlyingStrings): Returns map from StringImpl to the underlying
        string object used by StringView to track validity.
        (WTF::StringView::invalidate): Mark the underlying string object invalid,
        and remove it from the map, so any future StringImpl will get a new one,
        even if it has the same pointer.
        (WTF::StringView::underlyingStringIsValid): Return true only if the
        underlying string is still valid.
        (WTF::StringView::setUnderlyingString): Create and manage reference counts
        of underlying string objects as needed.

        * wtf/text/StringView.h: Moved function bodies out of the class definition,
        so we can now read a clean class definition to see the class design and what
        functions it offers.
        (WTF::StringView::StringView): Added a comment to the default constructor.
        Also added copy and move constructors so they can call setUnderlyingString
        and assert the underlying string is valid as needed, replacing the
        compiler-generated ones.
        (WTF::StringView::~StringView): Added a call to setUnderlyingString.
        (WTF::StringView::operator=): Added these assignment operators with the same
        job as the constructors above.
        (WTF::StringView::initialize): Added a comment.
        (WTF::StringView::characters8): Added an assertion that the underlying
        string is valid.
        (WTF::StringView::characters16): Ditto.
        (WTF::StringView::substring): Added code to propagate the underlying string
        from the original string to the substring.
        (WTF::StringView::invalidate): Inline empty version of this function for
        non-debug builds.
        (WTF::StringView::underlyingStringIsValid): Ditto.
        (WTF::StringView::setUnderlyingString): Ditto.

2014-10-06  Brent Fulgham  <bfulgham@apple.com>

        [Win] DateMath's calculateUTFOffset does not account for DST.
        https://bugs.webkit.org/show_bug.cgi?id=137458
        <rdar://problem/18559172>

        Reviewed by Geoffrey Garen.

        Check the return value of GetTimeZoneInformation and use the
        proper bias against UTC (depending on whether we are in daylight
        savings time, or standard time).

        Also, handle possible error cases in the FileTimeToSystemTime
        and SystemTimeToTzSpecificLocalTime, rather than using potentially
        uninitialized values.

        * wtf/DateMath.cpp:
        (WTF::calculateUTCOffset): Use proper daylight-savings-time state.
        (WTF::calculateDSTOffset): Avoid uninitialized data due to failing
        API calls.

2014-10-06  Christophe Dumez  <cdumez@apple.com>

        Add is<>() / downcast<>() support for RenderObject subclasses
        https://bugs.webkit.org/show_bug.cgi?id=137424

        Reviewed by Benjamin Poulain.

        Handle correctly calling TypeCastTraits<ExpectedType, ArgType>::isOfType(ArgType&)
        with ExpectedType being a base class of ArgType (or the same as ArgType). The
        previous template specialization was only meant to support the case where
        ExpectedType is the same as ArgType but even that wasn't working as the compiler
        would complain about ambiguous partial specializations. Since this is needed by
        RenderTraversal functions, this patch adds an extra isBaseType template parameter
        to TypeCastTraits to resolve the ambiguity and relies on std::is_base_of for the
        detection.

        * wtf/TypeCasts.h:

2014-10-06  Brent Fulgham  <bfulgham@apple.com>

        [Win] Project file gardening.

        * WTF.vcxproj/WTF.vcxproj.filters: Move HashMethod.h and
        FastBitVector.cpp to proper places in hierarchy.

2014-10-04  Brian J. Burg  <burg@cs.washington.edu>

        Unreviewed, rolling out r174319.

        Causes assertions in fast/profiler tests. Needs nontrivial
        investigation, will take offline.

        Reverted changeset:

        "Web Inspector: timelines should not count time elapsed while
        paused in the debugger"
        https://bugs.webkit.org/show_bug.cgi?id=136351
        http://trac.webkit.org/changeset/174319

2014-10-04  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: timelines should not count time elapsed while paused in the debugger
        https://bugs.webkit.org/show_bug.cgi?id=136351

        Reviewed by Timothy Hatcher.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        * wtf/Stopwatch.h: Added. This implements a refcounted monotonic stopwatch.
        (WTF::Stopwatch::reset):
        (WTF::Stopwatch::start):
        (WTF::Stopwatch::stop):

2014-10-04  Filip Pizlo  <fpizlo@apple.com>

        FTL should sink PutLocals
        https://bugs.webkit.org/show_bug.cgi?id=137168

        Reviewed by Oliver Hunt.
        
        Make the set bits of a BitVector iterable.

        * wtf/BitVector.h:
        (WTF::BitVector::SetBitsIterable::SetBitsIterable):
        (WTF::BitVector::SetBitsIterable::iterator::iterator):
        (WTF::BitVector::SetBitsIterable::iterator::operator*):
        (WTF::BitVector::SetBitsIterable::iterator::operator++):
        (WTF::BitVector::SetBitsIterable::iterator::operator==):
        (WTF::BitVector::SetBitsIterable::iterator::operator!=):
        (WTF::BitVector::SetBitsIterable::begin):
        (WTF::BitVector::SetBitsIterable::end):
        (WTF::BitVector::setBits):

2014-10-03  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r174275.
        https://bugs.webkit.org/show_bug.cgi?id=137408

        Build failures on the internal bots. (Requested by dethbakin
        on #webkit).

        Reverted changeset:

        "FTL should sink PutLocals"
        https://bugs.webkit.org/show_bug.cgi?id=137168
        http://trac.webkit.org/changeset/174275

2014-10-03  Christophe Dumez  <cdumez@apple.com>

        Add TypeCasts.h to xcodeproject
        https://bugs.webkit.org/show_bug.cgi?id=137403

        Reviewed by Benjamin Poulain.

        Add TypeCasts.h to xcodeproject.

        * WTF.xcodeproj/project.pbxproj:

2014-09-28  Filip Pizlo  <fpizlo@apple.com>

        FTL should sink PutLocals
        https://bugs.webkit.org/show_bug.cgi?id=137168

        Reviewed by Oliver Hunt.
        
        Make the set bits of a BitVector iterable.

        * wtf/BitVector.h:
        (WTF::BitVector::SetBitsIterable::SetBitsIterable):
        (WTF::BitVector::SetBitsIterable::iterator::iterator):
        (WTF::BitVector::SetBitsIterable::iterator::operator*):
        (WTF::BitVector::SetBitsIterable::iterator::operator++):
        (WTF::BitVector::SetBitsIterable::iterator::operator==):
        (WTF::BitVector::SetBitsIterable::iterator::operator!=):
        (WTF::BitVector::SetBitsIterable::begin):
        (WTF::BitVector::SetBitsIterable::end):
        (WTF::BitVector::setBits):

2014-10-03  Myles C. Maxfield  <mmaxfield@apple.com>

        Support modern for loops over StringViews
        https://bugs.webkit.org/show_bug.cgi?id=137165

        Reviewed by Darin Adler.

        This patch adds two functions, codePoints() and codeUnits(), on StringView.
        These two functions return small objects which have begin() and end() functions,
        which means it can be used by the modern for loop style. This small class also
        has an inner iterator class which can be incremented, dereferenced, and
        compared.

        Using these new objects looks like this:
        for (UChar codeunit : stringView.codeUnits()) { } and
        for (UChar32 codepoint : stringView.codePoints()) { }.

        * wtf/text/StringView.h:
        (WTF::StringView::codepoints):
        (WTF::StringView::codeunits):
        (WTF::StringViewCodePointIterator::StringViewCodePointIterator):
        (WTF::StringViewCodePointIterator::Iterator::Iterator):
        (WTF::StringViewCodePointIterator::Iterator::operator*):
        (WTF::StringViewCodePointIterator::Iterator::operator!=):
        (WTF::StringViewCodeUnitIterator::StringViewCodeUnitIterator):
        (WTF::StringViewCodeUnitIterator::Iterator::Iterator):
        (WTF::StringViewCodeUnitIterator::Iterator::operator*):
        (WTF::StringViewCodeUnitIterator::Iterator::operator!=):

2014-09-28  Sam Weinig  <sam@webkit.org>

        Remove RefPtrHashMap
        https://bugs.webkit.org/show_bug.cgi?id=137200

        Reviewed by Darin Adler.

        HashMap now has all the features of the RefPtr specialization of HashMap
        (which lived in RefPtrHashMap.h) and is in fact more efficient when moving
        items into it. For instance:

        For HashMap<RefPtr<Foo>, Bar> map:

        RefPtr<Foo> foo = ...;
        map.add(WTF::move(foo), Bar());

        will now not cause a ref() / deref(), but will successfully move the item in
        without churn. The same is true if foo.release() was used.

        * WTF.vcxproj/WTF.vcxproj:
        * WTF.vcxproj/WTF.vcxproj.filters:
        * WTF.xcodeproj/project.pbxproj:
        * wtf/CMakeLists.txt:
        Remove references to RefPtrHashMap.h.

        * wtf/RefPtrHashMap.h: Removed.

        * wtf/HashMap.h:
        Remove #include of RefPtrHashMap.h and add inlineGet to match the interface
        exposed by the RefPtrHashMap specialization.

2014-10-02  Anders Carlsson  <andersca@apple.com>

        Add back debugging/testing code that I accidentally removed.

        * wtf/text/StringConcatenate.h:
        (WTF::StringTypeAdapter<String>::writeTo):

2014-10-02  Anders Carlsson  <andersca@apple.com>

        Simplify StringTypeAdapter templates
        https://bugs.webkit.org/show_bug.cgi?id=137356

        Reviewed by Andreas Kling.

        * wtf/text/StringConcatenate.h:
        Use StringView for copying characters. Use inheritance for char* vs const char* etc. Make all StringAdapter member functions const.

        * wtf/text/StringView.h:
        Move enough functions out of line so we can include WTFString.h after the StringView class definition.

2014-10-01  Christophe Dumez  <cdumez@apple.com>

        Have is<>(T*) function do a null check on the pointer argument
        https://bugs.webkit.org/show_bug.cgi?id=137333

        Reviewed by Gavin Barraclough.

        Have is<>(T*) function do a null check on the argument instead of a
        simple assertion. This makes sense for 2 reasons:
        1. It is more consistent with downcast<>(T*), which will succeed even
           if the argument is a nullptr.
        2. It simplifies the code a bit as it gets rid of a lot of explicit
           null checks.

        * wtf/TypeCasts.h:
        (WTF::is):

2014-10-02  Daniel Bates  <dabates@apple.com>

        Clean up: Move XPC forward declarations in JavaScriptCore to WTF SPI wrapper header
        https://bugs.webkit.org/show_bug.cgi?id=137277

        Reviewed by Alexey Proskuryakov.

        Towards centralizing the declarations of XPC functions used in JavaScriptCore
        and WebKit2, add a header that wraps these function declarations called XPCSPI.h
        and use it instead of including the corresponding XPC API/SPI headers/forward
        declaring XPC functions. This will also aid in the effort to make WebKit2 build
        for iOS with the public iOS SDK.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/spi/darwin/XPCSPI.h: Added.

2014-10-01  Christophe Dumez  <cdumez@apple.com>

        Unreviewed build fix after r174193.

        Adding a return statement as that function is returning a boolean.

        * wtf/TypeCasts.h:
        (WTF::TypeCastTraits::isOfType):

2014-10-01  Christophe Dumez  <cdumez@apple.com>

        Fail better when is<>() / downcast<>() is used for an unsupported type
        https://bugs.webkit.org/show_bug.cgi?id=137323

        Reviewed by Benjamin Poulain.

        We should fail better when is<>() / downcast<>() is used for an
        unsupported type (i.e. a type that doesn't have the needed
        TypeCastTraits template specialization). Previously, we would get an
        obscure linking error, which was sub-optimal.

        With this patch, you would now hit a static_assert() at build time if
        you tried to use is<>() / downcast<>() for a type that did not have the
        needed template specialization. There is also a helpful comment above
        the assertion letting the developer know how to add the needed template
        specialization.

        * wtf/TypeCasts.h:
        (WTF::TypeCastTraits::isOfType):

2014-10-01  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r174180, r174183, and r174186.
        https://bugs.webkit.org/show_bug.cgi?id=137320

        Broke the Mac MountainLion build. Will investigate offline.
        (Requested by dydz on #webkit).

        Reverted changesets:

        "Clean up: Move XPC forward declarations in JavaScriptCore to
        WTF SPI wrapper header"
        https://bugs.webkit.org/show_bug.cgi?id=137277
        http://trac.webkit.org/changeset/174180

        "Attempt to fix the build after
        <https://trac.webkit.org/changeset/174180>"
        https://bugs.webkit.org/show_bug.cgi?id=137277
        http://trac.webkit.org/changeset/174183

        "Another attempt to fix the Mac build after
        <https://trac.webkit.org/changeset/174180>"
        https://bugs.webkit.org/show_bug.cgi?id=137277
        http://trac.webkit.org/changeset/174186

2014-10-01  Daniel Bates  <dabates@apple.com>

        Another attempt to fix the Mac build after <https://trac.webkit.org/changeset/174180>
        (https://bugs.webkit.org/show_bug.cgi?id=137277)

        Include header AvailabilityMacros.h instead of Availability.h, which actually defines the
        macro __MAC_OS_X_VERSION_MIN_REQUIRED.

        * wtf/spi/darwin/XPCSPI.h:

2014-10-01  Daniel Bates  <dabates@apple.com>

        Attempt to fix the build after <https://trac.webkit.org/changeset/174180>
        (https://bugs.webkit.org/show_bug.cgi?id=137277)

        Include header <Availability.h> for the definition of __MAC_OS_X_VERSION_MIN_REQUIRED.
        Also, we want to define CONST_ON_OR_AFTER_MAC_OS_X_VERSION_1090 to be const when building
        on iOS.

        * wtf/spi/darwin/XPCSPI.h:

2014-10-01  Daniel Bates  <dabates@apple.com>

        Clean up: Move XPC forward declarations in JavaScriptCore to WTF SPI wrapper header
        https://bugs.webkit.org/show_bug.cgi?id=137277

        Reviewed by Alexey Proskuryakov.

        Towards centralizing the declarations of XPC functions used in JavaScriptCore
        and WebKit2, add a header that wraps these function declarations called XPCSPI.h
        and use it instead of including the corresponding XPC API/SPI headers/forward
        declaring XPC functions. This will also aid in the effort to make WebKit2 build
        for iOS with the public iOS SDK.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/spi/darwin/XPCSPI.h: Added.

2014-10-01  Brent Fulgham  <bfulgham@apple.com>

        [Win] 32-bit JavaScriptCore should limit itself to the C loop
        https://bugs.webkit.org/show_bug.cgi?id=137304
        <rdar://problem/18375370>

        Reviewed by Michael Saboff.

        * wtf/Platform.h: Force the C loop when building for 32-bit Windows.

2014-09-30  Christophe Dumez  <cdumez@apple.com>

        Generalize is<>() / downcast<>() support to all types
        https://bugs.webkit.org/show_bug.cgi?id=137243

        Reviewed by Benjamin Poulain.

        Generalize is<>() / downcast<>() support to all types, not just Nodes.

        * wtf/Assertions.h:
        * wtf/TypeCasts.h: Added.
        (WTF::is):
        (WTF::downcast):

2014-09-30  Anders Carlsson  <andersca@apple.com>

        Get the STRING_STATS codepath compiling again, and add calls to ref/deref
        https://bugs.webkit.org/show_bug.cgi?id=137259

        Reviewed by Andreas Kling.

        * wtf/text/StringImpl.cpp:
        (WTF::StringStats::removeString):
        (WTF::StringStats::printStats):
        (WTF::StringImpl::~StringImpl):
        * wtf/text/StringImpl.h:
        (WTF::StringImpl::StringImpl):
        (WTF::StringImpl::isSubString):
        (WTF::StringImpl::ref):
        (WTF::StringImpl::deref):
        (WTF::StringStats::addUpconvertedString): Deleted.

2014-09-30  Daniel Bates  <dabates@apple.com>

        REGRESSION (r172532): JSBase.h declares NSMapTable functions that are SPI
        https://bugs.webkit.org/show_bug.cgi?id=137170
        <rdar://problem/18477384>

        Reviewed by Geoffrey Garen.

        Add SPI wrapper header, NSMapTableSPI.h.

        Additionally, define convenience macro EXTERN_C that can be used to specify the C linkage
        convention for a declaration. For example, the declaration "EXTERN_C const int x;" will
        expand to:

        extern const int x;

        and

        extern "C" const int x;

        when used in a C and C++ file, respectively.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/Compiler.h:
        * wtf/spi/cocoa/NSMapTableSPI.h: Added.

2014-09-29  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r174045.
        https://bugs.webkit.org/show_bug.cgi?id=137231

        Introduced a crash during page loading tests on Mac (Requested
        by rniwa on #webkit).

        Reverted changeset:

        "Replace OSObjectPtr with RetainPtr/adoptOS"
        https://bugs.webkit.org/show_bug.cgi?id=137158
        http://trac.webkit.org/changeset/174045

2014-09-26  Sam Weinig  <sam@webkit.org>

        Replace OSObjectPtr with RetainPtr/adoptOS
        https://bugs.webkit.org/show_bug.cgi?id=137158

        Reviewed by Dan Bernstein.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/OSObjectPtr.h: Removed.
        * wtf/RetainPtr.h:
        (WTF::adoptOS):
        Added. This adopt function is slightly different than both adoptCF and adoptNS,
        in that unlike adoptCF(), it can be passed an Objective-C type (since OS objects
        are sometimes Objective-C objects, but not always), and unlike adoptNS() it doesn't 
        require us to jump through hoops to appease GC (since OS objects are not Objective-C
        objects if GC is enabled).

2014-09-24  Filip Pizlo  <fpizlo@apple.com>

        FTL should sink object allocations
        https://bugs.webkit.org/show_bug.cgi?id=136330

        Reviewed by Oliver Hunt.
        
        Make it possible to reset a Bag.

        * wtf/Bag.h:
        (WTF::Bag::Bag):
        (WTF::Bag::~Bag):
        (WTF::Bag::clear):

2014-09-25  Roger Fong  <roger_fong@apple.com>

        [Windows] Unreviewed build fix. Ensure that python2.7 is used for Windows builds.

        * WTF.vcxproj/WTFGenerated.make:

2014-09-25  Csaba Osztrogonác  <ossy@webkit.org>

        Remove WinCE port from trunk
        https://bugs.webkit.org/show_bug.cgi?id=136951

        Reviewed by Alex Christensen.

        * config.h:
        * wtf/Assertions.cpp:
        * wtf/Assertions.h:
        * wtf/Atomics.h:
        (WTF::weakCompareAndSwap):
        * wtf/CurrentTime.cpp:
        (WTF::lowResUTCTime):
        * wtf/DataLog.cpp:
        * wtf/DateMath.cpp:
        (WTF::getLocalTime):
        (WTF::calculateDSTOffset):
        * wtf/FastMalloc.cpp:
        * wtf/FeatureDefines.h:
        * wtf/OSAllocator.h:
        (WTF::OSAllocator::decommitAndRelease):
        * wtf/Platform.h:
        * wtf/PlatformWin.cmake:
        * wtf/RAMSize.cpp:
        (WTF::computeRAMSize):
        * wtf/RandomNumberSeed.h:
        (WTF::initializeRandomNumberGenerator):
        * wtf/StackBounds.cpp:
        (WTF::StackBounds::initialize):
        * wtf/StackBounds.h:
        (WTF::StackBounds::isGrowingDownward):
        * wtf/StdLibExtras.h:
        (wtf_bsearch): Deleted.
        * wtf/StringExtras.h:
        (strnicmp): Deleted.
        (stricmp): Deleted.
        (strdup): Deleted.
        * wtf/ThreadSpecific.h:
        * wtf/ThreadingWin.cpp:
        (WTF::createThreadInternal):
        * wtf/WindowsExtras.h:
        (WTF::getRegistryValue):
        (WTF::getWindowPointer):
        (WTF::setWindowPointer):
        * wtf/dtoa/utils.h:
        * wtf/text/WTFString.cpp:
        (WTF::String::format):

2014-09-24  Geoffrey Garen  <ggaren@apple.com>

        Do the bmalloc.
        https://bugs.webkit.org/show_bug.cgi?id=132629

        Reviewed by Gavin Barraclough.

        64-bit only for now, just to try it out.

        * wtf/FastMalloc.cpp:

2014-09-23  Geoffrey Garen  <ggaren@apple.com>

        Rolled out r173346.

            bmalloc should honor the FastMalloc statistics API
            https://bugs.webkit.org/show_bug.cgi?id=136592

        This didn't really work. Because we allow ranges with and without
        physical pages to merge, and we allow double-committing and
        double-decommitting, we can't rely on commit actions to track memory
        footprint.

        * wtf/FastMalloc.cpp:
        (WTF::fastMallocStatistics):

2014-09-23  Joseph Pecoraro  <pecoraro@apple.com>

        Web Inspector: Should be able to attach a debugger to a JSContext before anything is executed
        https://bugs.webkit.org/show_bug.cgi?id=136893

        Reviewed by Timothy Hatcher.

        Currently automatic inspection only happens in processes that have a
        debugger attached. That condition may change in the future, but this
        function can stand on its own in WTF. It may be useful in the future
        to perhaps continue though ASSERTs if you have a debugger attached.

        * wtf/Assertions.cpp:
        * wtf/Assertions.h:

2014-09-22  Sam Weinig  <sam@webkit.org>

        Eliminate redundant PtrHash specializations
        https://bugs.webkit.org/show_bug.cgi?id=136990

        Reviewed by Darin Adler.

        Now that we have IsSmartPtr, we can eliminate all the specializations
        of PtrHash that we had (for RefPtr, OwnPtr, RetainPtr, and std::unique_ptr)
        and instead just have one that uses GetPtrHelper.

        No changes of behavior intended.

        * wtf/GetPtr.h:
        Remove unnecessary const_cast that Darin noticed.

        * wtf/HashFunctions.h:
        (WTF::PtrHash::hash): Deleted.
        (WTF::PtrHash::equal): Deleted.
        (WTF::PtrHash<RefPtr<P>>::hash): Deleted.
        (WTF::PtrHash<RefPtr<P>>::equal): Deleted.
        Specialize PtrHash based on whether the type is a smart pointer, and use GetPtrHelper
        to implement the smart pointer specialized variant.

        * wtf/HashMap.h:
        Remove include of GetPtr.h that is now included by HashFunctions.h

        * wtf/OwnPtr.h:
        (WTF::PtrHash<OwnPtr<P>>::hash): Deleted.
        (WTF::PtrHash<OwnPtr<P>>::equal): Deleted.
        Remove unnecessary specialization of PtrHash.

        * wtf/RetainPtr.h:
        (WTF::PtrHash<RetainPtr<P>>::hash): Deleted.
        (WTF::PtrHash<RetainPtr<P>>::equal): Deleted.
        Specialize IsSmartPointer for RetainPtr and remove the then unnecessary specialization of PtrHash.
        (This is already tested in the API test WTF/cf/RetainPtrHashing).

2014-09-20  Sam Weinig  <sam@webkit.org>

        Make possible HashSet<std::unique_ptr<>>
        https://bugs.webkit.org/show_bug.cgi?id=136166

        Reviewed by Darin Adler.

        * wtf/GetPtr.h:
        (WTF::getPtr):
        (WTF::GetPtrHelper<std::unique_ptr<T>>::getPtr):
        Make specializing GetPtrHelper a bit cleaner (you don't have to put 
        IsSmartPtr<T>::value everywhere any more) and add specializations for
        std::unique_ptr.

        * wtf/HashFunctions.h:
        (WTF::PtrHash<std::unique_ptr<P>>):
        Add specialization for PtrHash for std::unique_ptr and set it as the DefaultHash
        for it as well.

        * wtf/HashMap.h:    
        * wtf/HashSet.h:
        Add overloads of find(), contains(), remove(), take() (and get() for HashMap) for "smart pointers" that
        take the raw pointer type as the parameter. These use SFINAE to make themselves only available
        when the IsSmartPtr<KeyType>::value is true. 

        * wtf/HashTraits.h:
        Override constructDeletedValue() and isDeletedValue() in the std::unique_ptr specialization
        since the default implementation depends on the type having a constructor that takes a HashTableDeletedValue
        and function named isHashTableDeletedValue().

        * wtf/OwnPtr.h:
        (WTF::OwnPtr::OwnPtr):
        (WTF::OwnPtr::isHashTableDeletedValue):
        (WTF::OwnPtr::hashTableDeletedValue):
        Add HashTableDeletedValue constructor/functions to allow the constructDeletedValue() and isDeletedValue()
        hash traits to work.

        (WTF::PtrHash<OwnPtr<P>>::hash):
        (WTF::PtrHash<OwnPtr<P>>::equal):
        Add specialization for PtrHash for OwnPtr and set it as the DefaultHash
        for it as well.

        * wtf/Ref.h:
        Update for the less verbose GetPtrHelper specialization.

2014-09-19  Chris Dumez  <cdumez@apple.com>

        Allow DOM methods to return references instead of pointers
        https://bugs.webkit.org/show_bug.cgi?id=136931

        Add support for having WTF::getPtr() transform reference arguments
        into raw pointers so that DOM methods can now return references when
        appropriate and so that the generated bindings code can handle this
        via WTF::getPtr().

        This patch had to alter the way getPtr() was overloaded for smart
        pointer types so that we don't call &p on smart pointers but p.get().
        This was needed because the new WTF::getPtr(T&) was being called for
        RefPtr<T> arguments instead of the getPtr(const RefPtr<T>&) overload.
        This was addressed using traits and template specialization to
        distinguish WTF smart pointers from other types.

        Reviewed by Sam Weinig.

        * wtf/GetPtr.h:
        (WTF::getPtr):
        * wtf/OwnPtr.h:
        (WTF::getPtr): Deleted.
        * wtf/PassOwnPtr.h:
        (WTF::getPtr): Deleted.
        * wtf/PassRefPtr.h:
        (WTF::getPtr): Deleted.
        * wtf/Ref.h:
        * wtf/RefPtr.h:
        (WTF::getPtr): Deleted.
        * wtf/gobject/GRefPtr.h:
        (WTF::getPtr): Deleted.

2014-09-19  Daniel Bates  <dabates@apple.com>

        Always assume internal SDK when building configuration Production
        https://bugs.webkit.org/show_bug.cgi?id=136925
        <rdar://problem/18362399>

        Reviewed by Dan Bernstein.

        * Configurations/Base.xcconfig:

2014-09-19  Diego Pino Garcia  <dpino@igalia.com>

        Simple ES6 feature:String prototype additions
        https://bugs.webkit.org/show_bug.cgi?id=131704

        Reviewed by Darin Adler.

        * wtf/text/StringImpl.cpp:
        (WTF::StringImpl::find):
        (WTF::equalInner): Added.
        (WTF::StringImpl::startsWith): Add implementation that supports
        'startOffset' parameter.
        (WTF::StringImpl::endsWith): Add implementation that supports
        'endOffset' parameter.
        * wtf/text/StringImpl.h:
        * wtf/text/WTFString.h:
        (WTF::String::contains): Modify current implementation to allow
        setting a startOffset, 0 by default.
        (WTF::String::startsWith):
        (WTF::String::endsWith):

2014-09-18  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Dot not allow to create delete-on-destroy GMainLoopSources
        https://bugs.webkit.org/show_bug.cgi?id=136923

        Reviewed by Gustavo Noronha Silva.

        We have several asserts to ensure that delete-on-destroy sources
        are not misused, like not scheduling socket sources on a
        delete-on-destroy GMainLoopSource or not allowing to cancel them
        before they have been dispatched. It's better to ensure all those
        things at compile time, using static methods to schedule sources
        creating a delete-on-destroy GMainLoopSource that is not returned
        to the user.

        * wtf/gobject/GMainLoopSource.cpp:
        (WTF::GMainLoopSource::create): Private static method to create a
        delete-on-destroy GMainLoopSource.
        (WTF::GMainLoopSource::cancelWithoutLocking): Return early in case
        of delete-on-destroy source, since they can't be cancelled.
        (WTF::GMainLoopSource::schedule): Remove assertion to ensure
        socket sources are not scheduled on a delete-on-destroy GMainLoopSource.
        (WTF::GMainLoopSource::scheduleAndDeleteOnDestroy):
        (WTF::GMainLoopSource::scheduleAfterDelayAndDeleteOnDestroy):
        (WTF::GMainLoopSource::createAndDeleteOnDestroy): Deleted.
        * wtf/gobject/GMainLoopSource.h:
        * wtf/gtk/MainThreadGtk.cpp:
        (WTF::scheduleDispatchFunctionsOnMainThread): Use GMainLoopSource::scheduleAndDeleteOnDestroy()
        * wtf/gtk/RunLoopGtk.cpp:
        (WTF::RunLoop::wakeUp): Ditto.

2014-09-18  Joseph Pecoraro  <pecoraro@apple.com>

        Unreviewed rollout r173731. Broke multiple builds.

        * wtf/Assertions.cpp:
        * wtf/Assertions.h:

2014-09-18  Joseph Pecoraro  <pecoraro@apple.com>

        Web Inspector: Should be able to attach a debugger to a JSContext before anything is executed
        https://bugs.webkit.org/show_bug.cgi?id=136893

        Reviewed by Timothy Hatcher.

        Currently automatic inspection only happens in processes that have a
        debugger attached. That condition may change in the future, but this
        function can stand on its own in WTF. It may be useful in the future
        to perhaps continue though ASSERTs if you have a debugger attached.

        * wtf/Assertions.cpp:
        * wtf/Assertions.h:

2014-09-18  Zan Dobersek  <zdobersek@igalia.com>

        GMainLoopSource is exposed to race conditions
        https://bugs.webkit.org/show_bug.cgi?id=135800

        Reviewed by Carlos Garcia Campos.

        GMainLoopSource objects can be dispatching tasks on one thread
        while having a new task scheduled on a different thread. This
        can for instance occur in WebKitVideoSink, where the timeout
        callback can be called on main thread while at the same time
        it is being rescheduled on a different thread (created through
        GStreamer).

        The initial solution is to use GMutex to prevent parallel data
        access from different threads. In the future I plan to look at
        the possibility of creating thread-specific GMainLoopSource
        objects that wouldn't require the use of GMutex.

        GSource, GCancellable and std::function<> objects are now packed
        into an internal Context structure. Using the C++11 move semantics
        it's simple to, at the time of dispatch, move the current context
        out of the GMainLoopSource object in case the dispatch causes a
        rescheduling on that same object.

        Also added in the Context struct is a new GCancellable. The pointer
        of that object is shared with the GMainLoopSource before the Context
        is moved out for the callback dispatch. This makes it safe to cancel
        or even delete the GMainLoopSource during the dispatch and prevents
        use-after-delete on GMainLoopSource once the dispatch is done in
        the GMainLoopSource::*Callback() methods.

        All the schedule*() methods and the cancelWithoutLocking() method
        callers now lock the GMutex to ensure no one else is accessing the
        data at that moment. Similar goes for the dispatch methods, but those
        do the dispatch and possible destruction duties with the mutex unlocked.
        The dispatch can cause rescheduling on the same GMainLoopSource object,
        which must not be done with a locked mutex.

        * wtf/gobject/GMainLoopSource.cpp:
        (WTF::GMainLoopSource::GMainLoopSource):
        (WTF::GMainLoopSource::~GMainLoopSource):
        (WTF::GMainLoopSource::cancel):
        (WTF::GMainLoopSource::cancelWithoutLocking):
        (WTF::GMainLoopSource::scheduleIdleSource):
        (WTF::GMainLoopSource::schedule):
        (WTF::GMainLoopSource::scheduleTimeoutSource):
        (WTF::GMainLoopSource::scheduleAfterDelay):
        (WTF::GMainLoopSource::voidCallback):
        (WTF::GMainLoopSource::boolCallback):
        (WTF::GMainLoopSource::socketCallback):
        (WTF::GMainLoopSource::socketSourceCallback):
        (WTF::GMainLoopSource::Context::destroySource):
        (WTF::GMainLoopSource::reset): Deleted.
        (WTF::GMainLoopSource::destroy): Deleted.
        * wtf/gobject/GMainLoopSource.h:

2014-09-17  Daniel Bates  <dabates@apple.com>

        Unreviewed, rolling out r173695.

        Broke building third-party Legacy WebKit apps; will
        investigate offline

        Reverted changeset:

        "[iOS] Make WebCore build with public iOS SDK"
        https://bugs.webkit.org/show_bug.cgi?id=136487
        http://trac.webkit.org/changeset/173695

2014-09-17  Benjamin Poulain  <bpoulain@apple.com>

        CSS value in whitespace-separated list attribute selector (~=) mishandles tab/newline/etc.
        https://bugs.webkit.org/show_bug.cgi?id=136807

        Reviewed by Antti Koivisto.

        * wtf/text/AtomicString.h:
        (WTF::AtomicString::find):

2014-09-17  Daniel Bates  <dabates@apple.com>

        [iOS] Make WebCore build with public iOS SDK
        https://bugs.webkit.org/show_bug.cgi?id=136487

        Reviewed by David Kilzer.

        Define convenience macro EXTERN_C that can be used to specify the C linkage convention
        for a declaration. For example, the declaration "EXTERN_C const int x;" will expand to:

        extern const int x;

        and

        extern "C" const int x;

        when used in a C and C++ file, respectively.

        * wtf/Compiler.h:

2014-09-16  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, disable native inlining because it causes build failures.

        * wtf/Platform.h:

2014-09-15  Jer Noble  <jer.noble@apple.com>

        [Mac] Support audioSourceProvider() in MediaPlayerPrivateAVFoundationObjC
        https://bugs.webkit.org/show_bug.cgi?id=135042

        Reviewed by Eric Carlson.

        * wtf/Platform.h: Add WTF_USE_MEDIATOOLBOX.

2014-09-15  peavo@outlook.com  <peavo@outlook.com>

        [WinCairo] Make it easier to enable/disable GStreamer.
        https://bugs.webkit.org/show_bug.cgi?id=135766

        Reviewed by Brent Fulgham.

        Make it possible to enable/disable GStreamer by editing the new user macro ENABLE_GSTREAMER_WINCAIRO.

        * WTF.vcxproj/WTFDebugWinCairo.props: Import GStreamer property file.
        * WTF.vcxproj/WTFReleaseWinCairo.props: Ditto.
        * wtf/Platform.h: Enable GStreamer if ENABLE(GSTREAMER_WINCAIRO) is true, otherwise use Media Foundation.

2014-09-10  Jon Honeycutt  <jhoneycutt@apple.com>

        Re-add the request autocomplete feature

        <https://bugs.webkit.org/show_bug.cgi?id=136730>

        This feature was rolled out in r148731 because it was only used by
        Chromium. As we consider supporting this feature, roll it back in, but
        leave it disabled.

        This rolls out r148731 (which removed the feature) with small changes
        needed to make the code build in ToT, to make the tests run, and to
        remove unused code.

        Reviewed by Andy Estes.

        * wtf/FeatureDefines.h:

2014-09-12  Tim Horton  <timothy_horton@apple.com>

        Swiping back from a Twitter image to Twitter flashes to the wrong position
        https://bugs.webkit.org/show_bug.cgi?id=136798
        <rdar://problem/18324338>

        Reviewed by Darin Adler and Sam Weinig.

        * wtf/RunLoop.h:
        (WTF::RunLoop::TimerBase::startRepeating):
        Add a std::chrono veresion of RunLoop::TimerBase::startRepeating.

2014-09-12  Geoffrey Garen  <ggaren@apple.com>

        Rolled out r173540.

        It broke the Membuster performance bot, and it's still slightly profligate
        with memory.

            Do the bmalloc.
            https://bugs.webkit.org/show_bug.cgi?id=132629

        * wtf/FastMalloc.cpp:

2014-09-11  Geoffrey Garen  <ggaren@apple.com>

        Do the bmalloc.
        https://bugs.webkit.org/show_bug.cgi?id=132629

        Reviewed by Michael Saboff.

        64-bit only for now, just to try it out.

        * wtf/FastMalloc.cpp:

2014-09-09  Benjamin Poulain  <bpoulain@apple.com>

        Disable the "unreachable-code" warning
        https://bugs.webkit.org/show_bug.cgi?id=136677

        Reviewed by Darin Adler.

        The warning causes various build errors depending on which Clang you are using.

        For example, with recent clangs, it breaks all the ARCHS dependent code like this:
            if (sizeof(uintptr_t) == 4)
                // Something for 32 bits.
            else
                // Somethign for 64 bits.

        * Configurations/Base.xcconfig:

2014-09-07  Filip Pizlo  <fpizlo@apple.com>

        DFG should have a reusable SSA builder
        https://bugs.webkit.org/show_bug.cgi?id=136331

        Reviewed by Oliver Hunt.
        
        Update the alloc() method to use variadic templates. This makes it more natural to use.

        * wtf/SegmentedVector.h:
        (WTF::SegmentedVector::alloc):

2014-09-08  Eva Balazsfalvi  <evab.u-szeged@partner.samsung.com>

        Remove FILTERS flag
        https://bugs.webkit.org/show_bug.cgi?id=136571

        Reviewed by Darin Adler.

        * wtf/FeatureDefines.h:

2014-09-08  Dan Bernstein  <mitz@apple.com>

        HAVE(VOUCHERS) is not available outside of WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=136637

        Reviewed by Tim Horton.

        * wtf/Platform.h: Moved the definition of HAVE_VOUCHERS from WebKit2’s config.h here.

2014-09-08  Tim Horton  <timothy_horton@apple.com>

        Try to fix the build after r173383, part 2.

        * wtf/OSObjectPtr.h:

2014-09-08  Tim Horton  <timothy_horton@apple.com>

        Try to fix the build after r173383.

        * wtf/OSObjectPtr.h:

2014-09-07  Sam Weinig  <sam@webkit.org>

        Make OSObjectPtr a bit more like RefPtr
        https://bugs.webkit.org/show_bug.cgi?id=136613

        Reviewed by Darin Adler.

        Address some of Darin's feedback by:
        - Making the adopting constructor private and friending adoptOSObject().
        - Implementing the assignment operator using swap.
        - Adding a move assignment operator.

        * wtf/OSObjectPtr.h:
        (WTF::OSObjectPtr::operator=):
        (WTF::OSObjectPtr::swap):
        (WTF::OSObjectPtr::OSObjectPtr):

2014-09-08  Jessie Berlin  <jberlin@apple.com>

        More build fixes after r173374.

        * wtf/dtoa/strtod.cc:

2014-09-08  Jessie Berlin  <jberlin@apple.com>

        Build fix after r173374.

        * wtf/dtoa/strtod.cc:

2014-09-08  Jessie Berlin  <jberlin@apple.com>

        Speculative build fix after r173364.

        * wtf/dtoa/strtod.cc:

2014-09-07  Maciej Stachowiak  <mjs@apple.com>

        Introduce COMPILER_QUIRK(CONSIDERS_UNREACHABLE_CODE) and use it
        https://bugs.webkit.org/show_bug.cgi?id=136616

        Reviewed by Darin Adler.

        * wtf/Compiler.h: Define the quirk for all compilers but clang.

2014-09-06  Sam Weinig  <sam@webkit.org>

        XPCPtr should be converted into an all purpose smart pointer for os_objects
        https://bugs.webkit.org/show_bug.cgi?id=136602

        Reviewed by Darin Adler.

        * WTF.xcodeproj/project.pbxproj:
        * wtf/OSObjectPtr.h: Copied from Source/WebKit2/Platform/IPC/mac/XPCPtr.h.
        (WTF::retainOSObject):
        (WTF::releaseOSObject):
        (WTF::OSObjectPtr::OSObjectPtr):
        (WTF::OSObjectPtr::~OSObjectPtr):
        (WTF::OSObjectPtr::operator=):
        (WTF::adoptOSObject):
        (IPC::XPCPtr::XPCPtr): Deleted.
        (IPC::XPCPtr::~XPCPtr): Deleted.
        (IPC::XPCPtr::operator=): Deleted.
        (IPC::adoptXPC): Deleted.
        Rename/move XPCPtr to OSObjectPtr and make it work with any os_object.

2014-09-06  Darin Adler  <darin@apple.com>

        Make updates suggested by new version of Xcode
        https://bugs.webkit.org/show_bug.cgi?id=136603

        Reviewed by Mark Rowe.

        * Configurations/Base.xcconfig: Added CLANG_WARN_UNREACHABLE_CODE,
        COMBINE_HIDPI_IMAGES, and ENABLE_STRICT_OBJC_MSGSEND as suggested by
        Xcode upgrade check.

        * WTF.xcodeproj/project.pbxproj: Updated LastUpgradeCheck.

2014-09-05  Geoffrey Garen  <ggaren@apple.com>

        bmalloc should honor the FastMalloc statistics API
        https://bugs.webkit.org/show_bug.cgi?id=136592

        Reviewed by Gavin Barraclough.

        * wtf/FastMalloc.cpp:
        (WTF::fastMallocStatistics):

2014-09-05  Geoffrey Garen  <ggaren@apple.com>

        bmalloc should honor the FastMalloc scavenging API
        https://bugs.webkit.org/show_bug.cgi?id=136588

        Reviewed by Andreas Kling.

        * wtf/FastMalloc.cpp:
        (WTF::releaseFastMallocFreeMemory):

2014-09-05  Geoffrey Garen  <ggaren@apple.com>

        Rolled out <http://trac.webkit.org/changeset/173313>.

        It seems to have broken the PLT bot.

                Do the bmalloc.
                https://bugs.webkit.org/show_bug.cgi?id=132629

                * wtf/FastMalloc.cpp:

2014-06-06  Jer Noble  <jer.noble@apple.com>

        Refactoring: make MediaTime the primary time type for audiovisual times.
        https://bugs.webkit.org/show_bug.cgi?id=133579

        Reviewed by Eric Carlson.

        Add a unary minus operator, and add unimplemented private casting operators, to make
        unintentional double->MediaTime and MediaTime->double casts hard errors.

        * wtf/MediaTime.cpp:
        (WTF::MediaTime::operator-):
        * wtf/MediaTime.h:

2014-09-04  Geoffrey Garen  <ggaren@apple.com>

        Do the bmalloc.
        https://bugs.webkit.org/show_bug.cgi?id=132629

        Reviewed by Michael Saboff.

        64-bit only for now, just to try it out.

        * wtf/FastMalloc.cpp:

2014-09-05  Dániel Bátyai  <dbatyai.u-szeged@partner.samsung.com>

        Enable GenGC on ARM Traditional
        https://bugs.webkit.org/show_bug.cgi?id=136567

        Reviewed by Csaba Osztrogonác.

        * wtf/Platform.h:

2014-09-04  Filip Pizlo  <fpizlo@apple.com>

        Beef up the DFG's CFG analyses to include iterated dominance frontiers and more user-friendly BlockSets
        https://bugs.webkit.org/show_bug.cgi?id=136520

        Fix bug found in Geoff's review but not landed in previous commit.

        * wtf/BitVector.cpp:
        (WTF::BitVector::equalsSlowCaseFast): return true.

2014-09-03  Filip Pizlo  <fpizlo@apple.com>

        Beef up the DFG's CFG analyses to include iterated dominance frontiers and more user-friendly BlockSets
        https://bugs.webkit.org/show_bug.cgi?id=136520

        Reviewed by Geoffrey Garen.
        
        Give BitVector a way to quickly find the next set (or unset) bit. Make BitVector equality
        faster. Fix a minor closure goof in Spectrum.

        * wtf/BitVector.cpp:
        (WTF::BitVector::equalsSlowCase):
        (WTF::BitVector::equalsSlowCaseFast):
        (WTF::BitVector::equalsSlowCaseSimple):
        * wtf/BitVector.h:
        (WTF::BitVector::findBit):
        (WTF::BitVector::findBitFast):
        (WTF::BitVector::findBitSimple):
        (WTF::BitVector::findBitInWord):
        * wtf/Spectrum.h:
        (WTF::Spectrum::removeIf):

2014-09-04  Anders Carlsson  <andersca@apple.com>

        Make hash table classes final
        https://bugs.webkit.org/show_bug.cgi?id=136540

        Reviewed by Antti Koivisto.

        We don't want anybody inheriting from these classes, so make them final.

        * wtf/HashCountedSet.h:
        * wtf/HashMap.h:
        * wtf/HashSet.h:

2014-09-04  Eva Balazsfalvi  <evab.u-szeged@partner.samsung.com>

        Remove CSS_FILTERS flag
        https://bugs.webkit.org/show_bug.cgi?id=136529

        Reviewed by Dirk Schulze.

        * wtf/FeatureDefines.h:

2014-09-04  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r173201.
        https://bugs.webkit.org/show_bug.cgi?id=136538

        Improves the situation but also introduces additional crashes.
        (Requested by zdobersek on #webkit).

        Reverted changeset:

        "GMainLoopSource is exposed to race conditions"
        https://bugs.webkit.org/show_bug.cgi?id=135800
        http://trac.webkit.org/changeset/173201

2014-09-04  Pratik Solanki  <psolanki@apple.com>

        Remove iOS specific disk image cache
        https://bugs.webkit.org/show_bug.cgi?id=136517

        Reviewed by Antti Koivisto.

        Disk image cache code unnecessarily complicates SharedBuffer implementation. We can remove
        this now since we don't enable it in WebKit2 on iOS.

        * wtf/FeatureDefines.h:

2014-09-03  Dan Bernstein  <mitz@apple.com>

        Get rid of HIGH_DPI_CANVAS leftovers
        https://bugs.webkit.org/show_bug.cgi?id=136491

        Reviewed by Benjamin Poulain.

        * wtf/FeatureDefines.h: Removed definition of ENABLE_HIGH_DPI_CANVAS.

2014-09-03  Zan Dobersek  <zdobersek@igalia.com>

        GMainLoopSource is exposed to race conditions
        https://bugs.webkit.org/show_bug.cgi?id=135800

        Reviewed by Carlos Garcia Campos.

        GMainLoopSource objects can be dispatching tasks on one thread
        while having a new task scheduled on a different thread. This
        can for instance occur in WebKitVideoSink, where the timeout
        callback can be called on main thread while at the same time
        it is being rescheduled on a different thread (created through
        GStreamer).

        The initial solution is to use GMutex to prevent parallel data
        access from different threads. In the future I plan to add better
        assertions, some meaningful comments and look at the possibility
        of creating thread-specific GMainLoopSource objects that wouldn't
        require the use of GMutex.

        GSource, GCancellable and std::function<> objects are now packed
        into an internal Context structure. Using the C++11 move semantics
        it's simple to, at the time of dispatch, move the current context
        out of the GMainLoopSource object in case the dispatch causes a
        rescheduling on that same object.

        All the schedule*() methods and the cancelInternal() method callers
        now lock the GMutex to ensure no one else is accessing the data at
        that moment. Similar goes for the dispatch methods, but those do
        the dispatch and possible destruction duties with the mutex unlocked.
        The dispatch can cause rescheduling on the same GMainLoopSource object,
        which must not be done with a locked mutex.

        * wtf/gobject/GMainLoopSource.cpp:
        (WTF::GMainLoopSource::GMainLoopSource):
        (WTF::GMainLoopSource::~GMainLoopSource):
        (WTF::GMainLoopSource::cancel):
        (WTF::GMainLoopSource::cancelInternal):
        (WTF::GMainLoopSource::scheduleIdleSource):
        (WTF::GMainLoopSource::schedule):
        (WTF::GMainLoopSource::scheduleTimeoutSource):
        (WTF::GMainLoopSource::scheduleAfterDelay):
        (WTF::GMainLoopSource::voidCallback):
        (WTF::GMainLoopSource::boolCallback):
        (WTF::GMainLoopSource::socketCallback):
        (WTF::GMainLoopSource::destroy):
        (WTF::GMainLoopSource::reset): Deleted.
        * wtf/gobject/GMainLoopSource.h:

2014-09-02  Daniel Bates  <dabates@apple.com>

        [iOS] Support using Foundation networking code
        https://bugs.webkit.org/show_bug.cgi?id=136467

        Reviewed by Pratik Solanki.

        Disable USE(CFNETWORK) and use the Foundation networking code by default when building
        iOS WebKit without the Apple Internal SDK.

        * wtf/Platform.h:

2014-08-26  Maciej Stachowiak  <mjs@apple.com>

        Use RetainPtr::autorelease in some places where it seems appropriate
        https://bugs.webkit.org/show_bug.cgi?id=136280

        Reviewed by Darin Adler.

        * wtf/text/mac/StringImplMac.mm:
        (WTF::StringImpl::operator NSString *): Use autorelease() instead of
        CFBridgingRelease(leakRef())

2014-08-29  Joseph Pecoraro  <pecoraro@apple.com>

        JavaScriptCore: Use ASCIILiteral where possible
        https://bugs.webkit.org/show_bug.cgi?id=136179

        Reviewed by Michael Saboff.

        * wtf/text/WTFString.cpp:
        (asciiDebug):

2014-08-27  Filip Pizlo  <fpizlo@apple.com>

        DFG should compute immediate dominators using the O(n log n) form of Lengauer and Tarjan's "A Fast Algorithm for Finding Dominators in a Flowgraph"
        https://bugs.webkit.org/show_bug.cgi?id=93361

        Reviewed by Mark Hahnenberg.
        
        Make BitVector operations return the previous value of the bit you're changing. This is
        useful for the kinds of set operations that are commonplace in compiler graph searches.

        * wtf/BitVector.h:
        (WTF::BitVector::quickSet):
        (WTF::BitVector::quickClear):
        (WTF::BitVector::set):
        (WTF::BitVector::ensureSizeAndSet):
        (WTF::BitVector::clear):

2014-08-27  Filip Pizlo  <fpizlo@apple.com>

        FTL should be able to do polymorphic call inlining
        https://bugs.webkit.org/show_bug.cgi?id=135145

        Reviewed by Geoffrey Garen.
        
        Add some power that I need for call edge profiling.

        * wtf/OwnPtr.h:
        (WTF::OwnPtr<T>::createTransactionally):
        * wtf/Spectrum.h:
        (WTF::Spectrum::add):
        (WTF::Spectrum::addAll):
        (WTF::Spectrum::get):
        (WTF::Spectrum::size):
        (WTF::Spectrum::KeyAndCount::KeyAndCount):
        (WTF::Spectrum::clear):
        (WTF::Spectrum::removeIf):

2014-08-27  Nico Weber  <thakis@chromium.org>

        Delete a MSVS2010 workaround.
        https://bugs.webkit.org/show_bug.cgi?id=136321

        Reviewed by Benjamin Poulain.

        Ports https://codereview.chromium.org/512923004/ by the talented
        Nico Weber from Blink. No intended behavior change.

        * wtf/Vector.h:
        (WTF::=):

2014-08-27  Mark Rowe  <mrowe@apple.com>

        JavaScriptCore is missing debug info for WTF because libWTF.a is stripped.
        <https://webkit.org/b/136320> / <rdar://problem/18148776>

        Reviewed by Dan Bernstein.

        * Configurations/WTF.xcconfig: Set STRIP_INSTALLED_PRODUCT = NO for the target
        that produces libWTF.a so that the debug symbols will be linked into JavaScriptCore
        and end up in its dSYM file.

2014-08-26  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r172940.
        https://bugs.webkit.org/show_bug.cgi?id=136256

        Caused assertions on fast/storage/serialized-script-
        value.html, and possibly flakiness on more tests (Requested by
        ap on #webkit).

        Reverted changeset:

        "FTL should be able to do polymorphic call inlining"
        https://bugs.webkit.org/show_bug.cgi?id=135145
        http://trac.webkit.org/changeset/172940

2014-08-23  Filip Pizlo  <fpizlo@apple.com>

        FTL should be able to do polymorphic call inlining
        https://bugs.webkit.org/show_bug.cgi?id=135145

        Reviewed by Geoffrey Garen.
        
        Add some power that I need for call edge profiling.

        * wtf/OwnPtr.h:
        (WTF::OwnPtr<T>::createTransactionally):
        * wtf/Spectrum.h:
        (WTF::Spectrum::add):
        (WTF::Spectrum::addAll):
        (WTF::Spectrum::get):
        (WTF::Spectrum::size):
        (WTF::Spectrum::KeyAndCount::KeyAndCount):
        (WTF::Spectrum::clear):
        (WTF::Spectrum::removeIf):

2014-08-25  Tomas Popela  <tpopela@redhat.com>

        Add support for little-endian PowerPC64
        https://bugs.webkit.org/show_bug.cgi?id=135647

        Reviewed by Oliver Hunt.

        * wtf/Platform.h:
        * wtf/dtoa/utils.h:

2014-08-24  Zan Dobersek  <zdobersek@igalia.com>

        GenericHashTraits::peek() is producing copies of passed-in temporary values
        https://bugs.webkit.org/show_bug.cgi?id=131461

        Reviewed by Darin Adler.

        * wtf/HashTraits.h:
        (WTF::GenericHashTraits::peek): Make this method a template that passes through
        the passed-in value without copying, achieved by using universal references and
        std::forward<>().

2014-08-22  Daniel Bates  <dabates@apple.com>

        [iOS] Disable ENABLE_IOS_{GESTURE, TOUCH}_EVENTS, and temporarily disable ENABLE_TOUCH_EVENTS
        and ENABLE_XSLT when building with the iOS public SDK
        https://bugs.webkit.org/show_bug.cgi?id=135945

        Reviewed by Andy Estes.

        * wtf/FeatureDefines.h:

2014-08-22  Akos Kiss  <akiss@inf.u-szeged.hu>

        Enable fixed executable allocator for any ARM64 target.
        https://bugs.webkit.org/show_bug.cgi?id=136162

        Reviewed by Michael Saboff.

        The ARM64 macro assembler relies on near calls being implemented by BL
        instructions, which have only 128MB offset range from PC. The
        on-demand executable allocator cannot ensure that any two locations in
        memory allocated for the JIT-compiled code are within this range. 
        However, the fixed executable allocator has a fixed 16MB memory pool for
        ARM64.

        * wtf/Platform.h:
        Define ENABLE_EXECUTABLE_ALLOCATOR_FIXED if CPU(ARM64), and update
        attached comment.

2014-08-22  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r172844.
        https://bugs.webkit.org/show_bug.cgi?id=136164

        re-applying WEBCORE_EXPORTS patch (Requested by
        alexchristensen on #webkit).

        Reverted changeset:

        "Revert r172831, it broke the Windows build."
        http://trac.webkit.org/changeset/172844

2014-08-22  Jon Lee  <jonlee@apple.com>

        Fix iOS build due to r172832 and move RUBBER_BANDING out of FeatureDefines.h
        https://bugs.webkit.org/show_bug.cgi?id=136157

        Reviewed by Simon Fraser.

        * wtf/FeatureDefines.h: Remove ENABLE(RUBBER_BANDING) logic for Mac platform.

2014-08-21  Tim Horton  <timothy_horton@apple.com>

        Revert r172831, it broke the Windows build.

        * wtf/ExportMacros.h:

2014-08-21  Zalan Bujtas  <zalan@apple.com>

        Enable SATURATED_LAYOUT_ARITHMETIC.
        https://bugs.webkit.org/show_bug.cgi?id=136106

        Reviewed by Simon Fraser.

        SATURATED_LAYOUT_ARITHMETIC protects LayoutUnit against arithmetic overflow.
        (No measurable performance regression on Mac.)

        * wtf/FeatureDefines.h:

2014-08-21  Alex Christensen  <achristensen@webkit.org>

        More WEBCORE_EXPORT macros.
        https://bugs.webkit.org/show_bug.cgi?id=136129

        Reviewed by Tim Horton.

        * wtf/ExportMacros.h:
        Removed WTF_TESTING which isn't used.

2014-08-20  Akos Kiss  <akiss@inf.u-szeged.hu>

        Enable ARM64 disassembler on EFL
        https://bugs.webkit.org/show_bug.cgi?id=136089

        Reviewed by Filip Pizlo.

        * wtf/Platform.h:
        Enable WTF_USE_ARM64_DISASSEMBLER for EFL as well.

2014-08-19  Pratik Solanki  <psolanki@apple.com>

        Remove PurgeableBuffer since it is not very useful any more
        https://bugs.webkit.org/show_bug.cgi?id=135939

        Reviewed by Andreas Kling.

        * wtf/Platform.h: Remove ENABLE_PURGEABLE_MEMORY define.
        * wtf/VMTags.h: Remove VM tags used by WebCore for cached resource purgeable memory.

2014-08-19  Magnus Granberg  <zorry@gentoo.org>

        TEXTREL in libjavascriptcoregtk-1.0.so.0.11.0 on x86 (or i586)
        https://bugs.webkit.org/show_bug.cgi?id=70610

        Reviewed by Darin Adler.

        Add PLT if we're building with PIC.

        * wtf/InlineASM.h:

2014-08-19  Zalan Bujtas  <zalan@apple.com>

        Remove ENABLE(SUBPIXEL_LAYOUT).
        https://bugs.webkit.org/show_bug.cgi?id=136077

        Reviewed by Simon Fraser.

        Remove compile time flag SUBPIXEL_LAYOUT. All ports have it enabled for a while now.

        * wtf/FeatureDefines.h:

2014-08-18  Maciej Stachowiak  <mjs@apple.com>

        Use NSURLFileTypeMappings directly instead of depending on WebKitSystemInterface wrappers for it
        https://bugs.webkit.org/show_bug.cgi?id=136035

        Reviewed by Dan Bernstein.

        * wtf/Platform.h: Define USE(APPLE_INTERNAL_SDK) by default on platforms that have it.

2014-08-18  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r172736.
        https://bugs.webkit.org/show_bug.cgi?id=136060

        Caused 14% PLT regressions (Requested by rniwa on #webkit).

        Reverted changeset:

        "Remove PurgeableBuffer since it is not very useful any more"
        https://bugs.webkit.org/show_bug.cgi?id=135939
        http://trac.webkit.org/changeset/172736

2014-08-18  Pratik Solanki  <psolanki@apple.com>

        Remove PurgeableBuffer since it is not very useful any more
        https://bugs.webkit.org/show_bug.cgi?id=135939

        Reviewed by Geoffrey Garen.

        * wtf/Platform.h: Remove ENABLE_PURGEABLE_MEMORY define.
        * wtf/VMTags.h: Remove VM tags used by WebCore for cached resource purgeable memory.

2014-08-14  Benjamin Poulain  <benjamin@webkit.org>

        CSS JIT: compile the :empty pseudo class
        https://bugs.webkit.org/show_bug.cgi?id=135958

        Reviewed by Andreas Kling.

        * wtf/text/StringImpl.h:
        (WTF::StringImpl::lengthMemoryOffset):

2014-08-12  Myles C. Maxfield  <mmaxfield@apple.com>

        Elements whose contents start with an astral Unicode symbol disappear when CSS `::first-letter` is applied to them
        https://bugs.webkit.org/show_bug.cgi?id=135756

        Reviewed by Darin Adler.

        Add a method to StringView which passes through contains() to find().

        * wtf/text/StringView.h:
        (WTF::StringView::contains):

2014-08-12  Pratik Solanki  <psolanki@apple.com>

        Enable didReceiveDataArray callback on Mac
        https://bugs.webkit.org/show_bug.cgi?id=135554
        <rdar://problem/9170731>

        Reviewed by Andreas Kling.

        Enable WTF_USE_NETWORK_CFDATA_ARRAY_CALLBACK for all Cocoa platforms so that we use the same
        code path for Mac and iOS.

        * wtf/Platform.h:

2014-08-12  Alex Christensen  <achristensen@webkit.org>

        Generate header detection headers for CMake on Windows.
        https://bugs.webkit.org/show_bug.cgi?id=135807

        Reviewed by Brent Fulgham.

        * wtf/CMakeLists.txt:
        * wtf/PlatformWin.cmake:
        Generate and include a stub WTFHeaderDetection.h.

2014-08-11  Andy Estes  <aestes@apple.com>

        [iOS] Get rid of iOS.xcconfig
        https://bugs.webkit.org/show_bug.cgi?id=135809

        Reviewed by Joseph Pecoraro.

        All iOS.xcconfig did was include AspenFamily.xcconfig, so there's no need for the indirection.

        * Configurations/Base.xcconfig:
        * Configurations/iOS.xcconfig: Removed.
        * WTF.xcodeproj/project.pbxproj:

2014-08-12  Zan Dobersek  <zdobersek@igalia.com>

        Clean up GMutexLocker
        https://bugs.webkit.org/show_bug.cgi?id=135833

        Reviewed by Carlos Garcia Campos.

        Place the GMutexLocker into the WTF namespace. There's no need for this
        class to use FastMalloc since it's always allocated on the stack. The
        constructor and class now operate on a GMutex reference. There's little
        need for an additional inline specifier for methods defined in the header.
        The mutex() method is removed as it was not used. m_val is renamed to a
        more descriptive m_locked and is made a boolean.

        * wtf/gobject/GMutexLocker.h:
        (WTF::GMutexLocker::GMutexLocker):
        (WTF::GMutexLocker::~GMutexLocker):
        (WTF::GMutexLocker::lock):
        (WTF::GMutexLocker::unlock):
        (WebCore::GMutexLocker::GMutexLocker): Deleted.
        (WebCore::GMutexLocker::~GMutexLocker): Deleted.
        (WebCore::GMutexLocker::lock): Deleted.
        (WebCore::GMutexLocker::unlock): Deleted.
        (WebCore::GMutexLocker::mutex): Deleted.

2014-08-12  Zan Dobersek  <zdobersek@igalia.com>

        Make GRefPtr move-able
        https://bugs.webkit.org/show_bug.cgi?id=135801

        Reviewed by Carlos Garcia Campos.

        Add move constructor and move assignment operator for GRefPtr.

        * wtf/gobject/GRefPtr.h:
        (WTF::GRefPtr::GRefPtr):
        (WTF::=):

2014-08-10  Benjamin Poulain  <benjamin@webkit.org>

        Update HashTable's operator= after r172167 per review comments

        * wtf/HashTable.h:
        Update the type as suggested by Darin.

2014-08-07  Benjamin Poulain  <bpoulain@apple.com>

        Get rid of SCRIPTED_SPEECH
        https://bugs.webkit.org/show_bug.cgi?id=135729

        Reviewed by Brent Fulgham.

        * wtf/FeatureDefines.h:

2014-08-07  Benjamin Poulain  <bpoulain@apple.com>

        Get rid of INPUT_SPEECH
        https://bugs.webkit.org/show_bug.cgi?id=135672

        Reviewed by Andreas Kling.

        * wtf/FeatureDefines.h:

2014-08-06  Dean Jackson  <dino@apple.com>

        ENABLE_CSS_TRANSFORMS_ANIMATIONS_UNPREFIXED is not used anywhere. Remove it.
        https://bugs.webkit.org/show_bug.cgi?id=135675

        Reviewed by Sam Weinig.

        * wtf/FeatureDefines.h:

2014-08-06  Benjamin Poulain  <benjamin@webkit.org>

        HashTable based classes leak a lot
        https://bugs.webkit.org/show_bug.cgi?id=135638

        Reviewed by Darin Adler.

        * wtf/HashTable.h:
        The operator= taking a rvalue reference was never freeing the memory allocated
        for the table of the left hand side object.

        This patch fixes the leaks by doing an alloc+swap with a new object.
